/* A Bison parser, made by GNU Bison 3.5.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2019 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Undocumented macros, especially those whose name start with YY_,
   are private implementation details.  Do not rely on them.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 30 "parser.yy"


#define yyerror Lily_parser::parser_error

/* We use custom location type: Input objects */
#define YYLTYPE Input
#define YYSTYPE SCM
#define YYLLOC_DEFAULT(Current,Rhs,N) \
	((Current).set_location ((Rhs)[1], (Rhs)[N]))

#define YYPRINT(file, type, value)					\
	do {								\
		if (scm_is_eq (value, SCM_UNSPECIFIED))			\
			break;						\
		SCM s = Display::value_to_lily_string (value);		\
		char *p = scm_to_locale_string (s);			\
		fputs (p, file);					\
		free (p);						\
	} while (0)

#line 103 "parser.yy"
 // -*-Fundamental-*-

/*
FIXME:

   * The rules for who is protecting what are very shady.  Uniformise
     this.

   * There are too many lexical modes?
*/

#include "config.hh"

#include <cctype>
#include <cstdlib>
#include <cstdio>
using namespace std;

#include "book.hh"
#include "context.hh"
#include "context-def.hh"
#include "context-mod.hh"
#include "dimensions.hh"
#include "file-path.hh"
#include "input.hh"
#include "international.hh"
#include "lily-guile.hh"
#include "lily-lexer.hh"
#include "lily-parser.hh"
#include "ly-module.hh"
#include "main.hh"
#include "misc.hh"
#include "music.hh"
#include "output-def.hh"
#include "paper-book.hh"
#include "scm-hash.hh"
#include "score.hh"
#include "text-interface.hh"
#include "warn.hh"
#include "lily-imports.hh"

void
Lily_parser::parser_error (Input const *i, Lily_parser *parser, SCM *, const string &s)
{
	parser->parser_error (*i, s);
}

// The following are somewhat precarious constructs as they may change
// the value of the lookahead token.  That implies that the lookahead
// token must not yet have made an impact on the state stack other
// than causing the reduction of the current rule, or switching the
// lookahead token while Bison is mulling it over will cause trouble.

#define MYBACKUP(Token, Value, Location)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		if (Token)						\
			parser->lexer_->push_extra_token		\
				(Location, Token, Value);		\
		parser->lexer_->push_extra_token (Location, BACKUP);	\
		yychar = YYEMPTY;					\
	} while (0)


#define MYREPARSE(Location, Pred, Token, Value)				\
	do {								\
		if (yychar != YYEMPTY)					\
			parser->lexer_->push_extra_token		\
				(yylloc, yychar, yylval);		\
		parser->lexer_->push_extra_token			\
			(Location, Token, Value);			\
		parser->lexer_->push_extra_token			\
			(Location, REPARSE, Pred);			\
		yychar = YYEMPTY;					\
	} while (0)

#line 184 "parser.yy"


#define MY_MAKE_MUSIC(x, spot) \
	make_music_with_input (ly_symbol2scm (x), \
			       parser->lexer_->override_input (spot))

/* ES TODO:
- delay application of the function
*/

#define LOWLEVEL_MAKE_SYNTAX(location, proc, ...)			\
	with_location							\
		(parser->lexer_->override_input (location).smobbed_copy (), \
		 proc,							\
		 ##__VA_ARGS__)

/* Syntactic Sugar. */
#define MAKE_SYNTAX(name, location, ...)				\
	LOWLEVEL_MAKE_SYNTAX (location, Syntax::name, ##__VA_ARGS__)

#define START_MAKE_SYNTAX(name, ...)					\
	scm_list_n (Syntax::name, ##__VA_ARGS__, SCM_UNDEFINED)

#define FINISH_MAKE_SYNTAX(start, location, ...)			\
	LOWLEVEL_MAKE_SYNTAX						\
		(location,						\
		 Guile_user::apply,					\
		 scm_car (start),					\
		 scm_append_x						\
		 (scm_list_2 (scm_cdr (start),				\
			      scm_list_n (__VA_ARGS__, SCM_UNDEFINED))))

SCM get_next_unique_context_id ();
SCM get_next_unique_lyrics_context_id ();

#undef _
#if !HAVE_GETTEXT
#define _(x) x
#else
#include <libintl.h>
#define _(x) gettext (x)
#endif


static Music *make_music_with_input (SCM name, Input where);
bool add_post_events (Music *music, SCM events);
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress);
SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp = SCM_UNDEFINED);
SCM make_music_from_simple (Lily_parser *parser, Input loc, SCM pitch);
SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg);
SCM make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list);
SCM make_chord_step (SCM step, Rational alter);
SCM make_simple_markup (SCM a);
SCM make_duration (SCM t, int dots = 0, SCM factor = SCM_UNDEFINED);
bool is_regular_identifier (SCM id, bool multiple=false);
SCM make_reverse_key_list (SCM keys);
SCM try_word_variants (SCM pred, SCM str);
SCM try_string_variants (SCM pred, SCM str);
int yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser);


#line 233 "./out/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Use api.header.include to #include this header
   instead of duplicating it here.  */
#ifndef YY_YY_OUT_PARSER_HH_INCLUDED
# define YY_YY_OUT_PARSER_HH_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    END_OF_FILE = 0,
    PREC_BOT = 258,
    REPEAT = 259,
    ALTERNATIVE = 260,
    COMPOSITE = 261,
    ADDLYRICS = 262,
    UNSIGNED = 263,
    REAL = 264,
    E_UNSIGNED = 265,
    EVENT_IDENTIFIER = 266,
    EVENT_FUNCTION = 267,
    HYPHEN = 268,
    EXTENDER = 269,
    DURATION_IDENTIFIER = 270,
    NUMBER_IDENTIFIER = 271,
    PREC_TOP = 272,
    ACCEPTS = 273,
    ALIAS = 274,
    BOOK = 275,
    BOOKPART = 276,
    CHANGE = 277,
    CHORDMODE = 278,
    CHORDS = 279,
    CONSISTS = 280,
    CONTEXT = 281,
    DEFAULT = 282,
    DEFAULTCHILD = 283,
    DENIES = 284,
    DESCRIPTION = 285,
    DRUMMODE = 286,
    DRUMS = 287,
    ETC = 288,
    FIGUREMODE = 289,
    FIGURES = 290,
    HEADER = 291,
    INVALID = 292,
    LAYOUT = 293,
    LYRICMODE = 294,
    LYRICS = 295,
    LYRICSTO = 296,
    MARKUP = 297,
    MARKUPLIST = 298,
    MIDI = 299,
    NAME = 300,
    NOTEMODE = 301,
    OVERRIDE = 302,
    PAPER = 303,
    REMOVE = 304,
    REST = 305,
    REVERT = 306,
    SCORE = 307,
    SCORELINES = 308,
    SEQUENTIAL = 309,
    SET = 310,
    SIMULTANEOUS = 311,
    TEMPO = 312,
    TYPE = 313,
    UNSET = 314,
    WITH = 315,
    NEWCONTEXT = 316,
    CHORD_BASS = 317,
    CHORD_CARET = 318,
    CHORD_COLON = 319,
    CHORD_MINUS = 320,
    CHORD_SLASH = 321,
    ANGLE_OPEN = 322,
    ANGLE_CLOSE = 323,
    DOUBLE_ANGLE_OPEN = 324,
    DOUBLE_ANGLE_CLOSE = 325,
    E_BACKSLASH = 326,
    E_EXCLAMATION = 327,
    E_PLUS = 328,
    FIGURE_CLOSE = 329,
    FIGURE_OPEN = 330,
    FIGURE_SPACE = 331,
    MULTI_MEASURE_REST = 332,
    EXPECT_MARKUP = 333,
    EXPECT_SCM = 334,
    BACKUP = 335,
    REPARSE = 336,
    EXPECT_MARKUP_LIST = 337,
    EXPECT_OPTIONAL = 338,
    EXPECT_NO_MORE_ARGS = 339,
    EMBEDDED_LILY = 340,
    BOOK_IDENTIFIER = 341,
    CHORD_MODIFIER = 342,
    CHORD_REPETITION = 343,
    DRUM_PITCH = 344,
    DURATION_ARG = 345,
    FRACTION = 346,
    LOOKUP_IDENTIFIER = 347,
    LYRIC_ELEMENT = 348,
    MARKUP_FUNCTION = 349,
    MARKUP_LIST_FUNCTION = 350,
    MARKUP_IDENTIFIER = 351,
    MARKUPLIST_IDENTIFIER = 352,
    MUSIC_FUNCTION = 353,
    MUSIC_IDENTIFIER = 354,
    NOTENAME_PITCH = 355,
    PITCH_IDENTIFIER = 356,
    RESTNAME = 357,
    SCM_ARG = 358,
    SCM_FUNCTION = 359,
    SCM_IDENTIFIER = 360,
    SCM_TOKEN = 361,
    STRING = 362,
    SYMBOL_LIST = 363,
    TONICNAME_PITCH = 364,
    SYMBOL = 365,
    UNARY_MINUS = 366
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef int YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif

/* Location type.  */
#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE YYLTYPE;
struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
};
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif



int yyparse (Lily_parser *parser, SCM *retval);

#endif /* !YY_YY_OUT_PARSER_HH_INCLUDED  */



#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))

/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
             && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE) \
             + YYSIZEOF (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  5
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   4273

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  129
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  199
/* YYNRULES -- Number of rules.  */
#define YYNRULES  598
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  886

#define YYUNDEFTOK  2
#define YYMAXUTOK   366


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    19,     2,     2,     2,     2,     2,   123,
       2,     2,   124,   116,   122,   115,   118,   126,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     8,     2,
       2,   121,     2,   128,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   127,     2,   125,    14,    15,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   119,     2,   120,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     9,    10,    11,    12,    13,    16,    17,
      18,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   117
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   392,   392,   393,   393,   401,   402,   404,   406,   409,
     416,   419,   423,   427,   434,   438,   442,   446,   450,   454,
     489,   505,   506,   514,   518,   522,   523,   524,   528,   529,
     533,   534,   535,   536,   537,   538,   539,   540,   541,   542,
     543,   549,   550,   551,   564,   565,   566,   570,   577,   581,
     582,   590,   597,   598,   599,   604,   616,   634,   638,   646,
     647,   650,   654,   663,   669,   669,   680,   684,   691,   695,
     700,   705,   720,   721,   722,   726,   730,   755,   756,   757,
     758,   759,   760,   761,   762,   763,   764,   765,   766,   767,
     768,   769,   779,   783,   787,   791,   795,   799,   803,   807,
     811,   818,   819,   829,   839,   849,   860,   870,   876,   885,
     898,   900,   900,   912,   915,   925,   936,   964,   976,   986,
     989,   993,   997,  1001,  1005,  1009,  1013,  1017,  1046,  1045,
    1049,  1058,  1066,  1071,  1074,  1077,  1081,  1085,  1089,  1093,
    1097,  1127,  1126,  1133,  1141,  1148,  1165,  1171,  1172,  1173,
    1178,  1181,  1241,  1240,  1263,  1276,  1286,  1292,  1297,  1306,
    1318,  1319,  1323,  1330,  1334,  1363,  1370,  1369,  1387,  1393,
    1396,  1399,  1408,  1411,  1415,  1425,  1431,  1432,  1433,  1437,
    1449,  1450,  1451,  1455,  1459,  1474,  1492,  1493,  1497,  1501,
    1508,  1511,  1517,  1520,  1528,  1529,  1530,  1535,  1534,  1542,
    1561,  1562,  1570,  1584,  1587,  1600,  1603,  1607,  1621,  1624,
    1630,  1633,  1655,  1656,  1657,  1658,  1661,  1668,  1669,  1670,
    1674,  1681,  1685,  1692,  1693,  1694,  1701,  1702,  1703,  1707,
    1708,  1765,  1766,  1770,  1777,  1778,  1782,  1791,  1792,  1804,
    1808,  1813,  1822,  1829,  1830,  1834,  1846,  1852,  1858,  1868,
    1872,  1882,  1886,  1890,  1894,  1898,  1902,  1910,  1923,  1940,
    1951,  1962,  1979,  1996,  2009,  2032,  2050,  2051,  2066,  2076,
    2092,  2108,  2117,  2144,  2155,  2165,  2184,  2195,  2205,  2219,
    2234,  2249,  2264,  2274,  2279,  2284,  2289,  2296,  2297,  2304,
    2305,  2324,  2328,  2332,  2336,  2343,  2347,  2351,  2355,  2362,
    2365,  2375,  2380,  2385,  2390,  2395,  2400,  2410,  2415,  2420,
    2425,  2432,  2450,  2461,  2472,  2490,  2508,  2522,  2545,  2557,
    2573,  2582,  2583,  2587,  2591,  2592,  2599,  2607,  2608,  2620,
    2620,  2627,  2631,  2642,  2653,  2658,  2664,  2669,  2676,  2683,
    2688,  2693,  2699,  2706,  2713,  2719,  2722,  2725,  2736,  2765,
    2772,  2784,  2785,  2789,  2793,  2800,  2801,  2803,  2804,  2805,
    2807,  2808,  2809,  2810,  2814,  2815,  2818,  2821,  2839,  2857,
    2865,  2880,  2912,  2930,  2939,  2942,  2951,  2962,  2963,  2964,
    2968,  2969,  2970,  2971,  2982,  2983,  2984,  2996,  2999,  3005,
    3021,  3022,  3023,  3024,  3032,  3036,  3037,  3041,  3048,  3055,
    3059,  3063,  3064,  3069,  3087,  3093,  3100,  3101,  3108,  3134,
    3144,  3160,  3164,  3165,  3166,  3170,  3177,  3180,  3201,  3204,
    3216,  3221,  3226,  3236,  3243,  3250,  3260,  3261,  3268,  3276,
    3277,  3280,  3285,  3289,  3292,  3313,  3314,  3319,  3322,  3323,
    3327,  3330,  3336,  3339,  3345,  3360,  3371,  3372,  3383,  3384,
    3388,  3393,  3399,  3406,  3414,  3422,  3425,  3428,  3431,  3434,
    3437,  3440,  3446,  3447,  3448,  3452,  3455,  3463,  3471,  3479,
    3485,  3491,  3494,  3501,  3504,  3511,  3522,  3525,  3537,  3538,
    3539,  3540,  3541,  3556,  3557,  3558,  3562,  3566,  3577,  3581,
    3592,  3600,  3603,  3606,  3609,  3615,  3618,  3625,  3628,  3634,
    3635,  3639,  3678,  3698,  3705,  3721,  3726,  3731,  3736,  3740,
    3750,  3756,  3763,  3766,  3772,  3775,  3778,  3781,  3787,  3790,
    3793,  3799,  3800,  3806,  3809,  3812,  3818,  3821,  3833,  3836,
    3839,  3843,  3846,  3849,  3855,  3858,  3862,  3863,  3864,  3871,
    3872,  3873,  3879,  3880,  3889,  3901,  3902,  3918,  3919,  3930,
    3929,  3938,  3954,  3963,  3967,  3974,  3982,  3985,  3990,  3997,
    3996,  4011,  4014,  4018,  4021,  4024,  4028,  4028,  4044,  4051,
    4057,  4058,  4061,  4067,  4073,  4076,  4079,  4082,  4088,  4089,
    4095,  4099,  4107,  4111,  4115,  4119,  4126,  4132,  4135,  4141,
    4142,  4146,  4150,  4154,  4154,  4167,  4170,  4177,  4182
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 1
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of input\"", "error", "$undefined", "PREC_BOT", "\"\\\\repeat\"",
  "\"\\\\alternative\"", "COMPOSITE", "\"\\\\addlyrics\"", "':'",
  "UNSIGNED", "REAL", "E_UNSIGNED", "EVENT_IDENTIFIER", "EVENT_FUNCTION",
  "'^'", "'_'", "\"--\"", "\"__\"", "DURATION_IDENTIFIER", "'!'",
  "NUMBER_IDENTIFIER", "PREC_TOP", "\"\\\\accepts\"", "\"\\\\alias\"",
  "\"\\\\book\"", "\"\\\\bookpart\"", "\"\\\\change\"",
  "\"\\\\chordmode\"", "\"\\\\chords\"", "\"\\\\consists\"",
  "\"\\\\context\"", "\"\\\\default\"", "\"\\\\defaultchild\"",
  "\"\\\\denies\"", "\"\\\\description\"", "\"\\\\drummode\"",
  "\"\\\\drums\"", "\"\\\\etc\"", "\"\\\\figuremode\"", "\"\\\\figures\"",
  "\"\\\\header\"", "\"\\\\version-error\"", "\"\\\\layout\"",
  "\"\\\\lyricmode\"", "\"\\\\lyrics\"", "\"\\\\lyricsto\"",
  "\"\\\\markup\"", "\"\\\\markuplist\"", "\"\\\\midi\"", "\"\\\\name\"",
  "\"\\\\notemode\"", "\"\\\\override\"", "\"\\\\paper\"",
  "\"\\\\remove\"", "\"\\\\rest\"", "\"\\\\revert\"", "\"\\\\score\"",
  "\"\\\\score-lines\"", "\"\\\\sequential\"", "\"\\\\set\"",
  "\"\\\\simultaneous\"", "\"\\\\tempo\"", "\"\\\\type\"", "\"\\\\unset\"",
  "\"\\\\with\"", "\"\\\\new\"", "\"/+\"", "\"^\"", "\":\"", "\"-\"",
  "\"/\"", "\"<\"", "\">\"", "\"<<\"", "\">>\"", "\"\\\\\\\\\"",
  "\"\\\\!\"", "\"\\\\+\"", "FIGURE_CLOSE", "FIGURE_OPEN", "\"_\"",
  "MULTI_MEASURE_REST", "\"markup?\"", "\"scheme?\"", "\"(backed-up?)\"",
  "\"(reparsed?)\"", "\"markup-list?\"", "\"optional?\"",
  "EXPECT_NO_MORE_ARGS", "\"#{\"", "BOOK_IDENTIFIER", "CHORD_MODIFIER",
  "CHORD_REPETITION", "DRUM_PITCH", "DURATION_ARG", "FRACTION",
  "LOOKUP_IDENTIFIER", "LYRIC_ELEMENT", "MARKUP_FUNCTION",
  "MARKUP_LIST_FUNCTION", "MARKUP_IDENTIFIER", "MARKUPLIST_IDENTIFIER",
  "MUSIC_FUNCTION", "MUSIC_IDENTIFIER", "NOTENAME_PITCH",
  "PITCH_IDENTIFIER", "RESTNAME", "SCM_ARG", "SCM_FUNCTION",
  "SCM_IDENTIFIER", "SCM_TOKEN", "STRING", "SYMBOL_LIST",
  "TONICNAME_PITCH", "SYMBOL", "'-'", "'+'", "UNARY_MINUS", "'.'", "'{'",
  "'}'", "'='", "','", "'\\''", "'*'", "']'", "'/'", "'['", "'?'",
  "$accept", "start_symbol", "$@1", "lilypond", "toplevel_expression",
  "lookup", "embedded_scm_bare", "embedded_scm_active",
  "embedded_scm_bare_arg", "embedded_scm", "embedded_scm_arg",
  "scm_function_call", "embedded_lilypond_number", "embedded_lilypond",
  "lilypond_header_body", "lilypond_header", "header_block", "$@2",
  "assignment_id", "assignment", "identifier_init",
  "identifier_init_nonumber", "partial_function_scriptable",
  "partial_function", "context_def_spec_block", "context_mod_arg", "$@3",
  "context_def_spec_body", "book_block", "book_body", "$@4",
  "bookpart_block", "bookpart_body", "$@5", "score_block", "score_body",
  "score_item", "score_items", "$@6", "paper_block", "output_def",
  "output_def_head", "output_def_head_with_mode_switch",
  "music_or_context_def", "output_def_body", "$@7", "tempo_event",
  "music_list", "braced_music_list", "music", "pitch_as_music",
  "music_embedded", "music_embedded_backup", "music_assign",
  "repeated_music", "sequential_music", "simultaneous_music",
  "simple_music", "context_modification", "$@8",
  "context_modification_arg", "optional_context_mods",
  "context_modification_mods_list", "context_mod_list", "context_prefix",
  "new_lyrics", "basic_music", "contextable_music",
  "contexted_basic_music", "composite_music", "music_bare",
  "grouped_music_list", "symbol_list_arg", "symbol_list_rev",
  "symbol_list_part", "symbol_list_element", "symbol_list_part_bare",
  "function_arglist_nonbackup", "reparsed_rhythm",
  "function_arglist_nonbackup_reparse", "function_arglist_backup",
  "function_arglist", "function_arglist_skip_nonbackup",
  "function_arglist_partial", "function_arglist_partial_optional",
  "function_arglist_common", "function_arglist_common_reparse",
  "function_arglist_optional", "function_arglist_skip_backup",
  "music_function_call", "optional_id", "lyric_mode_music", "$@9",
  "mode_changed_music", "mode_changing_head",
  "mode_changing_head_with_context", "context_change", "property_path",
  "property_operation", "revert_arg", "revert_arg_backup",
  "revert_arg_part", "context_def_mod", "context_mod", "grob_prop_spec",
  "grob_prop_path", "context_prop_spec", "simple_revert_context",
  "music_property_def", "string", "text", "simple_string", "symbol",
  "scalar", "event_chord", "note_chord_element", "chord_body",
  "chord_body_elements", "chord_body_element", "music_function_chord_body",
  "event_function_event", "post_events", "post_event_nofinger",
  "post_event", "string_number_event", "direction_less_event",
  "direction_reqd_event", "octave_check", "quotes", "sup_quotes",
  "sub_quotes", "steno_pitch", "steno_tonic_pitch", "pitch",
  "pitch_or_tonic_pitch", "gen_text_def", "fingering",
  "script_abbreviation", "script_dir", "maybe_notemode_duration",
  "optional_notemode_duration", "steno_duration", "multiplied_duration",
  "dots", "multipliers", "tremolo_type", "bass_number",
  "figured_bass_alteration", "bass_figure", "figured_bass_modification",
  "br_bass_figure", "figure_list", "optional_rest", "pitch_or_music",
  "simple_element", "lyric_element", "lyric_element_music", "new_chord",
  "chord_items", "chord_separator", "chord_item", "step_numbers",
  "step_number", "tempo_range", "number_expression", "number_term",
  "number_factor", "bare_number_common", "bare_number", "unsigned_number",
  "exclamations", "questions", "full_markup_list", "$@10", "markup_mode",
  "markup_mode_word", "full_markup", "partial_markup", "markup_top",
  "markup_scm", "$@11", "markup_list", "markup_uncomposed_list", "$@12",
  "markup_composed_list", "markup_braced_list", "markup_braced_list_body",
  "markup_command_list", "markup_command_basic_arguments",
  "markup_command_list_arguments", "markup_partial_function",
  "markup_arglist_partial", "markup_head_1_item", "markup_head_1_list",
  "markup_word", "simple_markup", "simple_markup_noword", "$@13", "markup", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_int16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,    58,   263,
     264,   265,   266,   267,    94,    95,   268,   269,   270,    33,
     271,   272,   273,   274,   275,   276,   277,   278,   279,   280,
     281,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   292,   293,   294,   295,   296,   297,   298,   299,   300,
     301,   302,   303,   304,   305,   306,   307,   308,   309,   310,
     311,   312,   313,   314,   315,   316,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,   327,   328,   329,   330,
     331,   332,   333,   334,   335,   336,   337,   338,   339,   340,
     341,   342,   343,   344,   345,   346,   347,   348,   349,   350,
     351,   352,   353,   354,   355,   356,   357,   358,   359,   360,
     361,   362,   363,   364,   365,    45,    43,   366,    46,   123,
     125,    61,    44,    39,    42,    93,    47,    91,    63
};
# endif

#define YYPACT_NINF (-644)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-585)

#define yytable_value_is_error(Yyn) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
      30,  -644,   136,  1721,  1301,  -644,  -644,   420,    24,    86,
    -644,  -644,   864,  -644,  -644,  -644,  -644,  -644,  -644,  -644,
    -644,   937,  -644,  -644,  -644,  -644,  -644,   117,   130,   130,
     864,  -644,  -644,   151,   389,  -644,   389,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,   148,   325,  -644,
    -644,  -644,  -644,  -644,  -644,   135,  1624,  -644,  -644,  -644,
    -644,  3934,   250,  -644,  -644,  -644,  -644,  -644,  -644,   187,
    -644,  -644,  1393,   179,  -644,  -644,   299,   296,   320,  -644,
    -644,   478,   347,   347,  -644,  -644,  -644,  -644,   864,   712,
    1301,   181,   181,   181,   909,   181,   476,  -644,  -644,    96,
      96,    96,  -644,  -644,   505,   226,   226,    96,   518,  -644,
    -644,   373,   226,   376,   108,  -644,  -644,   390,  -644,  -644,
    -644,  -644,  -644,  -644,   321,  -644,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  3590,   301,   396,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,    96,  -644,  -644,   398,  -644,  -644,
    -644,    96,  -644,  1174,  -644,  -644,  -644,   425,  -644,    96,
    -644,  -644,  -644,  -644,  1510,  -644,   440,  -644,  -644,  -644,
    -644,   406,   310,   316,  -644,  -644,  -644,   317,   327,   334,
     338,   359,   363,  1016,  -644,  -644,  -644,   317,  1922,   181,
     598,   403,  -644,  -644,   408,  -644,  -644,   427,  -644,  1417,
     369,  -644,   181,  3154,   181,  -644,  -644,  -644,  -644,  -644,
    -644,  3852,    42,   179,  -644,  -644,   250,  -644,  -644,  -644,
    -644,   484,  -644,   187,   464,  -644,  -644,   463,   532,  -644,
    -644,  -644,  -644,  -644,   269,  -644,  -644,  -644,  -644,  -644,
    -644,  1393,  -644,  -644,  3154,  -644,  -644,   423,  -644,   717,
     460,  -644,  -644,  -644,  -644,  -644,   423,   434,  -644,  -644,
    -644,  -644,  -644,  -644,   -24,  -644,  -644,  -644,   181,   441,
    -644,   181,   -24,   448,  -644,  -644,  -644,  -644,    96,   454,
    -644,  -644,  -644,  -644,   458,  -644,  1788,   782,  -644,  -644,
    -644,  -644,  -644,   717,   499,  -644,  -644,  -644,  -644,   436,
     461,  -644,  -644,   717,   514,  -644,  -644,   296,  -644,  -644,
    -644,   389,   181,   181,  -644,  -644,   347,  -644,  -644,  -644,
    -644,  4056,  -644,  -644,   305,  -644,    34,  1018,   580,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  1510,  -644,   487,   900,   945,
    -644,   945,   586,   576,  1600,  -644,  -644,  -644,  3770,  -644,
    1809,  -644,  1103,   420,  -644,  -644,  -644,   187,   420,   537,
     529,  -644,  1016,    75,  3680,  -644,  -644,  -644,  -644,   -24,
     548,    90,  -644,  3042,   551,   760,   985,  1060,  -644,  -644,
     -24,   517,    43,    69,    97,   139,  -644,  -644,  -644,  -644,
     141,  -644,  -644,   266,  -644,   189,  -644,  -644,  -644,   522,
    -644,  -644,  -644,   484,   359,  -644,  -644,  -644,   525,   527,
     532,   532,   532,  -644,  -644,   532,  -644,  -644,  1140,   567,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,   717,
     569,  -644,  2482,   776,   420,  4081,   181,   181,  -644,  3262,
    -644,  -644,   575,  -644,  3370,   546,   406,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,   757,  -644,  -644,   861,  -644,  -644,
     945,   945,  2482,   776,  -644,  -644,  2482,   776,   552,   554,
    1534,   945,  -644,   945,   540,  -644,  -644,   540,  -644,  -644,
     -22,  -644,    74,  -644,   945,   663,   663,  -644,  -644,   586,
     675,  -644,  -644,  -644,  -644,   148,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,   148,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,   359,  -644,  -644,  -644,
    -644,   148,  -644,  -644,  -644,   837,   989,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,   194,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,   605,  2594,   661,  -644,
    -644,   146,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,   925,  3154,  -644,   680,   131,
    -644,   181,   181,   945,   131,   131,   131,   131,  3154,  -644,
     359,  -644,  -644,  -644,   400,  1016,   874,  -644,  -644,  1393,
    -644,  -644,  -644,  -644,  2706,   859,  -644,   717,   624,  2146,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,   181,
    -644,   181,  -644,   864,  -644,   338,  -644,  -644,  4016,  -644,
    -644,  1107,  -644,   588,  -644,  -644,    46,  -644,  -644,  -644,
     139,  -644,  -644,   175,  -644,  -644,   237,  -644,  -644,    64,
    -644,  -644,   406,  -644,   599,  4153,   945,   580,   861,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,
    2146,  -644,  2146,  3478,  3478,  -644,  -644,   749,   226,  -644,
      96,  -644,  -644,   663,   687,  -644,   400,  -644,  -644,   130,
    -644,  -644,  -644,  -644,   646,  2258,   694,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,   760,  -644,  -644,  -644,  -644,
    -644,   232,  -644,  -644,  -644,  -644,  -644,  -644,  -644,   423,
     181,   181,  -644,  -644,  -644,  -644,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,    78,    87,  -644,  -644,  -644,
     632,   874,  -644,  -644,   650,  2034,  -644,  2818,   776,  -644,
     617,  -644,  -644,  -644,  -644,  -644,  -644,  3478,   717,   656,
    -644,   181,   181,   143,   259,   643,   830,  -644,  -644,   406,
    -644,  -644,  -644,   -22,  -644,  -644,   139,    11,  -644,  -644,
    -644,   630,  -644,  -644,   688,   874,  -644,   837,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,   358,  -644,  -644,  -644,  -644,
    -644,  -644,  -644,  -644,  -644,  -644,   487,   -24,   -24,  -644,
    -644,   859,  2370,  3478,  -644,   966,   923,  -644,  -644,   717,
     670,   717,   672,   385,   659,   181,   181,  -644,  -644,  -644,
    -644,  -644,   754,  -644,  -644,  -644,  -644,  -644,  -644,   945,
    -644,   181,   181,  -644,   684,   966,   966,   923,   966,   923,
     663,   385,  -644,  -644,   945,  -644,   945,   652,   655,   923,
     966,   966,  -644,   966,   966,  2930
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_int16 yydefact[] =
{
       5,     3,     0,     0,     0,     1,     8,     0,     0,     0,
     337,   341,     0,   335,   339,   336,   340,     9,   158,   338,
     342,     0,   551,   549,   157,   334,   156,     0,     0,     0,
       0,   172,    13,    21,     0,   227,     0,    25,    18,    66,
      67,   172,     6,    27,    19,    26,    10,     0,     0,     7,
      11,    12,    14,    20,   159,     0,     0,   191,   213,   230,
     229,     0,   223,   224,    15,   214,   228,   212,   226,     0,
     203,    17,     0,   554,    16,    57,   476,   471,   536,   428,
     430,     0,   463,   462,   420,   421,   471,   537,     0,     0,
       0,     0,     0,     0,     0,     0,   197,   406,   497,   465,
     465,   465,    85,   508,     0,   437,   437,   465,     0,    24,
      23,   507,   437,   506,   464,    43,    41,   185,    42,    53,
       4,    77,    52,   101,     0,    82,    79,    80,    78,    81,
     401,   180,   178,     0,   182,   176,   186,    90,   187,   196,
     195,    86,   194,   402,   465,   432,   426,   181,   429,   418,
     446,   465,   545,   108,   473,   416,   431,   179,   416,   465,
     177,   416,    49,    89,     0,   554,   505,    88,   384,   385,
     386,     0,   118,   132,   387,   388,   389,   327,   384,   385,
     386,   329,     0,     0,   150,   190,   192,   327,     0,     0,
       0,     0,   299,   287,     0,   326,   243,     0,    47,     0,
       0,    65,     0,    64,     0,   162,   168,   165,   155,   164,
     163,     0,     0,     0,   218,   217,   221,   222,   219,   179,
     203,   225,   332,     0,   202,   593,   566,     0,     0,   589,
     590,   570,   559,   553,     0,   556,   562,   561,   563,   564,
     587,     0,   552,   558,    64,   477,    50,   468,   538,     0,
       0,   415,    93,   454,   424,   425,   469,     0,   113,    58,
     240,   239,   241,   238,   368,   234,   242,   237,   369,     0,
     372,     0,   371,     0,   471,   380,   381,   383,   171,     0,
     382,   376,   201,   200,     0,   199,     0,     0,   467,   416,
     466,   416,   503,     0,     0,    92,   442,   440,   444,   439,
     438,   447,   504,     0,     0,    94,   445,   454,    48,   427,
      91,     0,     0,     0,   507,   506,   464,   185,   172,   176,
     181,     0,   416,   505,     0,   416,   510,     0,   547,   455,
     461,   458,   459,   451,   452,   457,   456,   460,   453,   107,
     419,   423,   422,   433,   434,     0,   450,   470,   184,   398,
     416,   502,     0,     0,     0,   542,   543,   544,     0,   119,
       0,   133,     0,     0,   203,   331,   215,     0,     0,     0,
       0,   550,     0,     0,   145,   203,   174,   193,   173,    22,
       0,   321,   266,    64,     0,     0,     0,     0,   175,    59,
     344,     0,   540,   377,   378,   464,    87,    68,    72,    83,
       0,   416,    84,    73,   530,   531,   539,   535,   379,     0,
     161,   167,   160,   220,   329,   203,   333,   204,     0,     0,
       0,     0,     0,   577,   595,     0,   578,   573,     0,     0,
     596,   565,   568,   588,   591,   557,   592,    71,   472,     0,
       0,   292,    64,     0,     0,   111,     0,     0,   370,    64,
     351,   374,     0,   350,    64,     0,     0,   205,   404,   416,
     413,   414,   412,   407,   410,   411,   449,   448,   545,   478,
     405,   486,   479,   480,     0,   482,   487,   495,   498,   481,
     400,   399,    64,     0,   441,   443,    64,     0,     0,     0,
       0,   184,   183,   403,     0,   515,   514,     0,   512,   546,
     435,   106,     0,   417,   509,     0,     0,   580,   555,     0,
     188,   130,   126,   117,   127,     0,   121,   122,   120,   154,
     123,   125,   124,   143,   139,   131,   140,     0,   135,   134,
     136,   138,   137,   328,   208,   330,   329,   146,   144,   147,
     151,     0,   149,   148,   209,     0,     0,   317,   318,    30,
      28,   311,    29,   314,   315,   464,    40,    44,   300,    45,
      34,    36,    37,    38,    35,    39,    46,    33,   302,   313,
     312,   301,    32,   316,    31,   323,     0,    64,     0,   471,
     254,   231,   256,   252,   251,   250,   255,   253,   304,   310,
     309,   308,   306,   305,   307,     0,    64,   541,   540,     0,
     534,     0,     0,    76,     0,     0,     0,     0,    64,   210,
     329,   150,   150,   586,     0,     0,     0,   569,   572,     0,
     598,   571,   560,   296,    64,     0,    96,     0,     0,    64,
     294,   343,   357,   360,   355,   358,   359,   362,   363,     0,
     356,     0,   361,     0,   109,    41,   110,   116,     0,   115,
     364,     0,   114,     0,   235,   236,     0,   463,   462,   392,
     464,   390,   104,     0,   395,   373,   108,   391,   393,     0,
     105,   375,     0,   169,   526,   111,   409,   547,   496,   485,
     494,   492,   491,   483,   484,   488,   493,   489,   490,    95,
      64,    97,    64,    64,    64,   517,   516,   511,   437,   548,
     465,   474,   475,     0,   586,   582,   585,   583,   581,     0,
     129,   142,   216,   153,     0,   324,   325,   286,   285,   284,
     282,   283,   319,   320,   303,     0,   264,   265,   258,   261,
     262,   464,   248,   244,   260,   259,   249,   263,   288,   473,
       0,     0,    61,    63,    62,    60,    69,    74,    75,   529,
     528,   532,   533,    70,   211,     0,     0,   576,   575,   574,
       0,     0,   579,   597,     0,   324,   298,    64,     0,    99,
       0,   348,   346,   112,   365,   366,   367,    64,     0,     0,
     394,     0,     0,     0,     0,     0,     0,   349,   170,     0,
     198,   207,   206,   435,    98,   100,     0,   523,   520,   518,
     513,   519,   521,   436,   499,   584,   189,     0,   272,   273,
     278,   274,   279,   280,   281,   464,   267,   268,   270,   269,
     271,   322,   290,   245,   246,   247,   416,   232,   233,   594,
     567,     0,    64,    64,   345,   291,     0,   396,   397,     0,
       0,     0,     0,     0,     0,     0,     0,   354,   527,   416,
     525,   524,     0,   500,   416,   325,   275,   276,   277,   257,
     347,     0,     0,   464,     0,   293,   291,     0,   291,     0,
       0,     0,   352,   353,   408,   522,   501,     0,     0,     0,
     293,   293,   585,   102,   103,    64
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -644,  -644,  -644,  -644,  -644,     3,   210,   -53,  -644,    68,
    -368,    12,   664,   697,  -644,  -420,    26,  -644,  -644,   -32,
    -159,    93,  -122,   360,    32,   113,  -644,  -644,    52,  -644,
    -644,   176,  -644,  -644,   120,  -106,  -644,  -644,  -644,   428,
      70,  -644,  -644,  -644,  -644,  -644,  -644,    -1,   -19,  -262,
     731,    80,  -644,   666,  -644,  -644,  -644,  -644,   163,  -644,
    -644,  -183,  -644,  -644,  -644,   578,   736,  -644,   740,    15,
    -644,   -26,  -335,   -79,   -85,  -644,  -175,   196,  -323,  -644,
    -488,    39,  -643,   -62,  -400,   -87,  -644,   -31,  -487,  -109,
     619,  -352,  -644,  -644,  -644,  -644,  -644,  -178,  -644,  -311,
    -644,  -644,  -644,   132,  -644,  -291,   -93,  -644,  -644,  -276,
    -644,    88,   -10,  -341,   752,  -644,  -644,  -644,  -644,  -644,
    -644,  -123,  -155,    49,  -644,   -83,  -644,    31,   -89,  -644,
    -644,  -644,   437,   413,  -644,  -644,   438,  -644,    21,  -124,
    1083,   -27,   204,   -52,    94,  -644,  -644,  -644,   351,  -644,
    -644,  -644,  -644,    41,  -644,  -644,  -232,  -644,  -644,   137,
    -644,  -644,   -25,   160,  -644,    20,  -318,    18,  -383,  -166,
     370,   184,   190,  -644,   642,     5,    -3,   185,  -644,   -90,
    -644,  -142,  -209,  -644,  -644,  -644,  -644,  -644,  -180,  -371,
     706,    62,  -228,   -68,   -12,  -208,    -7,  -644,   424
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     4,     3,    42,   115,   116,    44,   557,   232,
     558,   118,   119,   120,   595,   201,   560,    47,    48,    49,
     397,   398,   123,   124,   561,   647,   648,   445,   562,   360,
     515,   563,   362,   527,   564,   373,   540,   374,   541,   518,
     565,    54,    55,   411,    56,   211,   130,   188,    57,   131,
     132,   378,   134,   566,    58,    59,    60,   136,   567,   284,
     285,   223,   224,   675,    61,   221,    62,   216,    63,   138,
      65,    66,   582,   390,   265,   266,   267,   193,   583,   194,
     381,   195,   578,   630,   441,   196,   197,   383,   384,    67,
     364,   366,   367,    68,    69,    70,   139,   391,   650,   451,
     452,   453,   651,   652,   268,   269,   273,   271,   140,   141,
     278,   171,   177,   665,   142,   143,   144,   286,   463,   464,
     145,   348,   146,   503,   148,   149,   342,   700,   298,   299,
     300,   150,   151,   152,   468,   343,   309,   344,   321,   288,
     289,   154,   290,   247,   347,   156,   476,   687,   477,   688,
     478,   287,   854,   219,   158,   159,   160,   161,   697,   498,
     800,   801,   802,   673,   403,   404,   405,   406,   407,   674,
     328,   500,   572,   183,   164,   165,   408,   574,   233,   234,
     429,   235,   236,   419,   237,   238,   428,   239,   426,   427,
     501,   507,   240,   354,   434,   620,   436,   418,   762
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      74,   166,   281,   209,   241,   358,    43,   270,    73,   185,
     186,   182,   264,   433,   272,    45,   272,   301,    64,   252,
     187,   488,   162,   306,   210,   153,   409,   326,   400,    46,
     121,   339,   432,   435,   256,   349,   125,   414,   351,   623,
     199,   371,   295,   222,   340,   157,   305,   424,   401,   613,
     614,   615,   589,   147,   616,    50,   126,   715,   716,    43,
     242,   213,   609,   597,   590,   243,   668,   279,    45,   400,
     341,   668,   117,    53,   129,   198,   537,   600,   257,   537,
     850,   661,   822,   701,   133,   437,   661,   166,   537,   401,
     448,   280,   492,   370,   446,   710,   510,   122,   447,   698,
    -467,  -467,  -467,   382,  -467,   274,   699,   711,   162,   181,
     379,   153,   543,   671,    86,   372,   121,   307,    78,     1,
     251,   713,   125,    52,   128,   822,   433,   851,    87,   778,
     323,   157,   162,   779,   704,   706,     5,   765,   716,   147,
     598,    78,   126,   172,   433,   432,   435,   198,   598,    78,
     346,    87,   242,   229,   586,   593,   230,   243,   117,    87,
     129,  -240,   382,   432,   283,  -240,   480,   137,   481,   702,
     133,   786,   424,   664,  -324,   546,   581,   462,   664,    51,
     127,   534,   320,   122,   712,   323,   450,  -239,   200,   167,
     260,  -239,   544,    71,   163,   538,   323,   416,   829,   491,
     242,   317,   493,   722,   723,   173,   382,   830,   155,   732,
     128,   717,   340,   318,   724,  -241,   382,   170,   442,  -241,
     489,   338,   176,   718,   153,   766,   839,   504,   568,   121,
     840,   180,   610,   264,   272,   125,   184,   320,   341,   357,
     176,   823,   824,   410,   402,    28,   599,    29,   320,    41,
     656,   455,   825,   137,   205,   126,   317,   220,   754,   601,
      31,   732,   482,   602,   740,   153,   127,   317,   741,   189,
     121,   396,   486,   129,   663,   167,   125,   780,   603,   663,
     163,   600,   370,    22,   479,   402,   618,   568,   751,   752,
     109,   110,   261,   781,   155,   262,   126,   782,   176,   176,
     244,   263,   263,   263,   277,   263,    41,   514,   245,   526,
     668,   668,   396,   606,   129,   607,   246,   490,   346,   715,
     855,   323,   732,   128,   732,   661,   661,   568,   770,   424,
     771,   568,   805,   242,   787,   465,   676,   322,   243,   783,
     248,   535,   841,   765,   855,   784,   842,   816,   296,   297,
     251,    22,   382,   671,   461,   323,   253,   522,   310,   532,
     619,   654,   655,    43,   128,    43,   137,   856,   857,   430,
     431,   323,    45,  -377,    45,   520,  -378,   530,   858,   127,
     573,   604,   605,   323,   323,   324,   556,   417,   167,   338,
     -87,   433,   322,   163,   668,   559,   -83,   816,   -54,   263,
     359,   571,   103,   322,   587,   594,   361,   137,   624,   661,
     432,   763,   263,   780,   263,   355,   314,   664,   664,   315,
     127,   400,   733,   747,   748,   -84,   356,   585,   592,   167,
     519,   766,   519,   400,   163,   653,   834,   746,   363,   573,
    -379,   401,   539,   202,   542,   556,   203,   204,  -387,   753,
     668,   533,   556,   401,   559,  -388,   536,   556,   382,  -389,
     571,   559,   365,   153,   732,   661,   559,   505,   870,   568,
     666,   479,   190,   759,   733,   666,   191,   192,   263,   573,
     517,   263,   528,   573,   368,   556,   385,   323,   389,   556,
     667,   415,   860,   386,   559,   667,    33,   475,   559,   882,
     571,   664,    33,   153,   571,   755,   756,   153,    36,   109,
     110,   757,   387,   646,    36,   109,   110,   732,   663,   663,
     254,   255,   263,   263,   357,   370,   760,   739,    96,   109,
     110,   168,   631,   433,   169,   733,   516,   733,   382,   320,
     382,   438,   744,   443,   339,   420,   421,   372,   761,   422,
     521,   423,   531,   763,   450,   444,   450,   664,   317,   484,
     817,   249,   449,   745,   721,   250,   192,   705,   707,   454,
     877,   708,    33,   170,   737,   456,   804,   457,   170,   282,
     556,   577,   483,   485,    36,   109,   110,   720,   293,   559,
     584,   591,   294,   192,   252,   736,   767,   487,    43,   499,
     213,   303,   663,   837,   838,   304,   192,    45,   649,   803,
     817,   502,   568,   508,   425,   421,   433,   153,   422,   420,
     423,   573,   121,   848,   749,   750,   737,   556,   125,   153,
     431,   545,   556,   772,   121,   575,   559,   402,   596,   629,
     125,   559,   571,   608,   611,    72,   612,   736,   126,   402,
     153,   622,   625,   112,   170,   645,   263,   263,   663,   669,
     126,   827,   828,   773,   396,   653,   129,   672,   505,   506,
     135,   760,   422,   693,   423,   694,   396,   733,   129,   690,
     709,   190,   758,   692,   475,   380,   192,   737,   725,   737,
     806,   382,   738,   556,   322,   556,   556,   556,   212,   467,
     597,   847,   559,   859,   559,   559,   559,   768,   736,   777,
     736,   153,   820,   153,   789,   760,   128,   844,   556,   776,
     382,   295,   305,   466,  -584,   821,   874,   559,   128,   807,
     733,   876,   430,   831,   667,   667,    72,   761,   833,   836,
     357,   843,   853,   646,   382,   703,   506,   835,   852,   422,
     719,   423,   382,   867,   382,   869,   135,   871,   797,   137,
     872,   873,   820,   797,   573,   705,   469,   879,   556,   878,
     556,   137,   127,   883,   758,    72,   884,   559,   308,   559,
     556,   167,   264,   272,   127,   571,   163,   259,   791,   559,
     529,   469,   214,   167,   413,   345,   570,   215,   163,   319,
     439,   217,   626,    22,   440,   192,   375,   792,   866,   662,
     868,   263,   263,   218,   670,   494,   495,   496,   667,   497,
     569,   109,   110,   174,   849,   678,   175,   875,    22,   737,
      72,   258,   788,   826,   799,   556,   556,   471,   677,   260,
     798,    72,   689,   190,   559,   559,   691,   576,   192,   263,
     736,   263,   621,   176,   319,   570,   666,   357,     0,   627,
     470,   793,   471,   628,   192,   319,   109,   110,   472,   399,
     353,   473,     0,     0,   667,     0,     0,   412,     0,   569,
     679,     0,   737,     0,     0,   645,   666,   666,   556,   666,
       0,   109,   110,   472,     0,   570,   473,   559,     0,   570,
     -55,   666,   666,   736,   666,   666,     0,     0,    76,   474,
     399,    79,    80,   311,    82,    83,    84,    85,   274,   569,
     190,   577,     0,   569,   714,   192,     0,    86,     0,    72,
     225,   695,   707,   708,   696,     0,   680,   681,   682,   109,
     110,   261,   439,     0,   262,     0,   764,   192,   845,     0,
     263,   263,   846,    76,     0,    22,    79,    80,   311,    82,
      83,    84,    85,    72,   832,     0,    72,     0,     0,     0,
      33,    22,   227,   109,   110,   174,   683,   684,   175,   656,
     657,   658,    36,   109,   110,   229,   685,   686,   230,   769,
     735,   263,   263,     0,   274,    78,   263,     0,   274,    78,
      72,     0,    72,    86,    72,    87,   627,    86,     0,    87,
     864,   192,     0,     0,   734,   316,    72,   861,   109,   110,
     275,    33,     0,   276,   319,   862,     0,     0,    72,    72,
       0,    22,   865,    36,    37,   742,    39,   570,     0,    40,
     319,     0,   735,     0,     0,   743,   109,   110,   178,     0,
     794,   179,   795,     0,     0,   263,   263,     0,     0,     0,
     316,   569,     0,   880,     0,   881,   734,     0,   783,   274,
      78,   263,   263,   226,   784,   885,     0,     0,    86,   579,
      87,   863,   103,   579,   494,   495,   496,     0,   497,   105,
     106,     0,   580,   105,   106,     0,   314,   581,   112,   315,
       0,   581,   112,   735,   523,   735,    22,     7,     0,     0,
       0,     0,    33,     0,   369,   228,    72,     0,     0,     0,
       0,     0,     0,     0,    36,   109,   110,   734,   819,   734,
      10,    11,    72,    12,     0,   231,     0,     0,    13,    14,
       0,    15,    16,  -141,     0,    18,    19,    20,    21,    22,
      23,    24,   818,    25,   579,    26,   319,   103,     0,    27,
       0,    28,     0,    29,   105,   106,     0,   588,    30,     0,
       0,   314,   581,   112,   315,     0,    31,     0,   819,     0,
     570,     0,    76,   291,   292,    79,    80,    81,   329,   330,
     302,     0,     0,   331,     0,   626,   225,   226,     0,    33,
       0,     0,   818,    33,   569,    34,    35,     0,     0,     0,
       0,    36,    37,   524,     0,    36,   109,   110,   774,     0,
      22,   775,    41,   525,     0,   769,   689,   325,   691,     0,
       0,     0,     0,     0,   327,     0,    33,   212,   227,   228,
     794,   795,   350,   662,   670,   735,   332,     0,    36,   109,
     110,   229,     0,     0,   230,     0,     0,     0,     0,   231,
     617,     0,   399,     0,     0,     0,     0,     0,     0,   734,
      33,     0,     0,     0,   399,     0,   104,     0,     0,     0,
       0,     0,   108,   109,   110,   333,     0,     0,   334,   335,
     336,     0,   337,     0,     0,     0,     0,     0,   735,     0,
       0,   -51,    75,     0,     0,     7,     0,     0,   785,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
       0,    87,   734,     0,     0,     8,     9,    88,    10,    11,
       0,    89,     0,     0,     0,     0,    13,    14,     0,    15,
      16,   -64,    90,    18,    19,    20,    21,    22,    23,    24,
       0,    25,    91,    26,     0,     0,    92,    27,     0,    28,
      93,    29,    94,     0,    95,    96,    30,     0,     0,     0,
       0,     0,    97,     0,    31,     0,     0,     0,     0,     0,
      98,     0,    99,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   100,   101,     0,   102,    33,   103,     0,
       0,     0,     0,   104,    35,   105,   106,   107,     0,   108,
     109,   110,   111,     0,   112,   113,   114,     0,   376,     0,
      41,     7,     0,     0,     0,    76,   274,     0,    79,    80,
     311,    82,    83,    84,    85,    86,     0,     0,     0,     0,
       0,     0,     0,    88,    10,    11,     0,    12,     0,   225,
     226,     0,    13,    14,     0,    15,    16,     0,     0,     0,
      19,    20,    21,    22,     0,     0,     0,    25,   312,     0,
       0,     0,    92,     0,     0,    28,   313,    29,    94,     0,
      95,     0,    30,     0,     0,     0,     0,     0,    97,    33,
      31,   227,   228,     0,     0,     0,    98,     0,    99,     0,
       0,    36,   109,   110,   229,     0,     0,   230,     0,   100,
     101,     0,   231,    33,   103,     0,     0,     0,     0,    34,
      35,   105,   106,   107,     0,    36,   109,   110,   314,     0,
     112,   315,   316,     0,   -56,   376,    41,   388,     7,     0,
       0,     0,    76,   274,     0,    79,    80,   311,    82,    83,
      84,    85,    86,     0,     0,     0,     0,     0,     0,     0,
      88,    10,    11,     0,    12,     0,   225,   226,     0,    13,
      14,     0,    15,    16,     0,     0,     0,    19,    20,    21,
      22,     0,     0,     0,    25,   312,     0,     0,     0,    92,
       0,     0,    28,   313,    29,    94,     0,    95,     0,    30,
       0,     0,     0,     0,     0,    97,    33,    31,   352,   228,
       0,     0,     0,    98,     0,    99,     0,     0,    36,   109,
     110,   229,     0,     0,   230,   206,   100,   101,  -166,   231,
      33,   103,     0,     0,     0,     0,    34,    35,   105,   106,
     107,     0,    36,   109,   110,   314,     0,   112,   315,   316,
    -166,  -166,  -166,    41,  -166,     0,   225,   226,     0,  -166,
    -166,     0,  -166,  -166,     0,     0,     0,  -166,  -166,  -166,
      22,     0,     0,     0,  -166,  -166,     0,     0,     0,  -166,
       0,     0,  -166,  -166,  -166,  -166,     0,  -166,     0,  -166,
       0,     0,     0,     0,     0,  -166,    33,  -166,   509,   228,
       0,     0,     0,  -166,     0,  -166,     0,     0,    36,   109,
     110,   229,     0,     0,   230,     0,  -166,  -166,     0,   231,
      33,    -2,     6,     0,     0,     7,  -166,  -166,     0,     0,
    -166,     0,    36,    37,   207,    39,     0,     0,    40,     0,
       0,     0,     0,  -166,   208,     8,     9,     0,    10,    11,
       0,    12,     0,     0,     0,     0,    13,    14,     0,    15,
      16,   -64,    17,    18,    19,    20,    21,    22,    23,    24,
       0,    25,     0,    26,     0,     0,     0,    27,     0,    28,
       0,    29,     0,     0,     0,     0,    30,     0,     0,     0,
       0,     0,     0,     0,    31,     0,    76,     0,     0,    79,
      80,   311,    82,    83,    84,    85,     0,     0,     0,     0,
     511,    32,     0,     7,     0,     0,     0,    33,     0,     0,
       0,     0,     0,    34,    35,     0,     0,     0,     0,    36,
      37,    38,    39,     0,     9,    40,    10,    11,     0,    12,
      41,     0,     0,     0,    13,    14,     0,    15,    16,  -128,
       0,    18,    19,    20,    21,    22,    23,    24,     0,    25,
     458,    26,     0,     0,     0,    27,     0,    28,     0,    29,
       0,     0,     0,     0,    30,     0,     0,     0,     0,     0,
       0,   459,    31,     0,    33,     0,     0,     0,     0,     0,
      34,   460,   105,   106,     0,     0,    36,   109,   110,     0,
       0,   112,     0,   316,     0,    33,     0,     0,     0,     0,
       0,    34,    35,     0,     0,     0,     0,    36,    37,   512,
       0,     0,     0,   376,     0,     0,     7,     0,    41,   513,
      76,   274,     0,    79,    80,   311,    82,    83,    84,    85,
      86,     0,     0,     0,     0,     0,     0,     0,    88,    10,
      11,     0,    12,     0,     0,     0,     0,    13,    14,     0,
      15,    16,     0,     0,     0,    19,    20,    21,    22,     0,
       0,     0,    25,   312,     0,     0,     0,    92,     0,     0,
      28,   313,    29,    94,     0,    95,     0,    30,     0,     0,
       0,     0,     0,    97,     0,    31,   377,     0,     0,     0,
       0,    98,     0,    99,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   100,   101,     0,     0,    33,   103,
       0,     0,     0,     0,    34,    35,   105,   106,   107,     0,
      36,   109,   110,   314,     0,   112,   315,   316,     7,     0,
       0,    41,    76,   808,   809,    79,    80,   311,    82,    83,
      84,    85,   810,     0,   811,     0,     0,     0,     8,     9,
      88,    10,    11,     0,    89,     0,     0,     0,     0,    13,
      14,  -297,    15,    16,   -64,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,   312,    26,     0,     0,    92,
      27,     0,    28,   313,    29,    94,     0,    95,    96,    30,
       0,     0,     0,     0,     0,    97,     0,    31,     0,     0,
       0,     0,     0,    98,     0,    99,     0,     0,     0,   546,
       0,     0,     0,     0,     0,     0,   100,   101,     0,   549,
      33,     0,     0,     0,     0,     0,    34,    35,   105,   106,
     107,   550,    36,   812,   552,   813,     0,   112,   814,   815,
       7,     0,     0,    41,    76,   726,    78,    79,    80,    81,
      82,    83,    84,    85,   727,     0,    87,     0,     0,     0,
       8,     9,    88,    10,    11,     0,    89,  -289,     0,     0,
       0,    13,    14,  -293,    15,    16,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,    91,    26,     0,
       0,    92,    27,     0,    28,    93,    29,    94,     0,    95,
      96,    30,     0,     0,     0,     0,     0,    97,     0,    31,
       0,     0,     0,     0,     0,    98,     0,    99,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,   101,
       0,   549,    33,     0,     0,     0,     0,     0,   104,    35,
     105,   106,   107,   550,   108,   728,   552,   729,     0,   112,
     730,   731,     7,     0,     0,    41,    76,   808,   809,    79,
      80,   311,    82,    83,    84,    85,   810,     0,   811,     0,
       0,     0,     8,     9,    88,    10,    11,     0,    89,     0,
       0,     0,     0,    13,    14,     0,    15,    16,   -64,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,   312,
      26,     0,     0,    92,    27,     0,    28,   313,    29,    94,
       0,    95,    96,    30,     0,     0,     0,     0,     0,    97,
       0,    31,     0,     0,     0,     0,     0,    98,     0,    99,
       0,     0,     0,   546,     0,     0,     0,     0,     0,     0,
     100,   101,     0,   549,    33,     0,     0,     0,     0,     0,
      34,    35,   105,   106,   107,   550,    36,   812,   552,   813,
       0,   112,   814,   815,     7,     0,     0,    41,    76,   726,
      78,    79,    80,   311,    82,    83,    84,    85,   727,     0,
      87,     0,     0,     0,     8,     9,    88,    10,    11,     0,
      89,  -289,     0,     0,     0,    13,    14,  -293,    15,    16,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,   312,    26,     0,     0,    92,    27,     0,    28,   313,
      29,    94,     0,    95,    96,    30,     0,     0,     0,     0,
       0,    97,     0,    31,     0,     0,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,   101,     0,   549,    33,     0,     0,     0,
       0,     0,    34,    35,   105,   106,   107,   550,    36,   728,
     552,   729,     0,   112,   730,   731,     7,     0,     0,    41,
      76,   547,    78,    79,    80,    81,    82,    83,    84,    85,
     548,     0,    87,     0,     0,     0,     8,     9,    88,    10,
      11,     0,    89,     0,     0,     0,     0,    13,    14,  -291,
      15,    16,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,    91,    26,     0,     0,    92,    27,     0,
      28,    93,    29,    94,     0,    95,    96,    30,     0,     0,
       0,     0,     0,    97,     0,    31,     0,     0,     0,     0,
       0,    98,     0,    99,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   100,   101,     0,   549,    33,     0,
       0,     0,     0,     0,   104,    35,   105,   106,   107,   550,
     108,   551,   552,   553,     0,   112,   554,   555,     7,     0,
       0,    41,    76,   726,    78,    79,    80,   311,    82,    83,
      84,    85,   727,     0,    87,     0,     0,     0,     8,     9,
      88,    10,    11,     0,    89,  -289,     0,     0,     0,    13,
      14,     0,    15,    16,     0,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,   312,    26,     0,     0,    92,
      27,     0,    28,   313,    29,    94,     0,    95,    96,    30,
       0,     0,     0,     0,     0,    97,     0,    31,     0,     0,
       0,     0,     0,    98,     0,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   100,   101,     0,   549,
      33,     0,     0,     0,     0,     0,    34,    35,   105,   106,
     107,   550,    36,   728,   552,   729,     0,   112,   730,   731,
       7,     0,     0,    41,    76,   547,    78,    79,    80,   311,
      82,    83,    84,    85,   548,     0,    87,     0,     0,     0,
       8,     9,    88,    10,    11,     0,    89,     0,     0,     0,
       0,    13,    14,  -295,    15,    16,     0,     0,    18,    19,
      20,    21,    22,    23,    24,     0,    25,   312,    26,     0,
       0,    92,    27,     0,    28,   313,    29,    94,     0,    95,
      96,    30,     0,     0,     0,     0,     0,    97,     0,    31,
       0,     0,     0,     0,     0,    98,     0,    99,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   100,   101,
       0,   549,    33,     0,     0,     0,     0,     0,    34,    35,
     105,   106,   107,   550,    36,   551,   552,   553,     0,   112,
     554,   555,     7,     0,     0,    41,    76,   547,    78,    79,
      80,   311,    82,    83,    84,    85,   548,     0,    87,     0,
       0,     0,     8,     9,    88,    10,    11,     0,    89,     0,
       0,     0,     0,    13,    14,  -291,    15,    16,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,   312,
      26,     0,     0,    92,    27,     0,    28,   313,    29,    94,
       0,    95,    96,    30,     0,     0,     0,     0,     0,    97,
       0,    31,     0,     0,     0,     0,     0,    98,     0,    99,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     100,   101,     0,   549,    33,     0,     0,     0,     0,     0,
      34,    35,   105,   106,   107,   550,    36,   551,   552,   553,
       0,   112,   554,   555,     7,     0,     0,    41,    76,   726,
      78,    79,    80,   311,    82,    83,    84,    85,   727,     0,
      87,     0,     0,     0,     8,     9,    88,    10,    11,     0,
      89,     0,     0,     0,     0,    13,    14,  -293,    15,    16,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,   312,    26,     0,     0,    92,    27,     0,    28,   313,
      29,    94,     0,    95,    96,    30,     0,     0,     0,     0,
       0,    97,     0,    31,     0,     0,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,   101,     0,   549,    33,     0,     0,     0,
       0,     0,    34,    35,   105,   106,   107,   550,    36,   728,
     552,   729,     0,   112,   730,   731,     7,     0,     0,    41,
      76,   547,    78,    79,    80,   311,    82,    83,    84,    85,
     548,     0,    87,     0,     0,     0,     8,     9,    88,    10,
      11,     0,    89,     0,     0,     0,     0,    13,    14,     0,
      15,    16,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,   312,    26,     0,     0,    92,    27,     0,
      28,   313,    29,    94,     0,    95,    96,    30,     0,     0,
       0,     0,     0,    97,     0,    31,     0,     0,     0,     0,
       0,    98,     0,    99,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   100,   101,     0,   549,    33,     0,
       0,     0,     0,     0,    34,    35,   105,   106,   107,   550,
      36,   551,   552,   553,     0,   112,   554,   555,     7,     0,
       0,    41,    76,   392,    78,    79,    80,    81,    82,    83,
      84,    85,     0,     0,    87,     0,     0,     0,     8,     9,
      88,    10,    11,     0,    89,     0,     0,     0,     0,    13,
      14,     0,    15,    16,     0,     0,    18,    19,    20,    21,
      22,    23,    24,     0,    25,    91,    26,     0,     0,    92,
      27,     0,    28,    93,    29,    94,     0,    95,    96,    30,
       0,     0,     0,     0,     0,    97,     0,    31,     0,     0,
       0,     0,     0,    98,     0,    99,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   100,   101,     0,   102,
      33,     0,     0,     0,     0,     0,   104,    35,   105,   106,
     107,     0,   108,   109,   110,   393,     7,   112,   394,   395,
       0,   392,    78,    41,     0,   656,   657,   658,     0,     0,
       0,     0,    87,     0,     0,     0,     8,     9,    88,    10,
      11,     0,    89,     0,     0,     0,     0,    13,    14,  -102,
      15,    16,     0,     0,    18,    19,    20,    21,    22,    23,
      24,     0,    25,    91,    26,     0,     0,    92,    27,     0,
      28,    93,    29,    94,     0,    95,    96,    30,     0,     0,
       0,     0,     0,    97,     0,    31,     0,     0,     0,     0,
       0,    98,     0,    99,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   100,   101,     0,   549,    33,     0,
       0,     0,     0,     0,   104,    35,   105,   106,   107,   550,
     108,   659,   552,   393,     7,   112,   394,   660,     0,   392,
      78,    41,     0,   656,   657,   658,     0,     0,     0,     0,
      87,     0,     0,     0,     8,     9,    88,    10,    11,     0,
      89,     0,     0,     0,     0,    13,    14,  -103,    15,    16,
       0,     0,    18,    19,    20,    21,    22,    23,    24,     0,
      25,    91,    26,     0,     0,    92,    27,     0,    28,    93,
      29,    94,     0,    95,    96,    30,     0,     0,     0,     0,
       0,    97,     0,    31,     0,     0,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,   101,     0,   549,    33,     0,     0,     0,
       0,     0,   104,    35,   105,   106,   107,   550,   108,   659,
     552,   393,     7,   112,   394,   660,     0,   392,    78,    41,
       0,     0,     0,     0,     0,     0,     0,     0,    87,     0,
       0,     0,     8,     9,    88,    10,    11,     0,    89,     0,
       0,     0,     0,    13,    14,     0,    15,    16,     0,     0,
      18,    19,    20,    21,    22,    23,    24,     0,    25,   312,
      26,     0,     0,    92,    27,     0,    28,   313,    29,    94,
       0,    95,    96,    30,     0,     0,     0,     0,     0,    97,
       0,    31,     0,     0,     0,     0,     0,    98,     0,    99,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     100,   101,     0,   549,    33,     0,     0,     0,     0,     0,
      34,    35,   105,   106,   107,   550,    36,   659,   552,   393,
       0,   112,   394,   796,     7,     0,     0,    41,    76,   274,
       0,    79,    80,   311,    82,    83,    84,    85,    86,     0,
       0,     0,     0,     0,     0,     0,    88,    10,    11,     0,
      12,     0,     0,     0,     0,    13,    14,     0,    15,    16,
       0,     0,     0,    19,    20,    21,    22,     0,     0,     0,
      25,   312,     0,     0,     0,    92,     0,     0,    28,   313,
      29,    94,     0,    95,     0,    30,     0,     0,     0,     0,
       0,    97,     0,    31,     0,     0,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,   101,     7,     0,    33,   103,     0,     0,
       0,     0,    34,    35,   105,   106,   107,     0,    36,   109,
     110,   314,     0,   112,   315,   316,    88,    10,    11,    41,
      12,     0,     0,     0,     0,    13,    14,     0,    15,    16,
    -152,     0,    18,    19,    20,    21,    22,     0,    24,     0,
      25,   312,    26,     0,     0,    92,     0,     0,    28,   313,
      29,    94,     0,    95,     0,    30,     0,     0,     0,     0,
       0,    97,     0,    31,     0,     0,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   100,   101,     7,     0,    33,   103,     0,     0,
       0,     0,    34,    35,   105,   106,   107,     0,    36,   109,
     110,   314,     0,   112,   315,     0,    88,    10,    11,    41,
      12,     0,     0,     0,     0,    13,    14,     0,    15,    16,
       0,     0,     0,    19,    20,    21,    22,     0,     0,     0,
      25,   312,     0,     0,     0,    92,     0,     0,    28,   313,
      29,    94,     0,    95,     0,    30,     0,     0,     0,     0,
       0,    97,     0,    31,     0,     0,     0,     0,     0,    98,
       0,    99,     0,     0,     0,     0,     7,     0,     0,     0,
       0,     0,   100,   101,     0,     0,     0,   103,     0,     0,
       0,     0,    34,    35,   105,   106,   107,     0,    88,    10,
      11,   314,    89,   112,   315,     0,     0,    13,    14,    41,
      15,    16,     0,     0,     0,    19,    20,    21,     0,     0,
       0,     0,    25,   312,     0,     0,     0,    92,     0,     0,
      28,   313,    29,    94,     0,    95,     0,    30,     0,     0,
       0,     0,     0,    97,     0,    31,     0,     0,     0,     0,
       0,    98,     0,    99,     0,     0,     0,     0,     7,     0,
       0,     0,     0,     0,   100,   101,     0,     0,     0,     0,
       0,     0,     0,     0,    34,    35,     0,     0,   107,     0,
       0,    10,    11,     0,    12,     0,     0,     0,     0,    13,
      14,    41,    15,    16,     0,     0,     0,    19,    20,    21,
       0,     0,     0,     0,    25,     0,     0,     0,     0,     0,
       0,     0,    28,     0,    29,    94,     0,     0,     0,    30,
       0,     0,     0,     0,     0,    97,     0,    31,     0,     0,
       0,     0,     0,    98,     0,    99,     0,     0,     0,     0,
       7,     0,     0,     0,     0,     0,   100,   101,     0,     0,
       0,     0,     0,     0,     0,     0,    34,    35,   105,   106,
     107,     0,     0,    10,    11,     0,    12,   112,     0,     0,
       0,    13,    14,    41,    15,    16,     0,     0,     0,    19,
      20,    21,     0,     0,    76,     0,    25,    79,    80,   311,
     329,   330,     0,     0,    28,   331,    29,     0,     0,     0,
       0,    30,     0,     0,     0,     0,     0,     0,     0,    31,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    22,   632,   633,     0,     0,     0,     0,     0,
     634,     0,     0,   635,   636,   637,     0,     0,    34,    35,
       0,     0,     0,     0,     0,     0,     0,     0,   332,     0,
     638,     0,   639,     0,   640,    41,   641,     0,     0,     0,
       0,     0,     0,   642,   643,    96,     0,     0,     0,     0,
       0,     0,    33,     0,     0,     0,     0,     0,    34,     0,
       0,     0,     0,     0,    36,   109,   110,   333,     0,     0,
     334,   335,   336,     0,   337,   632,   633,    33,     0,     0,
       0,     0,   634,     0,     0,   635,   636,   637,     0,    36,
     109,   110,   174,     0,     0,   175,     0,     0,     0,     0,
       0,   644,   638,     0,   639,     0,   640,     0,   641,     0,
       0,     0,     0,     0,     0,   642,   643,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    33,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    36,   109,   110,   174,     0,     0,   175,     0,     0,
       0,     0,     0,   790
};

static const yytype_int16 yycheck[] =
{
       3,     4,    95,    56,    72,   171,     3,    92,     3,    28,
      29,    21,    91,   241,    93,     3,    95,   106,     3,    81,
      30,   312,     4,   112,    56,     4,   204,   151,   203,     3,
       4,   153,   241,   241,    86,   158,     4,   220,   161,   439,
      41,   183,   104,    69,   153,     4,   108,   227,   203,   420,
     421,   422,   387,     4,   425,     3,     4,   545,   545,    56,
      72,    56,   414,    20,   387,    72,   449,    94,    56,   244,
     153,   454,     4,     3,     4,    36,     1,   395,    88,     1,
      69,   449,   725,     9,     4,   244,   454,    90,     1,   244,
     268,    94,   324,   183,   118,   515,   358,     4,   122,   121,
      66,    67,    68,   190,    70,     9,   128,   527,    90,    21,
     189,    90,   374,   454,    18,   183,    90,     9,    10,    89,
      81,   541,    90,     3,     4,   768,   354,   116,    20,    83,
     133,    90,   114,    87,   505,   506,     0,   625,   625,    90,
       9,    10,    90,   119,   372,   354,   354,   108,     9,    10,
     153,    20,   164,   111,   386,   387,   114,   164,    90,    20,
      90,   118,   249,   372,    96,   122,   289,     4,   291,    95,
      90,   107,   352,   449,    84,    85,   112,   286,   454,     3,
       4,   364,   133,    90,   536,   188,   271,   118,    40,     4,
       9,   122,   375,     3,     4,   120,   199,   223,   120,   322,
     212,   133,   325,     9,    10,   119,   293,   120,     4,   577,
      90,   546,   321,   133,    20,   118,   303,     7,   249,   122,
     313,   153,    12,   546,   203,   625,    83,   350,   383,   203,
      87,    21,   415,   312,   313,   203,   119,   188,   321,   171,
      30,     9,    10,   211,   203,    58,   115,    60,   199,   119,
      13,   278,    20,    90,   119,   203,   188,     7,   610,   118,
      73,   629,   293,   122,   118,   244,    90,   199,   122,   118,
     244,   203,   303,   203,   449,    90,   244,   660,   401,   454,
      90,   599,   372,    46,   287,   244,   428,   442,   606,   607,
     109,   110,   111,   118,    90,   114,   244,   122,    88,    89,
     121,    91,    92,    93,    94,    95,   119,   360,     9,   362,
     693,   694,   244,   124,   244,   126,    20,   318,   321,   807,
     807,   324,   690,   203,   692,   693,   694,   482,   639,   509,
     641,   486,   703,   345,   669,   286,   459,   133,   345,   102,
      20,   367,    83,   831,   831,   108,    87,   715,   122,   123,
     311,    46,   439,   694,   286,   358,     9,   360,    37,   362,
     428,   446,   447,   360,   244,   362,   203,     9,    10,   100,
     101,   374,   360,     0,   362,   360,     0,   362,    20,   203,
     383,   115,   116,   386,   387,    84,   383,   224,   203,   321,
       0,   619,   188,   203,   777,   383,     0,   765,     0,   189,
      90,   383,    97,   199,   386,   387,    90,   244,   439,   777,
     619,   619,   202,   796,   204,     9,   111,   693,   694,   114,
     244,   596,   577,   601,   602,     0,    20,   386,   387,   244,
     360,   831,   362,   608,   244,   445,   777,   596,   121,   442,
       0,   596,   374,   118,   374,   442,   121,   122,   121,   608,
     833,   363,   449,   608,   442,   121,   368,   454,   545,   121,
     442,   449,   103,   442,   832,   833,   454,    82,    83,   624,
     449,   474,    83,   615,   629,   454,    87,    88,   268,   482,
     360,   271,   362,   486,   121,   482,    83,   490,   119,   486,
     449,     7,   833,    85,   482,   454,    96,   287,   486,   870,
     482,   777,    96,   482,   486,   611,   612,   486,   108,   109,
     110,   111,    85,   445,   108,   109,   110,   885,   693,   694,
      82,    83,   312,   313,   456,   615,   616,   579,    64,   109,
     110,   111,   444,   761,   114,   690,   360,   692,   625,   490,
     627,   118,   595,    83,   666,    82,    83,   615,   616,    86,
     360,    88,   362,   761,   639,   121,   641,   833,   490,   123,
     715,    83,   121,   595,   546,    87,    88,   505,   506,   121,
     861,   509,    96,   363,   577,   121,   700,   119,   368,   103,
     577,   385,    83,   122,   108,   109,   110,   546,    83,   577,
     386,   387,    87,    88,   656,   577,   627,    83,   595,    19,
     595,    83,   777,   781,   782,    87,    88,   595,   445,   698,
     765,   124,   767,    37,    82,    83,   844,   596,    86,    82,
      88,   624,   596,   789,   604,   605,   629,   624,   596,   608,
     101,    83,   629,   643,   608,    84,   624,   596,   121,   443,
     608,   629,   624,   121,   119,     3,   119,   629,   596,   608,
     629,    84,    83,   113,   444,   445,   446,   447,   833,    84,
     608,   740,   741,   648,   596,   675,   596,   121,    82,    83,
       4,   761,    86,   121,    88,   121,   608,   832,   608,   483,
       5,    83,   614,   487,   474,    87,    88,   690,    83,   692,
     709,   778,    31,   690,   490,   692,   693,   694,    56,   286,
      20,   786,   690,   826,   692,   693,   694,    83,   690,   121,
     692,   690,   715,   692,   115,   805,   596,   785,   715,   651,
     807,   783,   784,   286,    37,    31,   849,   715,   608,    83,
     885,   854,   100,    83,   693,   694,    94,   805,   121,    83,
     672,    98,    54,   675,   831,    82,    83,   778,   118,    86,
     546,    88,   839,    83,   841,    83,    90,    98,     9,   596,
     845,   846,   765,     9,   767,   703,     9,    83,   765,   862,
     767,   608,   596,   121,   706,   133,   121,   765,   114,   767,
     777,   596,   861,   862,   608,   767,   596,    90,   675,   777,
     362,     9,    61,   608,   216,   153,   383,    61,   608,   133,
      83,    61,   442,    46,    87,    88,   187,   675,   839,   449,
     841,   601,   602,    61,   454,    66,    67,    68,   777,    70,
     383,   109,   110,   111,   793,   474,   114,   852,    46,   832,
     188,   119,   672,   739,   697,   832,   833,    80,   468,     9,
      91,   199,   482,    83,   832,   833,   486,    87,    88,   639,
     832,   641,   428,   643,   188,   442,   835,   789,    -1,    83,
      78,   677,    80,    87,    88,   199,   109,   110,   111,   203,
     164,   114,    -1,    -1,   833,    -1,    -1,   211,    -1,   442,
      19,    -1,   885,    -1,    -1,   675,   865,   866,   885,   868,
      -1,   109,   110,   111,    -1,   482,   114,   885,    -1,   486,
       0,   880,   881,   885,   883,   884,    -1,    -1,     8,   127,
     244,    11,    12,    13,    14,    15,    16,    17,     9,   482,
      83,   725,    -1,   486,    87,    88,    -1,    18,    -1,   287,
      56,   494,   870,   871,   497,    -1,    75,    76,    77,   109,
     110,   111,    83,    -1,   114,    -1,    87,    88,   118,    -1,
     740,   741,   122,     8,    -1,    46,    11,    12,    13,    14,
      15,    16,    17,   321,   768,    -1,   324,    -1,    -1,    -1,
      96,    46,    98,   109,   110,   111,   115,   116,   114,    13,
      14,    15,   108,   109,   110,   111,   125,   126,   114,   629,
     577,   781,   782,    -1,     9,    10,   786,    -1,     9,    10,
     358,    -1,   360,    18,   362,    20,    83,    18,    -1,    20,
      87,    88,    -1,    -1,   577,   115,   374,    51,   109,   110,
     111,    96,    -1,   114,   358,    59,    -1,    -1,   386,   387,
      -1,    46,   836,   108,   109,   110,   111,   624,    -1,   114,
     374,    -1,   629,    -1,    -1,   120,   109,   110,   111,    -1,
     690,   114,   692,    -1,    -1,   845,   846,    -1,    -1,    -1,
     115,   624,    -1,   867,    -1,   869,   629,    -1,   102,     9,
      10,   861,   862,    57,   108,   879,    -1,    -1,    18,    94,
      20,   115,    97,    94,    66,    67,    68,    -1,    70,   104,
     105,    -1,   107,   104,   105,    -1,   111,   112,   113,   114,
      -1,   112,   113,   690,     1,   692,    46,     4,    -1,    -1,
      -1,    -1,    96,    -1,    98,    99,   474,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   108,   109,   110,   690,   715,   692,
      27,    28,   490,    30,    -1,   119,    -1,    -1,    35,    36,
      -1,    38,    39,    40,    -1,    42,    43,    44,    45,    46,
      47,    48,   715,    50,    94,    52,   490,    97,    -1,    56,
      -1,    58,    -1,    60,   104,   105,    -1,   107,    65,    -1,
      -1,   111,   112,   113,   114,    -1,    73,    -1,   765,    -1,
     767,    -1,     8,   100,   101,    11,    12,    13,    14,    15,
     107,    -1,    -1,    19,    -1,   835,    56,    57,    -1,    96,
      -1,    -1,   765,    96,   767,   102,   103,    -1,    -1,    -1,
      -1,   108,   109,   110,    -1,   108,   109,   110,   111,    -1,
      46,   114,   119,   120,    -1,   865,   866,   144,   868,    -1,
      -1,    -1,    -1,    -1,   151,    -1,    96,   595,    98,    99,
     880,   881,   159,   883,   884,   832,    72,    -1,   108,   109,
     110,   111,    -1,    -1,   114,    -1,    -1,    -1,    -1,   119,
     120,    -1,   596,    -1,    -1,    -1,    -1,    -1,    -1,   832,
      96,    -1,    -1,    -1,   608,    -1,   102,    -1,    -1,    -1,
      -1,    -1,   108,   109,   110,   111,    -1,    -1,   114,   115,
     116,    -1,   118,    -1,    -1,    -1,    -1,    -1,   885,    -1,
      -1,     0,     1,    -1,    -1,     4,    -1,    -1,   666,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      -1,    20,   885,    -1,    -1,    24,    25,    26,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      -1,    50,    51,    52,    -1,    -1,    55,    56,    -1,    58,
      59,    60,    61,    -1,    63,    64,    65,    -1,    -1,    -1,
      -1,    -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,
      79,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    92,    93,    -1,    95,    96,    97,    -1,
      -1,    -1,    -1,   102,   103,   104,   105,   106,    -1,   108,
     109,   110,   111,    -1,   113,   114,   115,    -1,     1,    -1,
     119,     4,    -1,    -1,    -1,     8,     9,    -1,    11,    12,
      13,    14,    15,    16,    17,    18,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    26,    27,    28,    -1,    30,    -1,    56,
      57,    -1,    35,    36,    -1,    38,    39,    -1,    -1,    -1,
      43,    44,    45,    46,    -1,    -1,    -1,    50,    51,    -1,
      -1,    -1,    55,    -1,    -1,    58,    59,    60,    61,    -1,
      63,    -1,    65,    -1,    -1,    -1,    -1,    -1,    71,    96,
      73,    98,    99,    -1,    -1,    -1,    79,    -1,    81,    -1,
      -1,   108,   109,   110,   111,    -1,    -1,   114,    -1,    92,
      93,    -1,   119,    96,    97,    -1,    -1,    -1,    -1,   102,
     103,   104,   105,   106,    -1,   108,   109,   110,   111,    -1,
     113,   114,   115,    -1,     0,     1,   119,   120,     4,    -1,
      -1,    -1,     8,     9,    -1,    11,    12,    13,    14,    15,
      16,    17,    18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      26,    27,    28,    -1,    30,    -1,    56,    57,    -1,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    55,
      -1,    -1,    58,    59,    60,    61,    -1,    63,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    71,    96,    73,    98,    99,
      -1,    -1,    -1,    79,    -1,    81,    -1,    -1,   108,   109,
     110,   111,    -1,    -1,   114,     1,    92,    93,     4,   119,
      96,    97,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,    -1,   108,   109,   110,   111,    -1,   113,   114,   115,
      26,    27,    28,   119,    30,    -1,    56,    57,    -1,    35,
      36,    -1,    38,    39,    -1,    -1,    -1,    43,    44,    45,
      46,    -1,    -1,    -1,    50,    51,    -1,    -1,    -1,    55,
      -1,    -1,    58,    59,    60,    61,    -1,    63,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    71,    96,    73,    98,    99,
      -1,    -1,    -1,    79,    -1,    81,    -1,    -1,   108,   109,
     110,   111,    -1,    -1,   114,    -1,    92,    93,    -1,   119,
      96,     0,     1,    -1,    -1,     4,   102,   103,    -1,    -1,
     106,    -1,   108,   109,   110,   111,    -1,    -1,   114,    -1,
      -1,    -1,    -1,   119,   120,    24,    25,    -1,    27,    28,
      -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      -1,    50,    -1,    52,    -1,    -1,    -1,    56,    -1,    58,
      -1,    60,    -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    73,    -1,     8,    -1,    -1,    11,
      12,    13,    14,    15,    16,    17,    -1,    -1,    -1,    -1,
       1,    90,    -1,     4,    -1,    -1,    -1,    96,    -1,    -1,
      -1,    -1,    -1,   102,   103,    -1,    -1,    -1,    -1,   108,
     109,   110,   111,    -1,    25,   114,    27,    28,    -1,    30,
     119,    -1,    -1,    -1,    35,    36,    -1,    38,    39,    40,
      -1,    42,    43,    44,    45,    46,    47,    48,    -1,    50,
      72,    52,    -1,    -1,    -1,    56,    -1,    58,    -1,    60,
      -1,    -1,    -1,    -1,    65,    -1,    -1,    -1,    -1,    -1,
      -1,    93,    73,    -1,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,    -1,    -1,   108,   109,   110,    -1,
      -1,   113,    -1,   115,    -1,    96,    -1,    -1,    -1,    -1,
      -1,   102,   103,    -1,    -1,    -1,    -1,   108,   109,   110,
      -1,    -1,    -1,     1,    -1,    -1,     4,    -1,   119,   120,
       8,     9,    -1,    11,    12,    13,    14,    15,    16,    17,
      18,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,
      38,    39,    -1,    -1,    -1,    43,    44,    45,    46,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    55,    -1,    -1,
      58,    59,    60,    61,    -1,    63,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    73,    74,    -1,    -1,    -1,
      -1,    79,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    93,    -1,    -1,    96,    97,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,    -1,
     108,   109,   110,   111,    -1,   113,   114,   115,     4,    -1,
      -1,   119,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    -1,    20,    -1,    -1,    -1,    24,    25,
      26,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,
      36,    37,    38,    39,    40,    -1,    42,    43,    44,    45,
      46,    47,    48,    -1,    50,    51,    52,    -1,    -1,    55,
      56,    -1,    58,    59,    60,    61,    -1,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    81,    -1,    -1,    -1,    85,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,
      96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
       4,    -1,    -1,   119,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    -1,    20,    -1,    -1,    -1,
      24,    25,    26,    27,    28,    -1,    30,    31,    -1,    -1,
      -1,    35,    36,    37,    38,    39,    -1,    -1,    42,    43,
      44,    45,    46,    47,    48,    -1,    50,    51,    52,    -1,
      -1,    55,    56,    -1,    58,    59,    60,    61,    -1,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    71,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    79,    -1,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,
      -1,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,     4,    -1,    -1,   119,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    -1,    20,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    -1,    30,    -1,
      -1,    -1,    -1,    35,    36,    -1,    38,    39,    40,    -1,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    -1,    -1,    55,    56,    -1,    58,    59,    60,    61,
      -1,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    79,    -1,    81,
      -1,    -1,    -1,    85,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    93,    -1,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,     4,    -1,    -1,   119,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    -1,
      20,    -1,    -1,    -1,    24,    25,    26,    27,    28,    -1,
      30,    31,    -1,    -1,    -1,    35,    36,    37,    38,    39,
      -1,    -1,    42,    43,    44,    45,    46,    47,    48,    -1,
      50,    51,    52,    -1,    -1,    55,    56,    -1,    58,    59,
      60,    61,    -1,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    93,    -1,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,     4,    -1,    -1,   119,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    -1,    20,    -1,    -1,    -1,    24,    25,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    37,
      38,    39,    -1,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    -1,    -1,    55,    56,    -1,
      58,    59,    60,    61,    -1,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    79,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,     4,    -1,
      -1,   119,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    -1,    20,    -1,    -1,    -1,    24,    25,
      26,    27,    28,    -1,    30,    31,    -1,    -1,    -1,    35,
      36,    -1,    38,    39,    -1,    -1,    42,    43,    44,    45,
      46,    47,    48,    -1,    50,    51,    52,    -1,    -1,    55,
      56,    -1,    58,    59,    60,    61,    -1,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,
      96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,    -1,   113,   114,   115,
       4,    -1,    -1,   119,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    -1,    20,    -1,    -1,    -1,
      24,    25,    26,    27,    28,    -1,    30,    -1,    -1,    -1,
      -1,    35,    36,    37,    38,    39,    -1,    -1,    42,    43,
      44,    45,    46,    47,    48,    -1,    50,    51,    52,    -1,
      -1,    55,    56,    -1,    58,    59,    60,    61,    -1,    63,
      64,    65,    -1,    -1,    -1,    -1,    -1,    71,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    79,    -1,    81,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    92,    93,
      -1,    95,    96,    -1,    -1,    -1,    -1,    -1,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,    -1,   113,
     114,   115,     4,    -1,    -1,   119,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    -1,    20,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    -1,    30,    -1,
      -1,    -1,    -1,    35,    36,    37,    38,    39,    -1,    -1,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    -1,    -1,    55,    56,    -1,    58,    59,    60,    61,
      -1,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    79,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    93,    -1,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,     4,    -1,    -1,   119,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    -1,
      20,    -1,    -1,    -1,    24,    25,    26,    27,    28,    -1,
      30,    -1,    -1,    -1,    -1,    35,    36,    37,    38,    39,
      -1,    -1,    42,    43,    44,    45,    46,    47,    48,    -1,
      50,    51,    52,    -1,    -1,    55,    56,    -1,    58,    59,
      60,    61,    -1,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    93,    -1,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,    -1,   113,   114,   115,     4,    -1,    -1,   119,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    -1,    20,    -1,    -1,    -1,    24,    25,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    -1,
      38,    39,    -1,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    -1,    -1,    55,    56,    -1,
      58,    59,    60,    61,    -1,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    79,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,    -1,   113,   114,   115,     4,    -1,
      -1,   119,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    -1,    -1,    20,    -1,    -1,    -1,    24,    25,
      26,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,
      36,    -1,    38,    39,    -1,    -1,    42,    43,    44,    45,
      46,    47,    48,    -1,    50,    51,    52,    -1,    -1,    55,
      56,    -1,    58,    59,    60,    61,    -1,    63,    64,    65,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    81,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    95,
      96,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,    -1,   108,   109,   110,   111,     4,   113,   114,   115,
      -1,     9,    10,   119,    -1,    13,    14,    15,    -1,    -1,
      -1,    -1,    20,    -1,    -1,    -1,    24,    25,    26,    27,
      28,    -1,    30,    -1,    -1,    -1,    -1,    35,    36,    37,
      38,    39,    -1,    -1,    42,    43,    44,    45,    46,    47,
      48,    -1,    50,    51,    52,    -1,    -1,    55,    56,    -1,
      58,    59,    60,    61,    -1,    63,    64,    65,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    79,    -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    92,    93,    -1,    95,    96,    -1,
      -1,    -1,    -1,    -1,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,     4,   113,   114,   115,    -1,     9,
      10,   119,    -1,    13,    14,    15,    -1,    -1,    -1,    -1,
      20,    -1,    -1,    -1,    24,    25,    26,    27,    28,    -1,
      30,    -1,    -1,    -1,    -1,    35,    36,    37,    38,    39,
      -1,    -1,    42,    43,    44,    45,    46,    47,    48,    -1,
      50,    51,    52,    -1,    -1,    55,    56,    -1,    58,    59,
      60,    61,    -1,    63,    64,    65,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    93,    -1,    95,    96,    -1,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,     4,   113,   114,   115,    -1,     9,    10,   119,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    20,    -1,
      -1,    -1,    24,    25,    26,    27,    28,    -1,    30,    -1,
      -1,    -1,    -1,    35,    36,    -1,    38,    39,    -1,    -1,
      42,    43,    44,    45,    46,    47,    48,    -1,    50,    51,
      52,    -1,    -1,    55,    56,    -1,    58,    59,    60,    61,
      -1,    63,    64,    65,    -1,    -1,    -1,    -1,    -1,    71,
      -1,    73,    -1,    -1,    -1,    -1,    -1,    79,    -1,    81,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    93,    -1,    95,    96,    -1,    -1,    -1,    -1,    -1,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
      -1,   113,   114,   115,     4,    -1,    -1,   119,     8,     9,
      -1,    11,    12,    13,    14,    15,    16,    17,    18,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    26,    27,    28,    -1,
      30,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    55,    -1,    -1,    58,    59,
      60,    61,    -1,    63,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    93,     4,    -1,    96,    97,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,    -1,   108,   109,
     110,   111,    -1,   113,   114,   115,    26,    27,    28,   119,
      30,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,    39,
      40,    -1,    42,    43,    44,    45,    46,    -1,    48,    -1,
      50,    51,    52,    -1,    -1,    55,    -1,    -1,    58,    59,
      60,    61,    -1,    63,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    81,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    92,    93,     4,    -1,    96,    97,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,    -1,   108,   109,
     110,   111,    -1,   113,   114,    -1,    26,    27,    28,   119,
      30,    -1,    -1,    -1,    -1,    35,    36,    -1,    38,    39,
      -1,    -1,    -1,    43,    44,    45,    46,    -1,    -1,    -1,
      50,    51,    -1,    -1,    -1,    55,    -1,    -1,    58,    59,
      60,    61,    -1,    63,    -1,    65,    -1,    -1,    -1,    -1,
      -1,    71,    -1,    73,    -1,    -1,    -1,    -1,    -1,    79,
      -1,    81,    -1,    -1,    -1,    -1,     4,    -1,    -1,    -1,
      -1,    -1,    92,    93,    -1,    -1,    -1,    97,    -1,    -1,
      -1,    -1,   102,   103,   104,   105,   106,    -1,    26,    27,
      28,   111,    30,   113,   114,    -1,    -1,    35,    36,   119,
      38,    39,    -1,    -1,    -1,    43,    44,    45,    -1,    -1,
      -1,    -1,    50,    51,    -1,    -1,    -1,    55,    -1,    -1,
      58,    59,    60,    61,    -1,    63,    -1,    65,    -1,    -1,
      -1,    -1,    -1,    71,    -1,    73,    -1,    -1,    -1,    -1,
      -1,    79,    -1,    81,    -1,    -1,    -1,    -1,     4,    -1,
      -1,    -1,    -1,    -1,    92,    93,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   102,   103,    -1,    -1,   106,    -1,
      -1,    27,    28,    -1,    30,    -1,    -1,    -1,    -1,    35,
      36,   119,    38,    39,    -1,    -1,    -1,    43,    44,    45,
      -1,    -1,    -1,    -1,    50,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    58,    -1,    60,    61,    -1,    -1,    -1,    65,
      -1,    -1,    -1,    -1,    -1,    71,    -1,    73,    -1,    -1,
      -1,    -1,    -1,    79,    -1,    81,    -1,    -1,    -1,    -1,
       4,    -1,    -1,    -1,    -1,    -1,    92,    93,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   102,   103,   104,   105,
     106,    -1,    -1,    27,    28,    -1,    30,   113,    -1,    -1,
      -1,    35,    36,   119,    38,    39,    -1,    -1,    -1,    43,
      44,    45,    -1,    -1,     8,    -1,    50,    11,    12,    13,
      14,    15,    -1,    -1,    58,    19,    60,    -1,    -1,    -1,
      -1,    65,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    46,    22,    23,    -1,    -1,    -1,    -1,    -1,
      29,    -1,    -1,    32,    33,    34,    -1,    -1,   102,   103,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    72,    -1,
      49,    -1,    51,    -1,    53,   119,    55,    -1,    -1,    -1,
      -1,    -1,    -1,    62,    63,    64,    -1,    -1,    -1,    -1,
      -1,    -1,    96,    -1,    -1,    -1,    -1,    -1,   102,    -1,
      -1,    -1,    -1,    -1,   108,   109,   110,   111,    -1,    -1,
     114,   115,   116,    -1,   118,    22,    23,    96,    -1,    -1,
      -1,    -1,    29,    -1,    -1,    32,    33,    34,    -1,   108,
     109,   110,   111,    -1,    -1,   114,    -1,    -1,    -1,    -1,
      -1,   120,    49,    -1,    51,    -1,    53,    -1,    55,    -1,
      -1,    -1,    -1,    -1,    -1,    62,    63,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    96,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   108,   109,   110,   111,    -1,    -1,   114,    -1,    -1,
      -1,    -1,    -1,   120
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_int16 yystos[] =
{
       0,    89,   130,   132,   131,     0,     1,     4,    24,    25,
      27,    28,    30,    35,    36,    38,    39,    41,    42,    43,
      44,    45,    46,    47,    48,    50,    52,    56,    58,    60,
      65,    73,    90,    96,   102,   103,   108,   109,   110,   111,
     114,   119,   133,   134,   136,   140,   145,   146,   147,   148,
     157,   160,   163,   169,   170,   171,   173,   177,   183,   184,
     185,   193,   195,   197,   198,   199,   200,   218,   222,   223,
     224,   301,   303,   304,   305,     1,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    20,    26,    30,
      41,    51,    55,    59,    61,    63,    64,    71,    79,    81,
      92,    93,    95,    97,   102,   104,   105,   106,   108,   109,
     110,   111,   113,   114,   115,   134,   135,   138,   140,   141,
     142,   145,   150,   151,   152,   153,   157,   160,   163,   169,
     175,   178,   179,   180,   181,   182,   186,   187,   198,   225,
     237,   238,   243,   244,   245,   249,   251,   252,   253,   254,
     260,   261,   262,   267,   270,   271,   274,   282,   283,   284,
     285,   286,   296,   301,   303,   304,   305,   306,   111,   114,
     135,   240,   119,   119,   111,   114,   135,   241,   111,   114,
     135,   240,   241,   302,   119,   177,   177,   241,   176,   118,
      83,    87,    88,   206,   208,   210,   214,   215,   210,   176,
      40,   144,   118,   121,   122,   119,     1,   110,   120,   136,
     148,   174,   303,   304,   179,   195,   196,   197,   243,   282,
       7,   194,   200,   190,   191,    56,    57,    98,    99,   111,
     114,   119,   138,   307,   308,   310,   311,   313,   314,   316,
     321,   322,   323,   325,   121,     9,    20,   272,    20,    83,
      87,   210,   212,     9,   265,   265,   272,   241,   119,   142,
       9,   111,   114,   135,   202,   203,   204,   205,   233,   234,
     203,   236,   202,   235,     9,   111,   114,   135,   239,   270,
     305,   235,   103,   138,   188,   189,   246,   280,   268,   269,
     271,   269,   269,    83,    87,   212,   122,   123,   257,   258,
     259,   257,   269,    83,    87,   212,   257,     9,   141,   265,
      37,    13,    51,    59,   111,   114,   115,   138,   180,   182,
     252,   267,   271,   305,    84,   269,   268,   269,   299,    14,
      15,    19,    72,   111,   114,   115,   116,   118,   138,   151,
     218,   254,   255,   264,   266,   303,   305,   273,   250,   250,
     269,   250,    98,   319,   322,     9,    20,   138,   298,    90,
     158,    90,   161,   121,   219,   103,   220,   221,   121,    98,
     308,   310,   322,   164,   166,   219,     1,    74,   180,   202,
      87,   209,   214,   216,   217,    83,    85,    85,   120,   119,
     202,   226,     9,   111,   114,   115,   138,   149,   150,   182,
     205,   251,   282,   293,   294,   295,   296,   297,   305,   226,
     153,   172,   182,   194,   190,     7,   200,   187,   326,   312,
      82,    83,    86,    88,   317,    82,   317,   318,   315,   309,
     100,   101,   311,   321,   323,   324,   325,   149,   118,    83,
      87,   213,   216,    83,   121,   156,   118,   122,   226,   121,
     203,   228,   229,   230,   121,   270,   121,   119,    72,    93,
     103,   138,   218,   247,   248,   252,   261,   262,   263,     9,
      78,    80,   111,   114,   127,   135,   275,   277,   279,   305,
     250,   250,   216,    83,   123,   122,   216,    83,   234,   235,
     176,   250,   285,   250,    66,    67,    68,    70,   288,    19,
     300,   319,   124,   252,   250,    82,    83,   320,    37,    98,
     178,     1,   110,   120,   136,   159,   160,   163,   168,   169,
     198,   301,   305,     1,   110,   120,   136,   162,   163,   168,
     198,   301,   305,   240,   190,   200,   240,     1,   120,   138,
     165,   167,   169,   178,   190,    83,    85,     9,    18,    95,
     107,   109,   110,   111,   114,   115,   134,   137,   139,   140,
     145,   153,   157,   160,   163,   169,   182,   187,   251,   261,
     262,   296,   301,   305,   306,    84,    87,   206,   211,    94,
     107,   112,   201,   207,   271,   282,   285,   296,   107,   201,
     207,   271,   282,   285,   296,   143,   121,    20,     9,   115,
     295,   118,   122,   250,   115,   116,   124,   126,   121,   220,
     190,   119,   119,   318,   318,   318,   318,   120,   310,   322,
     324,   327,    84,   213,   216,    83,   152,    83,    87,   206,
     212,   240,    22,    23,    29,    32,    33,    34,    49,    51,
      53,    55,    62,    63,   120,   135,   138,   154,   155,   187,
     227,   231,   232,   241,   203,   203,    13,    14,    15,   109,
     115,   139,   152,   205,   238,   242,   267,   282,   297,    84,
     152,   242,   121,   292,   298,   192,   250,   299,   277,    19,
      75,    76,    77,   115,   116,   125,   126,   276,   278,   152,
     206,   152,   206,   121,   121,   261,   261,   287,   121,   128,
     256,     9,    95,    82,   318,   320,   318,   320,   320,     5,
     144,   144,   220,   144,    87,   209,   217,   201,   207,   271,
     282,   296,     9,    10,    20,    83,     9,    18,   109,   111,
     114,   115,   139,   251,   261,   262,   296,   305,    31,   272,
     118,   122,   110,   120,   136,   148,   149,   226,   226,   294,
     294,   295,   295,   149,   220,   164,   164,   111,   138,   310,
     308,   322,   327,   324,    87,   209,   213,   216,    83,   152,
     228,   228,   241,   198,   111,   114,   138,   121,    83,    87,
     297,   118,   122,   102,   108,   303,   107,   201,   292,   115,
     120,   154,   232,   300,   152,   152,   115,     9,    91,   288,
     289,   290,   291,   257,   268,   318,   177,    83,     9,    10,
      18,    20,   109,   111,   114,   115,   139,   251,   261,   262,
     305,    31,   211,     9,    10,    20,   273,   202,   202,   120,
     120,    83,   206,   121,   242,   216,    83,   226,   226,    83,
      87,    83,    87,    98,   322,   118,   122,   203,   298,   256,
      69,   116,   118,    54,   281,   217,     9,    10,    20,   250,
     242,    51,    59,   115,    87,   206,   216,    83,   216,    83,
      83,    98,   203,   203,   250,   291,   250,   234,   235,    83,
     206,   206,   318,   121,   121,   206
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_int16 yyr1[] =
{
       0,   129,   130,   131,   130,   132,   132,   132,   132,   132,
     133,   133,   133,   133,   133,   133,   133,   133,   133,   133,
     133,   134,   134,   135,   135,   136,   136,   136,   137,   137,
     137,   137,   137,   137,   137,   137,   137,   137,   137,   137,
     137,   138,   138,   138,   139,   139,   139,   140,   141,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   143,
     143,   143,   143,   144,   146,   145,   147,   147,   148,   148,
     148,   148,   149,   149,   149,   149,   149,   150,   150,   150,
     150,   150,   150,   150,   150,   150,   150,   150,   150,   150,
     150,   150,   151,   151,   151,   151,   151,   151,   151,   151,
     151,   152,   152,   152,   152,   152,   152,   152,   152,   153,
     154,   155,   154,   156,   156,   156,   156,   157,   158,   158,
     158,   158,   158,   158,   158,   158,   158,   158,   159,   158,
     158,   160,   161,   161,   161,   161,   161,   161,   161,   161,
     161,   162,   161,   161,   163,   164,   164,   165,   165,   165,
     166,   166,   167,   166,   168,   169,   170,   170,   170,   171,
     172,   172,   173,   173,   173,   173,   174,   173,   173,   175,
     175,   175,   176,   176,   176,   177,   178,   178,   178,   179,
     180,   180,   180,   180,   180,   181,   182,   182,   183,   183,
     184,   184,   185,   185,   186,   186,   186,   188,   187,   187,
     189,   189,   190,   191,   191,   192,   192,   192,   193,   193,
     194,   194,   195,   195,   195,   195,   195,   196,   196,   196,
     197,   197,   197,   198,   198,   198,   199,   199,   199,   200,
     200,   201,   201,   201,   202,   202,   202,   203,   203,   204,
     204,   205,   205,   206,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   206,   206,   206,   206,   207,   208,   208,
     208,   208,   208,   208,   208,   208,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   209,   209,   209,
     209,   209,   209,   209,   209,   209,   209,   210,   210,   211,
     211,   212,   212,   212,   212,   213,   213,   213,   213,   214,
     214,   214,   214,   214,   214,   214,   214,   214,   214,   214,
     214,   215,   215,   215,   215,   215,   215,   215,   215,   215,
     215,   216,   216,   216,   217,   217,   218,   219,   219,   221,
     220,   220,   222,   222,   223,   223,   223,   223,   223,   224,
     224,   224,   224,   225,   226,   227,   227,   227,   227,   228,
     229,   230,   230,   230,   230,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   232,   232,   232,   232,   233,   234,
     234,   235,   236,   237,   237,   237,   237,   238,   238,   238,
     239,   239,   239,   239,   240,   240,   240,   241,   241,   241,
     242,   242,   242,   242,   242,   242,   242,   242,   243,   243,
     243,   243,   243,   244,   245,   245,   246,   246,   247,   247,
     247,   247,   248,   248,   248,   249,   250,   250,   251,   251,
     251,   251,   251,   251,   251,   251,   252,   252,   253,   254,
     254,   254,   254,   255,   255,   256,   256,   257,   257,   257,
     258,   258,   259,   259,   260,   261,   262,   262,   263,   263,
     264,   264,   264,   264,   265,   266,   266,   266,   266,   266,
     266,   266,   267,   267,   267,   268,   268,   269,   270,   270,
     271,   272,   272,   273,   273,   273,   274,   274,   275,   275,
     275,   275,   275,   276,   276,   276,   277,   277,   277,   277,
     277,   278,   278,   278,   278,   279,   279,   280,   280,   281,
     281,   282,   282,   283,   283,   284,   284,   284,   284,   285,
     286,   286,   287,   287,   288,   288,   288,   288,   289,   289,
     289,   290,   290,   291,   291,   291,   292,   292,   293,   293,
     293,   294,   294,   294,   295,   295,   296,   296,   296,   297,
     297,   297,   298,   298,   298,   299,   299,   300,   300,   302,
     301,   303,   304,   305,   305,   306,   307,   307,   307,   309,
     308,   310,   310,   311,   311,   311,   312,   311,   313,   314,
     315,   315,   315,   316,   317,   317,   317,   317,   318,   318,
     319,   319,   320,   320,   320,   320,   321,   322,   322,   323,
     323,   324,   324,   326,   325,   325,   325,   327,   327
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     1,     0,     3,     0,     2,     2,     2,     2,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     2,     2,     1,
       2,     0,     1,     1,     1,     2,     3,     1,     2,     0,
       2,     2,     2,     4,     0,     2,     1,     1,     3,     5,
       5,     3,     1,     1,     3,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     2,     2,     2,     2,     4,     4,     4,     5,     5,
       5,     1,     3,     3,     4,     4,     3,     2,     1,     4,
       1,     0,     2,     0,     2,     2,     2,     4,     0,     1,
       2,     2,     2,     2,     2,     2,     2,     2,     0,     3,
       2,     4,     0,     1,     2,     2,     2,     2,     2,     2,
       2,     0,     3,     2,     4,     1,     2,     1,     1,     1,
       0,     2,     0,     3,     1,     2,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     0,     3,     2,     4,
       5,     2,     0,     2,     2,     3,     1,     1,     1,     1,
       1,     1,     1,     3,     2,     1,     1,     1,     4,     6,
       2,     1,     2,     3,     1,     1,     1,     0,     5,     2,
       1,     1,     1,     0,     2,     0,     2,     2,     4,     4,
       3,     4,     1,     1,     1,     3,     5,     1,     1,     1,
       3,     2,     2,     1,     1,     2,     1,     1,     1,     1,
       1,     1,     3,     3,     1,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     4,     5,     5,     5,     4,     4,
       3,     3,     3,     3,     3,     3,     3,     4,     4,     4,
       4,     4,     4,     4,     4,     4,     1,     4,     4,     4,
       4,     4,     4,     4,     4,     5,     5,     5,     4,     4,
       4,     4,     3,     3,     3,     3,     3,     1,     4,     1,
       3,     2,     2,     3,     3,     2,     2,     3,     3,     1,
       3,     3,     3,     4,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       4,     1,     4,     2,     1,     3,     2,     0,     2,     0,
       2,     1,     2,     3,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     4,     1,     3,     2,     4,     2,     3,
       1,     1,     5,     5,     4,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     2,     2,     1,     1,
       2,     1,     1,     4,     3,     4,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     2,     1,     3,     3,     2,     3,
       3,     1,     1,     3,     3,     3,     0,     2,     5,     2,
       1,     1,     1,     1,     1,     2,     0,     2,     1,     2,
       1,     1,     2,     2,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     0,     1,     1,
       1,     2,     1,     2,     2,     2,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     1,     1,     2,     2,
       2,     0,     2,     0,     3,     3,     1,     2,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     2,     2,
       2,     1,     1,     1,     1,     1,     2,     0,     2,     0,
       1,     7,     2,     2,     2,     1,     1,     1,     1,     3,
       2,     4,     0,     2,     1,     1,     2,     2,     1,     1,
       1,     1,     3,     1,     2,     2,     1,     3,     3,     3,
       1,     1,     3,     3,     2,     1,     1,     1,     2,     1,
       1,     2,     1,     1,     1,     0,     2,     0,     2,     0,
       3,     1,     2,     2,     1,     3,     1,     2,     1,     0,
       3,     1,     1,     1,     1,     2,     0,     5,     2,     3,
       0,     2,     2,     2,     3,     3,     3,     1,     1,     3,
       2,     3,     2,     2,     2,     2,     3,     1,     2,     1,
       1,     1,     1,     0,     5,     2,     2,     2,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (&yylloc, parser, retval, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)                                \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;        \
          (Current).first_column = YYRHSLOC (Rhs, 1).first_column;      \
          (Current).last_line    = YYRHSLOC (Rhs, N).last_line;         \
          (Current).last_column  = YYRHSLOC (Rhs, N).last_column;       \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).first_line   = (Current).last_line   =              \
            YYRHSLOC (Rhs, 0).last_line;                                \
          (Current).first_column = (Current).last_column =              \
            YYRHSLOC (Rhs, 0).last_column;                              \
        }                                                               \
    while (0)
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K])


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL

/* Print *YYLOCP on YYO.  Private, do not rely on its existence. */

YY_ATTRIBUTE_UNUSED
static int
yy_location_print_ (FILE *yyo, YYLTYPE const * const yylocp)
{
  int res = 0;
  int end_col = 0 != yylocp->last_column ? yylocp->last_column - 1 : 0;
  if (0 <= yylocp->first_line)
    {
      res += YYFPRINTF (yyo, "%d", yylocp->first_line);
      if (0 <= yylocp->first_column)
        res += YYFPRINTF (yyo, ".%d", yylocp->first_column);
    }
  if (0 <= yylocp->last_line)
    {
      if (yylocp->first_line < yylocp->last_line)
        {
          res += YYFPRINTF (yyo, "-%d", yylocp->last_line);
          if (0 <= end_col)
            res += YYFPRINTF (yyo, ".%d", end_col);
        }
      else if (0 <= end_col && yylocp->first_column < end_col)
        res += YYFPRINTF (yyo, "-%d", end_col);
    }
  return res;
 }

#  define YY_LOCATION_PRINT(File, Loc)          \
  yy_location_print_ (File, &(Loc))

# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value, Location, parser, retval); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  FILE *yyoutput = yyo;
  YYUSE (yyoutput);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyo, yytoknum[yytype], *yyvaluep);
# endif
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp, Lily_parser *parser, SCM *retval)
{
  YYFPRINTF (yyo, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  YY_LOCATION_PRINT (yyo, *yylocationp);
  YYFPRINTF (yyo, ": ");
  yy_symbol_value_print (yyo, yytype, yyvaluep, yylocationp, parser, retval);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule, Lily_parser *parser, SCM *retval)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &yyvsp[(yyi + 1) - (yynrhs)]
                       , &(yylsp[(yyi + 1) - (yynrhs)])                       , parser, retval);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, yylsp, Rule, parser, retval); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
#  else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                yy_state_t *yyssp, int yytoken)
{
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Actual size of YYARG. */
  int yycount = 0;
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      YYPTRDIFF_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
      yysize = yysize0;
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYPTRDIFF_T yysize1
                    = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
                    yysize = yysize1;
                  else
                    return 2;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    /* Don't count the "%s"s in the final size, but reserve room for
       the terminator.  */
    YYPTRDIFF_T yysize1 = yysize + (yystrlen (yyformat) - 2 * yycount) + 1;
    if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
      yysize = yysize1;
    else
      return 2;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp, Lily_parser *parser, SCM *retval)
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);
  YYUSE (parser);
  YYUSE (retval);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/*----------.
| yyparse.  |
`----------*/

int
yyparse (Lily_parser *parser, SCM *retval)
{
/* The lookahead symbol.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

/* Location data for the lookahead symbol.  */
static YYLTYPE yyloc_default
# if defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL
  = { 1, 1, 1, 1 }
# endif
;
YYLTYPE yylloc = yyloc_default;

    /* Number of syntax errors so far.  */
    int yynerrs;

    yy_state_fast_t yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.
       'yyls': related to locations.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss;
    yy_state_t *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[3];

    YYPTRDIFF_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yylsp = yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  yylsp[0] = yylloc;
  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    goto yyexhaustedlab;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;
        YYLTYPE *yyls1 = yyls;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yyls1, yysize * YYSIZEOF (*yylsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
        yyls = yyls1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
        YYSTACK_RELOCATE (yyls_alloc, yyls);
# undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex (&yylval, &yylloc, parser);
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END
  *++yylsp = yylloc;

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location. */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  yyerror_range[1] = yyloc;
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 3:
#line 393 "parser.yy"
                        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3123 "./out/parser.cc"
    break;

  case 4:
#line 395 "parser.yy"
                            {
		parser->lexer_->pop_state ();
                *retval = yyvsp[0];
 	}
#line 3132 "./out/parser.cc"
    break;

  case 5:
#line 401 "parser.yy"
                            { yyval = SCM_UNSPECIFIED; }
#line 3138 "./out/parser.cc"
    break;

  case 6:
#line 402 "parser.yy"
                                       {
	}
#line 3145 "./out/parser.cc"
    break;

  case 7:
#line 404 "parser.yy"
                              {
	}
#line 3152 "./out/parser.cc"
    break;

  case 8:
#line 406 "parser.yy"
                         {
		parser->error_level_ = 1;
	}
#line 3160 "./out/parser.cc"
    break;

  case 9:
#line 409 "parser.yy"
                                {
		parser->error_level_ = 1;
	}
#line 3168 "./out/parser.cc"
    break;

  case 10:
#line 416 "parser.yy"
                     {
		parser->lexer_->set_identifier (ly_symbol2scm ("$defaultheader"), yyvsp[0]);
	}
#line 3176 "./out/parser.cc"
    break;

  case 11:
#line 419 "parser.yy"
                     {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-book-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3185 "./out/parser.cc"
    break;

  case 12:
#line 423 "parser.yy"
                         {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3194 "./out/parser.cc"
    break;

  case 13:
#line 427 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier
			(unsmob<Book>(yyvsp[0])->paper_
			 ? "toplevel-book-handler"
			 : "toplevel-bookpart-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3206 "./out/parser.cc"
    break;

  case 14:
#line 434 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3215 "./out/parser.cc"
    break;

  case 15:
#line 438 "parser.yy"
                          {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-music-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3224 "./out/parser.cc"
    break;

  case 16:
#line 442 "parser.yy"
                      {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, scm_list_1 (yyvsp[0]));
	}
#line 3233 "./out/parser.cc"
    break;

  case 17:
#line 446 "parser.yy"
                           {
		SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
		scm_call_1 (proc, yyvsp[0]);
	}
#line 3242 "./out/parser.cc"
    break;

  case 18:
#line 450 "parser.yy"
                    {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3251 "./out/parser.cc"
    break;

  case 19:
#line 455 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-text-handler");
			scm_call_1 (proc, out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("toplevel-score-handler");
			scm_call_1 (proc, yyvsp[0]);
		} else if (Output_def * od = unsmob<Output_def> (yyvsp[0])) {
			SCM id = SCM_EOL;

			if (to_boolean (od->c_variable ("is-paper")))
				id = ly_symbol2scm ("$defaultpaper");
			else if (to_boolean (od->c_variable ("is-midi")))
				id = ly_symbol2scm ("$defaultmidi");
			else if (to_boolean (od->c_variable ("is-layout")))
				id = ly_symbol2scm ("$defaultlayout");

			parser->lexer_->set_identifier (id, yyvsp[0]);
		} else if (ly_is_module (yyvsp[0]))
		{
			SCM module = get_header (parser);
			ly_module_copy (module, yyvsp[0]);
			parser->lexer_->set_identifier
				(ly_symbol2scm ("$defaultheader"), module);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3290 "./out/parser.cc"
    break;

  case 20:
#line 489 "parser.yy"
                     {
		SCM id = SCM_EOL;
		Output_def * od = unsmob<Output_def> (yyvsp[0]);

		if (to_boolean (od->c_variable ("is-paper")))
			id = ly_symbol2scm ("$defaultpaper");
		else if (to_boolean (od->c_variable ("is-midi")))
			id = ly_symbol2scm ("$defaultmidi");
		else if (to_boolean (od->c_variable ("is-layout")))
			id = ly_symbol2scm ("$defaultlayout");

		parser->lexer_->set_identifier (id, yyvsp[0]);
	}
#line 3308 "./out/parser.cc"
    break;

  case 22:
#line 507 "parser.yy"
        {
		yyval = loc_on_copy (parser, (yyloc),
				  nested_property (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 3317 "./out/parser.cc"
    break;

  case 23:
#line 515 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3325 "./out/parser.cc"
    break;

  case 29:
#line 530 "parser.yy"
        {
		yyval = parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3333 "./out/parser.cc"
    break;

  case 47:
#line 570 "parser.yy"
                                      {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 3342 "./out/parser.cc"
    break;

  case 48:
#line 578 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 3350 "./out/parser.cc"
    break;

  case 50:
#line 583 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 3358 "./out/parser.cc"
    break;

  case 51:
#line 590 "parser.yy"
        {
		// FIXME: @$ does not contain a useful source location
		// for empty rules, and the only token in the whole
		// production, EMBEDDED_LILY, is synthetic and also
		// contains no source location.
		yyval = MAKE_SYNTAX (void_music, (yyloc));
	}
#line 3370 "./out/parser.cc"
    break;

  case 54:
#line 600 "parser.yy"
        {
		if (!unsmob<Music> (yyvsp[0]))
			yyval = MY_MAKE_MUSIC ("PostEvents", (yyloc))->unprotect ();
	}
#line 3379 "./out/parser.cc"
    break;

  case 55:
#line 605 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0])) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
			n->set_property ("duration", yyvsp[-1]);
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 3395 "./out/parser.cc"
    break;

  case 56:
#line 616 "parser.yy"
                                                   {
		SCM tail = SCM_EOL;
		if (unsmob<Music> (yyvsp[-2]))
			tail = scm_cons (yyvsp[-2], tail);
		if (unsmob<Music> (yyvsp[-1]))
			tail = scm_cons (yyvsp[-1], tail);
		yyval = reverse_music_list (parser, (yyloc),
					 scm_append_x (scm_list_2 (yyvsp[0], tail)),
					 true, true);
		if (scm_is_pair (yyval)) // unpackaged list
			if (scm_is_null (scm_cdr (yyval)))
				yyval = scm_car (yyval); // single expression
			else
				yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyval);
		else if (scm_is_null (yyval))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		// else already packaged post-event
	}
#line 3418 "./out/parser.cc"
    break;

  case 57:
#line 634 "parser.yy"
                {
		parser->error_level_ = 1;
                yyval = SCM_UNSPECIFIED;
	}
#line 3427 "./out/parser.cc"
    break;

  case 58:
#line 638 "parser.yy"
                                    {
		parser->error_level_ = 1;
                yyval = yyvsp[0];
	}
#line 3436 "./out/parser.cc"
    break;

  case 59:
#line 646 "parser.yy"
                    { yyval = SCM_UNSPECIFIED; }
#line 3442 "./out/parser.cc"
    break;

  case 60:
#line 647 "parser.yy"
                                           {

	}
#line 3450 "./out/parser.cc"
    break;

  case 61:
#line 650 "parser.yy"
                                         {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3459 "./out/parser.cc"
    break;

  case 62:
#line 654 "parser.yy"
                                                   {
		if (ly_is_module (yyvsp[0]))
			ly_module_copy (scm_current_module (), yyvsp[0]);
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3470 "./out/parser.cc"
    break;

  case 63:
#line 663 "parser.yy"
                                                {
		yyval = parser->lexer_->remove_scope ();
	}
#line 3478 "./out/parser.cc"
    break;

  case 64:
#line 669 "parser.yy"
        {
		parser->lexer_->add_scope (get_header (parser));
	}
#line 3486 "./out/parser.cc"
    break;

  case 65:
#line 671 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 3494 "./out/parser.cc"
    break;

  case 66:
#line 681 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3502 "./out/parser.cc"
    break;

  case 67:
#line 685 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 3510 "./out/parser.cc"
    break;

  case 68:
#line 691 "parser.yy"
                                           {
	        parser->lexer_->set_identifier (yyvsp[-2], yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3519 "./out/parser.cc"
    break;

  case 69:
#line 695 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3529 "./out/parser.cc"
    break;

  case 70:
#line 700 "parser.yy"
                                                              {
		SCM path = scm_cons (yyvsp[-4], yyvsp[-2]);
		parser->lexer_->set_identifier (path, yyvsp[0]);
                yyval = SCM_UNSPECIFIED;
	}
#line 3539 "./out/parser.cc"
    break;

  case 71:
#line 706 "parser.yy"
        {
		if (scm_is_false (Lily::markup_function_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("Not a markup function"));
		} else {
			Lily::define_markup_command_internal
				(scm_string_to_symbol (yyvsp[-2]), yyvsp[0]);
		}
		yyval = SCM_UNSPECIFIED;
	}
#line 3554 "./out/parser.cc"
    break;

  case 74:
#line 723 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3562 "./out/parser.cc"
    break;

  case 75:
#line 727 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 3570 "./out/parser.cc"
    break;

  case 76:
#line 731 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (Music *m = unsmob<Music> (yyvsp[-1]))
		{
			if (m->is_mus_type ("post-event-wrapper"))
				yyval = scm_append
					(scm_list_2 (m->get_property ("elements"),
						     yyval));
			else
				yyval = scm_cons (yyvsp[-1], yyval);
		}
		if (scm_is_pair (yyval)
		    && scm_is_null (scm_cdr (yyval)))
			yyval = scm_car (yyval);
		else
		{
			Music * m = MY_MAKE_MUSIC ("PostEvents", (yyloc));
			m->set_property ("elements", yyval);
			yyval = m->unprotect ();
		}
	}
#line 3596 "./out/parser.cc"
    break;

  case 91:
#line 770 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_music_function, (yyloc),
				  scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 3605 "./out/parser.cc"
    break;

  case 92:
#line 780 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3613 "./out/parser.cc"
    break;

  case 93:
#line 784 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3621 "./out/parser.cc"
    break;

  case 94:
#line 788 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 3629 "./out/parser.cc"
    break;

  case 95:
#line 792 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3637 "./out/parser.cc"
    break;

  case 96:
#line 796 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3645 "./out/parser.cc"
    break;

  case 97:
#line 800 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-3], yyvsp[-1], yyvsp[0]);
	}
#line 3653 "./out/parser.cc"
    break;

  case 98:
#line 804 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3661 "./out/parser.cc"
    break;

  case 99:
#line 808 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3669 "./out/parser.cc"
    break;

  case 100:
#line 812 "parser.yy"
        {
		yyval = scm_acons (yyvsp[-4], yyvsp[-1], yyvsp[0]);
	}
#line 3677 "./out/parser.cc"
    break;

  case 102:
#line 820 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override_function,
					     scm_cdr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3691 "./out/parser.cc"
    break;

  case 103:
#line 830 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set_function,
					     scm_cadr (yyvsp[-1]), scm_car (yyvsp[-1])),
				 SCM_EOL);
	}
#line 3705 "./out/parser.cc"
    break;

  case 104:
#line 840 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_override_function,
					     scm_cdr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3719 "./out/parser.cc"
    break;

  case 105:
#line 850 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_list_1 (SCM_BOOL_F);
		else
			yyval = scm_cons
				(scm_list_3 (Syntax::property_set_function,
					     scm_cadr (yyvsp[-2]), scm_car (yyvsp[-2])),
				 yyvsp[0]);
	}
#line 3733 "./out/parser.cc"
    break;

  case 106:
#line 861 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyvsp[-2] = SCM_INUM0;
		yyvsp[0] = MAKE_SYNTAX (partial_markup, (yylsp[0]), yyvsp[0]);
		parser->lexer_->pop_state ();
// This relies on partial_function always being followed by ETC
		yyval = scm_list_1 (scm_list_3 (MAKE_SYNTAX (partial_text_script, (yyloc), yyvsp[0]),
					     yyvsp[0], yyvsp[-2]));
	}
#line 3747 "./out/parser.cc"
    break;

  case 107:
#line 871 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[-1]))
			yyvsp[-1] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[-1]), yyvsp[0]);
	}
#line 3757 "./out/parser.cc"
    break;

  case 108:
#line 877 "parser.yy"
        {
		if (SCM_UNBNDP (yyvsp[0]))
			yyvsp[0] = SCM_INUM0;
		yyval = scm_acons (Syntax::create_script_function, scm_list_1 (yyvsp[0]), SCM_EOL);
	}
#line 3767 "./out/parser.cc"
    break;

  case 109:
#line 886 "parser.yy"
        {
		yyval = yyvsp[-1];
		Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
		td->origin ()->set_spot ((yyloc));
	}
#line 3781 "./out/parser.cc"
    break;

  case 111:
#line 900 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 3789 "./out/parser.cc"
    break;

  case 112:
#line 904 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 3798 "./out/parser.cc"
    break;

  case 113:
#line 912 "parser.yy"
             {
		yyval = SCM_UNSPECIFIED;
	}
#line 3806 "./out/parser.cc"
    break;

  case 114:
#line 915 "parser.yy"
                                            {
		if (!SCM_UNBNDP (yyvsp[0])) {
			Context_def *td = unsmob<Context_def> (yyval);
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			unsmob<Context_def> (yyval)->add_context_mod (yyvsp[0]);
		}
	}
#line 3821 "./out/parser.cc"
    break;

  case 115:
#line 925 "parser.yy"
                                                     {
                Context_def *td = unsmob<Context_def> (yyval);
		if (!td) {
			yyval = Context_def::make_scm ();
			td = unsmob<Context_def> (yyval);
		}
                SCM new_mods = unsmob<Context_mod> (yyvsp[0])->get_mods ();
                for (SCM m = new_mods; scm_is_pair (m); m = scm_cdr (m)) {
                    td->add_context_mod (scm_car (m));
                }
	}
#line 3837 "./out/parser.cc"
    break;

  case 116:
#line 936 "parser.yy"
                                                {
		Context_def *td = unsmob<Context_def> (yyvsp[-1]);
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			;
		else if (!td && unsmob<Context_def> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			if (!td) {
				yyval = Context_def::make_scm ();
				td = unsmob<Context_def> (yyval);
			}
			if (unsmob<Music> (yyvsp[0])) {
				SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
				yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
			}
			if (Context_mod *cm = unsmob<Context_mod> (yyvsp[0])) {
				for (SCM m = cm->get_mods (); scm_is_pair (m); m = scm_cdr (m)) {
					td->add_context_mod (scm_car (m));
				}
			} else
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
		}
	}
#line 3865 "./out/parser.cc"
    break;

  case 117:
#line 964 "parser.yy"
                                {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		pop_paper (parser);
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), SCM_BOOL_F);
	}
#line 3876 "./out/parser.cc"
    break;

  case 118:
#line 976 "parser.yy"
        {
		Book *book = new Book;
		init_papers (parser);
		book->paper_ = dynamic_cast<Output_def*> (unsmob<Output_def> (parser->lexer_->lookup_identifier ("$defaultpaper"))->clone ());
		book->paper_->unprotect ();
		push_paper (parser, book->paper_);
		book->header_ = get_header (parser);
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyval);
	}
#line 3891 "./out/parser.cc"
    break;

  case 119:
#line 986 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-book"), yyvsp[0]);
	}
#line 3899 "./out/parser.cc"
    break;

  case 120:
#line 989 "parser.yy"
                                {
		unsmob<Book> (yyvsp[-1])->paper_ = unsmob<Output_def> (yyvsp[0]);
		set_paper (parser, unsmob<Output_def> (yyvsp[0]));
	}
#line 3908 "./out/parser.cc"
    break;

  case 121:
#line 993 "parser.yy"
                                   {
		SCM proc = parser->lexer_->lookup_identifier ("book-bookpart-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3917 "./out/parser.cc"
    break;

  case 122:
#line 997 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3926 "./out/parser.cc"
    break;

  case 123:
#line 1001 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("book-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3935 "./out/parser.cc"
    break;

  case 124:
#line 1005 "parser.yy"
                                {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 3944 "./out/parser.cc"
    break;

  case 125:
#line 1009 "parser.yy"
                                     {
		SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 3953 "./out/parser.cc"
    break;

  case 126:
#line 1013 "parser.yy"
                              {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 3962 "./out/parser.cc"
    break;

  case 127:
#line 1018 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("book-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
				set_paper (parser, od);
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0]))
		{
			ly_module_copy (unsmob<Book> (yyvsp[-1])->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 3994 "./out/parser.cc"
    break;

  case 128:
#line 1046 "parser.yy"
        {
		parser->lexer_->add_scope (unsmob<Book> (yyvsp[0])->header_);
	}
#line 4002 "./out/parser.cc"
    break;

  case 130:
#line 1049 "parser.yy"
                          {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
		book->bookparts_ = SCM_EOL;
	}
#line 4013 "./out/parser.cc"
    break;

  case 131:
#line 1058 "parser.yy"
                                       {
		yyval = yyvsp[-1];
		unsmob<Book> (yyval)->origin ()->set_spot ((yyloc));
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), SCM_BOOL_F);
	}
#line 4023 "./out/parser.cc"
    break;

  case 132:
#line 1066 "parser.yy"
        {
		Book *book = new Book;
                yyval = book->unprotect ();
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyval);
	}
#line 4033 "./out/parser.cc"
    break;

  case 133:
#line 1071 "parser.yy"
                          {
		parser->lexer_->set_identifier (ly_symbol2scm ("$current-bookpart"), yyvsp[0]);
	}
#line 4041 "./out/parser.cc"
    break;

  case 134:
#line 1074 "parser.yy"
                                    {
		unsmob<Book> (yyval)->paper_ = unsmob<Output_def> (yyvsp[0]);
	}
#line 4049 "./out/parser.cc"
    break;

  case 135:
#line 1077 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4058 "./out/parser.cc"
    break;

  case 136:
#line 1081 "parser.yy"
                                        {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-music-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4067 "./out/parser.cc"
    break;

  case 137:
#line 1085 "parser.yy"
                                    {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], scm_list_1 (yyvsp[0]));
	}
#line 4076 "./out/parser.cc"
    break;

  case 138:
#line 1089 "parser.yy"
                                         {
		SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
		scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
	}
#line 4085 "./out/parser.cc"
    break;

  case 139:
#line 1093 "parser.yy"
                                  {
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4094 "./out/parser.cc"
    break;

  case 140:
#line 1098 "parser.yy"
        {
		SCM out = SCM_UNDEFINED;
		if (Text_interface::is_markup (yyvsp[0]))
			out = scm_list_1 (yyvsp[0]);
		else if (Text_interface::is_markup_list (yyvsp[0]))
			out = yyvsp[0];
		if (scm_is_pair (out))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-text-handler");
			scm_call_2 (proc, yyvsp[-1], out);
		} else if (unsmob<Score> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier ("bookpart-score-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (Output_def *od = unsmob<Output_def> (yyvsp[0])) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper")))) {
				unsmob<Book> (yyvsp[-1])->paper_ = od;
			} else {
				parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			}
		} else if (ly_is_module (yyvsp[0])) {
			Book *book = unsmob<Book> (yyvsp[-1]);
			if (!ly_is_module (book->header_))
				book->header_ = ly_make_module (false);
			ly_module_copy (book->header_, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
	}
#line 4127 "./out/parser.cc"
    break;

  case 141:
#line 1127 "parser.yy"
        {
                Book *book = unsmob<Book> (yyvsp[0]);
		if (!ly_is_module (book->header_))
			book->header_ = ly_make_module (false);
		parser->lexer_->add_scope (book->header_);
	}
#line 4138 "./out/parser.cc"
    break;

  case 143:
#line 1133 "parser.yy"
                              {
                Book *book = unsmob<Book> (yyvsp[-1]);
		book->paper_ = 0;
		book->scores_ = SCM_EOL;
	}
#line 4148 "./out/parser.cc"
    break;

  case 144:
#line 1141 "parser.yy"
                                        {
		unsmob<Score> (yyvsp[-1])->origin ()->set_spot ((yyloc));
		yyval = yyvsp[-1];
	}
#line 4157 "./out/parser.cc"
    break;

  case 145:
#line 1148 "parser.yy"
                    {
		if (!unsmob<Score> (yyvsp[0])) {
			parser->parser_error ((yylsp[0]), _("Missing music in \\score"));
			yyval = (new Score)->unprotect ();
			if (scm_is_pair (yyvsp[0]) && ly_is_module (scm_car (yyvsp[0])))
			{
				unsmob<Score> (yyval)->set_header (scm_car (yyvsp[0]));
				yyvsp[0] = scm_cdr (yyvsp[0]);
			}
			for (SCM p = scm_reverse_x (yyvsp[0], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				unsmob<Score> (yyval)->
					add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
	}
#line 4179 "./out/parser.cc"
    break;

  case 146:
#line 1165 "parser.yy"
                           {
		unsmob<Score> (yyval)->error_found_ = true;
	}
#line 4187 "./out/parser.cc"
    break;

  case 150:
#line 1178 "parser.yy"
        {
		yyval = SCM_EOL;
	}
#line 4195 "./out/parser.cc"
    break;

  case 151:
#line 1182 "parser.yy"
        {
		Output_def *od = unsmob<Output_def> (yyvsp[0]);
		if (od) {
			if (to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
			{
				parser->parser_error ((yylsp[0]), _("\\paper cannot be used in \\score, use \\layout instead"));
				od = 0;
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		} else if (!unsmob<Score> (yyval)) {
			if (unsmob<Music> (yyvsp[0])) {
				yyvsp[0] = Lily::scorify_music (yyvsp[0]);
			}
			if (unsmob<Score> (yyvsp[0]))
			{
				yyval = yyvsp[0];
				yyvsp[0] = SCM_UNSPECIFIED;
			}
		}
		Score *score = unsmob<Score> (yyval);
		if (score && scm_is_pair (yyvsp[-1])) {
			if (ly_is_module (scm_car (yyvsp[-1])))
			{
				score->set_header (scm_car (yyvsp[-1]));
				yyvsp[-1] = scm_cdr (yyvsp[-1]);
			}
			for (SCM p = scm_reverse_x (yyvsp[-1], SCM_EOL);
			     scm_is_pair (p); p = scm_cdr (p))
			{
				score->add_output_def (unsmob<Output_def> (scm_car (p)));
			}
		}
		if (od) {
			if (score)
				score->add_output_def (od);
			else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				scm_set_cdr_x (yyval, scm_cons (yyvsp[0], scm_cdr (yyval)));
			else
				yyval = scm_cons (yyvsp[0], yyval);
		} else if (ly_is_module (yyvsp[0])) {
			SCM module = SCM_UNSPECIFIED;
			if (score) {
				module = score->get_header ();
				if (!ly_is_module (module))
				{
					module = ly_make_module (false);
					score->set_header (module);
				}
			} else if (scm_is_pair (yyval) && ly_is_module (scm_car (yyval)))
				module = scm_car (yyval);
			else {
				module = ly_make_module (false);
				yyval = scm_cons (module, yyval);
			}
			ly_module_copy (module, yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("Spurious expression in \\score"));
	}
#line 4258 "./out/parser.cc"
    break;

  case 152:
#line 1241 "parser.yy"
        {
		if (Score *score = unsmob<Score> (yyvsp[0])) {
			if (!ly_is_module (score->get_header ()))
				score->set_header (ly_make_module (false));
			parser->lexer_->add_scope (score->get_header ());
		} else {
			if (!scm_is_pair (yyvsp[0]) || !ly_is_module (scm_car (yyvsp[0])))
				yyvsp[0] = scm_cons (ly_make_module (false), yyvsp[0]);
			parser->lexer_->add_scope (scm_car (yyvsp[0]));
		}
	}
#line 4274 "./out/parser.cc"
    break;

  case 153:
#line 1252 "parser.yy"
        {
		yyval = yyvsp[-2];
	}
#line 4282 "./out/parser.cc"
    break;

  case 154:
#line 1263 "parser.yy"
                   {
                Output_def *od = unsmob<Output_def> (yyvsp[0]);

		if (!to_boolean (od->lookup_variable (ly_symbol2scm ("is-paper"))))
		{
			parser->parser_error ((yylsp[0]), _ ("need \\paper for paper block"));
			yyval = get_paper (parser)->unprotect ();
		}
	}
#line 4296 "./out/parser.cc"
    break;

  case 155:
#line 1276 "parser.yy"
                            {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);

		parser->lexer_->remove_scope ();
		parser->lexer_->pop_state ();
	}
#line 4308 "./out/parser.cc"
    break;

  case 156:
#line 1286 "parser.yy"
              {
                Output_def *p = get_paper (parser);
		p->input_origin_ = (yyloc);
		parser->lexer_->add_scope (p->scope_);
                yyval = p->unprotect ();
	}
#line 4319 "./out/parser.cc"
    break;

  case 157:
#line 1292 "parser.yy"
                  {
		Output_def *p = get_midi (parser);
		yyval = p->unprotect ();
		parser->lexer_->add_scope (p->scope_);
	}
#line 4329 "./out/parser.cc"
    break;

  case 158:
#line 1297 "parser.yy"
                        {
		Output_def *p = get_layout (parser);

		parser->lexer_->add_scope (p->scope_);
		yyval = p->unprotect ();
	}
#line 4340 "./out/parser.cc"
    break;

  case 159:
#line 1306 "parser.yy"
                        {
		parser->lexer_->push_initial_state ();
		yyval = yyvsp[0];
	}
#line 4349 "./out/parser.cc"
    break;

  case 162:
#line 1323 "parser.yy"
                                             {
		unsmob<Output_def> (yyvsp[-1])->input_origin_.set_spot ((yyloc));
		// This is a stupid trick to mark the beginning of the
		// body for deciding whether to allow
		// embedded_scm_active to have an output definition
		yyval = scm_list_1 (yyvsp[-1]);
	}
#line 4361 "./out/parser.cc"
    break;

  case 163:
#line 1330 "parser.yy"
                                      {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
	}
#line 4370 "./out/parser.cc"
    break;

  case 164:
#line 1335 "parser.yy"
        {
		// We don't switch into note mode for Scheme functions
		// here.  Does not seem warranted/required in output
		// definitions.
		if (scm_is_pair (yyvsp[-1]))
		{
			Output_def *o = unsmob<Output_def> (yyvsp[0]);
			if (o) {
				o->input_origin_.set_spot ((yyloc));
				yyvsp[-1] = o->self_scm ();
				parser->lexer_->remove_scope ();
				parser->lexer_->add_scope (o->scope_);
				yyvsp[0] = SCM_UNSPECIFIED;
			} else
				yyvsp[-1] = scm_car (yyvsp[-1]);
		}
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-1]), yyvsp[0]);
		// Seems unlikely, but let's be complete:
		else if (unsmob<Music> (yyvsp[0]))
		{
			SCM proc = parser->lexer_->lookup_identifier
				("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-1], yyvsp[0]);
		} else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _("bad expression type"));
		yyval = yyvsp[-1];
	}
#line 4403 "./out/parser.cc"
    break;

  case 165:
#line 1363 "parser.yy"
                                    {
		if (scm_is_pair (yyvsp[-1]))
			yyval = scm_car (yyvsp[-1]);
		// Evaluate and ignore #xxx, as opposed to \xxx
		parser->lexer_->eval_scm_token (yyvsp[0], (yylsp[0]));
	}
#line 4414 "./out/parser.cc"
    break;

  case 166:
#line 1370 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyvsp[0] = scm_car (yyvsp[0]);
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4424 "./out/parser.cc"
    break;

  case 167:
#line 1375 "parser.yy"
        {
		parser->lexer_->pop_state ();
		if (unsmob<Context_def> (yyvsp[0]))
			assign_context_def (unsmob<Output_def> (yyvsp[-2]), yyvsp[0]);
		else {

			SCM proc = parser->lexer_->lookup_identifier
				     ("output-def-music-handler");
			scm_call_2 (proc, yyvsp[-2], yyvsp[0]);
		}
		yyval = yyvsp[-2];
	}
#line 4441 "./out/parser.cc"
    break;

  case 168:
#line 1387 "parser.yy"
                                {

	}
#line 4449 "./out/parser.cc"
    break;

  case 169:
#line 1393 "parser.yy"
                                                {
		yyval = MAKE_SYNTAX (tempo, (yyloc), SCM_EOL, yyvsp[-2], yyvsp[0]);
	}
#line 4457 "./out/parser.cc"
    break;

  case 170:
#line 1396 "parser.yy"
                                                        {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4465 "./out/parser.cc"
    break;

  case 171:
#line 1399 "parser.yy"
                     {
		yyval = MAKE_SYNTAX (tempo, (yyloc), yyvsp[0]);
	}
#line 4473 "./out/parser.cc"
    break;

  case 172:
#line 1408 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 4481 "./out/parser.cc"
    break;

  case 173:
#line 1411 "parser.yy"
                                    {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 4490 "./out/parser.cc"
    break;

  case 174:
#line 1415 "parser.yy"
                           {
		Music *m = MY_MAKE_MUSIC("Music", (yyloc));
		// ugh. code dup
		m->set_property ("error-found", SCM_BOOL_T);
		yyval = scm_cons (m->self_scm (), yyvsp[-1]);
		m->unprotect (); /* UGH */
	}
#line 4502 "./out/parser.cc"
    break;

  case 175:
#line 1426 "parser.yy"
        {
		yyval = reverse_music_list (parser, (yyloc), yyvsp[-1], true, false);
	}
#line 4510 "./out/parser.cc"
    break;

  case 179:
#line 1438 "parser.yy"
        {
	        yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
                if (!unsmob<Music> (yyval))
		{
                        parser->parser_error ((yylsp[0]), _ ("music expected"));
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		}
	}
#line 4523 "./out/parser.cc"
    break;

  case 182:
#line 1452 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4531 "./out/parser.cc"
    break;

  case 183:
#line 1456 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 4539 "./out/parser.cc"
    break;

  case 184:
#line 1460 "parser.yy"
        {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

		parser->default_duration_ = *unsmob<Duration> (yyvsp[-1]);
		n->set_property ("duration", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0]))
			n->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
		yyval = n->unprotect ();
	}
#line 4555 "./out/parser.cc"
    break;

  case 185:
#line 1475 "parser.yy"
        {
		if (scm_is_eq (yyvsp[0], SCM_UNSPECIFIED)
		    || unsmob<Music> (yyvsp[0]))
			yyval = yyvsp[0];
		else if (parser->lexer_->is_lyric_state ()
			   && Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (LYRIC_ELEMENT, yyvsp[0], (yylsp[0]));
		else {
			(yyloc).warning (_ ("Ignoring non-music expression"));
			yyval = SCM_UNSPECIFIED;
		}
	}
#line 4572 "./out/parser.cc"
    break;

  case 188:
#line 1498 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 4580 "./out/parser.cc"
    break;

  case 189:
#line 1502 "parser.yy"
        {
		yyval = MAKE_SYNTAX (repeat, (yyloc), yyvsp[-4], yyvsp[-3], yyvsp[-2], yyvsp[0]);
	}
#line 4588 "./out/parser.cc"
    break;

  case 190:
#line 1508 "parser.yy"
                                     {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4596 "./out/parser.cc"
    break;

  case 191:
#line 1511 "parser.yy"
                            {
		yyval = MAKE_SYNTAX (sequential_music, (yyloc), yyvsp[0]);
	}
#line 4604 "./out/parser.cc"
    break;

  case 192:
#line 1517 "parser.yy"
                                       {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc), yyvsp[0]);
	}
#line 4612 "./out/parser.cc"
    break;

  case 193:
#line 1520 "parser.yy"
                                                                {
		yyval = MAKE_SYNTAX (simultaneous_music, (yyloc),
				  reverse_music_list (parser, (yyloc), yyvsp[-1],
						      true, false));
	}
#line 4622 "./out/parser.cc"
    break;

  case 197:
#line 1535 "parser.yy"
        {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 4630 "./out/parser.cc"
    break;

  case 198:
#line 1538 "parser.yy"
        {
                parser->lexer_->pop_state ();
                yyval = yyvsp[-1];
        }
#line 4639 "./out/parser.cc"
    break;

  case 199:
#line 1543 "parser.yy"
        {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			yyval = yyvsp[0];
		else {
			// let's permit \with #*unspecified* to go for
			// an empty context mod
			if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
				parser->parser_error ((yylsp[0]), _ ("not a context mod"));
			yyval = Context_mod ().smobbed_copy ();
		}
	}
#line 4659 "./out/parser.cc"
    break;

  case 202:
#line 1571 "parser.yy"
        {
		if (scm_is_pair (yyvsp[0]))
			yyval = scm_append_x (scm_reverse_x (yyvsp[0], SCM_EOL));
        }
#line 4668 "./out/parser.cc"
    break;

  case 203:
#line 1584 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 4676 "./out/parser.cc"
    break;

  case 204:
#line 1588 "parser.yy"
        {
		if (Context_mod *m = unsmob<Context_mod> (yyvsp[0]))
			yyval = scm_cons (m->get_mods (), yyvsp[-1]);
	}
#line 4685 "./out/parser.cc"
    break;

  case 205:
#line 1600 "parser.yy"
             {
            yyval = Context_mod ().smobbed_copy ();
        }
#line 4693 "./out/parser.cc"
    break;

  case 206:
#line 1603 "parser.yy"
                                        {
		if (!SCM_UNBNDP (yyvsp[0]))
			unsmob<Context_mod> (yyvsp[-1])->add_context_mod (yyvsp[0]);
        }
#line 4702 "./out/parser.cc"
    break;

  case 207:
#line 1607 "parser.yy"
                                           {
		if (unsmob<Music> (yyvsp[0])) {
			SCM proc = parser->lexer_->lookup_identifier ("context-mod-music-handler");
			yyvsp[0] = scm_call_1 (proc, yyvsp[0]);
		}
		if (unsmob<Context_mod> (yyvsp[0]))
			unsmob<Context_mod> (yyval)->add_context_mods
				(unsmob<Context_mod> (yyvsp[0])->get_mods ());
		else if (!scm_is_eq (yyvsp[0], SCM_UNSPECIFIED))
			parser->parser_error ((yylsp[0]), _ ("not a context mod"));
        }
#line 4718 "./out/parser.cc"
    break;

  case 208:
#line 1621 "parser.yy"
                                                         {
		yyval = START_MAKE_SYNTAX (context_specification, yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_BOOL_F);
	}
#line 4726 "./out/parser.cc"
    break;

  case 209:
#line 1624 "parser.yy"
                                                              {
		yyval = START_MAKE_SYNTAX (context_specification, yyvsp[-2], yyvsp[-1], yyvsp[0], SCM_BOOL_T);
	}
#line 4734 "./out/parser.cc"
    break;

  case 210:
#line 1630 "parser.yy"
                                                         {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], SCM_EOL);
	}
#line 4742 "./out/parser.cc"
    break;

  case 211:
#line 1633 "parser.yy"
                                                                      {
		yyval = scm_acons (yyvsp[0], yyvsp[-1], yyvsp[-3]);
	}
#line 4750 "./out/parser.cc"
    break;

  case 215:
#line 1658 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], SCM_EOL, yyvsp[0]);
	}
#line 4758 "./out/parser.cc"
    break;

  case 216:
#line 1662 "parser.yy"
        {
		yyval = MAKE_SYNTAX (lyric_combine, (yyloc), yyvsp[-1], yyvsp[-3], yyvsp[0]);
	}
#line 4766 "./out/parser.cc"
    break;

  case 220:
#line 1675 "parser.yy"
        {
		Input i;
		i.set_location ((yylsp[-2]), (yylsp[-1]));
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-2], i, yyvsp[-1]);
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyval, scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 4777 "./out/parser.cc"
    break;

  case 221:
#line 1682 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 4785 "./out/parser.cc"
    break;

  case 222:
#line 1686 "parser.yy"
        {
		yyval = FINISH_MAKE_SYNTAX (yyvsp[-1], (yyloc), yyvsp[0]);
	}
#line 4793 "./out/parser.cc"
    break;

  case 225:
#line 1695 "parser.yy"
        {
		yyval = MAKE_SYNTAX (add_lyrics, (yyloc), yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 4801 "./out/parser.cc"
    break;

  case 229:
#line 1707 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 4807 "./out/parser.cc"
    break;

  case 230:
#line 1708 "parser.yy"
                                        { yyval = yyvsp[0]; }
#line 4813 "./out/parser.cc"
    break;

  case 232:
#line 1767 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 4821 "./out/parser.cc"
    break;

  case 233:
#line 1771 "parser.yy"
        {
		yyval = scm_append (scm_list_2 (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 4829 "./out/parser.cc"
    break;

  case 235:
#line 1779 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 4837 "./out/parser.cc"
    break;

  case 236:
#line 1783 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 4845 "./out/parser.cc"
    break;

  case 238:
#line 1793 "parser.yy"
        {
		yyval = make_reverse_key_list (yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		}
	}
#line 4857 "./out/parser.cc"
    break;

  case 239:
#line 1805 "parser.yy"
        {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 4865 "./out/parser.cc"
    break;

  case 241:
#line 1814 "parser.yy"
        {
		yyval = try_word_variants (Lily::key_list_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval)) {
			parser->parser_error ((yylsp[0]), _("not a key"));
			yyval = SCM_EOL;
		} else
			yyval = scm_reverse (yyval);
	}
#line 4878 "./out/parser.cc"
    break;

  case 242:
#line 1823 "parser.yy"
        {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 4886 "./out/parser.cc"
    break;

  case 244:
#line 1831 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 4894 "./out/parser.cc"
    break;

  case 245:
#line 1835 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			yyval = scm_cons (n, yyvsp[-2]);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = check_scheme_arg (parser, (yylsp[-1]), t->unprotect (),
					       yyvsp[-2], yyvsp[-3], n);
		}
	}
#line 4910 "./out/parser.cc"
    break;

  case 246:
#line 1847 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 4920 "./out/parser.cc"
    break;

  case 247:
#line 1853 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[-1]),
				       scm_difference (yyvsp[0], SCM_UNDEFINED),
				       yyvsp[-2], yyvsp[-3]);
	}
#line 4930 "./out/parser.cc"
    break;

  case 248:
#line 1859 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 4944 "./out/parser.cc"
    break;

  case 249:
#line 1869 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 4952 "./out/parser.cc"
    break;

  case 250:
#line 1873 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 4966 "./out/parser.cc"
    break;

  case 251:
#line 1883 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4974 "./out/parser.cc"
    break;

  case 252:
#line 1887 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4982 "./out/parser.cc"
    break;

  case 253:
#line 1891 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4990 "./out/parser.cc"
    break;

  case 254:
#line 1895 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 4998 "./out/parser.cc"
    break;

  case 255:
#line 1899 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5006 "./out/parser.cc"
    break;

  case 256:
#line 1903 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5014 "./out/parser.cc"
    break;

  case 257:
#line 1911 "parser.yy"
        {
		yyval = make_music_from_simple (parser, (yyloc),
					     make_duration (yyvsp[-3], scm_to_int (yyvsp[-2]), yyvsp[-1]));
		Music *m = unsmob<Music> (yyval);
		assert (m);
		if (scm_is_pair (yyvsp[0]))
			m->set_property ("articulations",
					 scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 5028 "./out/parser.cc"
    break;

  case 258:
#line 1924 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5049 "./out/parser.cc"
    break;

  case 259:
#line 1941 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5064 "./out/parser.cc"
    break;

  case 260:
#line 1952 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5079 "./out/parser.cc"
    break;

  case 261:
#line 1963 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5100 "./out/parser.cc"
    break;

  case 262:
#line 1980 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5121 "./out/parser.cc"
    break;

  case 263:
#line 1997 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple
			   (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], STRING, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5138 "./out/parser.cc"
    break;

  case 264:
#line 2010 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5165 "./out/parser.cc"
    break;

  case 265:
#line 2033 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5181 "./out/parser.cc"
    break;

  case 267:
#line 2052 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = make_music_from_simple (parser, (yylsp[0]), yyvsp[0]);
			if (scm_is_true (scm_call_1 (yyvsp[-2], yyval)))
				yyval = scm_cons (yyval, yyvsp[-1]);
			else
			{
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5200 "./out/parser.cc"
    break;

  case 268:
#line 2067 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (EVENT_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5214 "./out/parser.cc"
    break;

  case 269:
#line 2077 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (PITCH_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5234 "./out/parser.cc"
    break;

  case 270:
#line 2093 "parser.yy"
        {
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		} else if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (TONICNAME_PITCH, yyvsp[0], (yylsp[0]));
		}
	}
#line 5254 "./out/parser.cc"
    break;

  case 271:
#line 2109 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5267 "./out/parser.cc"
    break;

  case 272:
#line 2118 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else {
					yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
					MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				}
			} else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
			}
		}
	}
#line 5298 "./out/parser.cc"
    break;

  case 273:
#line 2145 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = yyvsp[-1];
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (REAL, yyvsp[0], (yylsp[0]));
		}
	}
#line 5313 "./out/parser.cc"
    break;

  case 274:
#line 2156 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
		{
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (NUMBER_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5327 "./out/parser.cc"
    break;

  case 275:
#line 2166 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = yyvsp[-2];
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		} else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			yyval = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], yyval)))
				yyval = scm_cons (yyval, yyvsp[-2]);
			else {
				yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
				MYBACKUP (UNSIGNED, yyvsp[0], (yylsp[0]));
				parser->lexer_->push_extra_token ((yylsp[-1]), '-');
			}
		}
	}
#line 5350 "./out/parser.cc"
    break;

  case 276:
#line 2185 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
			yyval = yyvsp[-2];
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (REAL, n, (yylsp[0]));
		}
	}
#line 5365 "./out/parser.cc"
    break;

  case 277:
#line 2196 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n))) {
			yyval = scm_cons (n, yyvsp[-2]);
		} else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-2]), yyvsp[-4]), yyvsp[-2]);
			MYBACKUP (NUMBER_IDENTIFIER, n, (yylsp[0]));
		}
	}
#line 5379 "./out/parser.cc"
    break;

  case 278:
#line 2206 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (DURATION_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5397 "./out/parser.cc"
    break;

  case 279:
#line 2220 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (SCM_IDENTIFIER, yyvsp[0], (yylsp[0]));
		}
	}
#line 5416 "./out/parser.cc"
    break;

  case 280:
#line 2235 "parser.yy"
        {
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5435 "./out/parser.cc"
    break;

  case 281:
#line 2250 "parser.yy"
        {
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res)) {
				yyval = yyvsp[-1];
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			}
			else
				yyval = scm_cons (res, yyvsp[-1]);
		else {
			yyval = scm_cons (loc_on_copy (parser, (yylsp[-1]), yyvsp[-3]), yyvsp[-1]);
			MYBACKUP (STRING, yyvsp[0], (yylsp[0]));
		}
	}
#line 5454 "./out/parser.cc"
    break;

  case 282:
#line 2265 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5468 "./out/parser.cc"
    break;

  case 283:
#line 2275 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5477 "./out/parser.cc"
    break;

  case 284:
#line 2280 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5486 "./out/parser.cc"
    break;

  case 285:
#line 2285 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5495 "./out/parser.cc"
    break;

  case 286:
#line 2290 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5503 "./out/parser.cc"
    break;

  case 288:
#line 2298 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5511 "./out/parser.cc"
    break;

  case 290:
#line 2306 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5519 "./out/parser.cc"
    break;

  case 291:
#line 2325 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5527 "./out/parser.cc"
    break;

  case 292:
#line 2329 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5535 "./out/parser.cc"
    break;

  case 293:
#line 2333 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5543 "./out/parser.cc"
    break;

  case 294:
#line 2337 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5551 "./out/parser.cc"
    break;

  case 295:
#line 2344 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5559 "./out/parser.cc"
    break;

  case 296:
#line 2348 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5567 "./out/parser.cc"
    break;

  case 297:
#line 2352 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5575 "./out/parser.cc"
    break;

  case 298:
#line 2356 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 5583 "./out/parser.cc"
    break;

  case 299:
#line 2362 "parser.yy"
                            {
		yyval = SCM_EOL;
	}
#line 5591 "./out/parser.cc"
    break;

  case 300:
#line 2366 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-1], yyvsp[-2]);
	}
#line 5605 "./out/parser.cc"
    break;

  case 301:
#line 2376 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5614 "./out/parser.cc"
    break;

  case 302:
#line 2381 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 5623 "./out/parser.cc"
    break;

  case 303:
#line 2386 "parser.yy"
        {
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		yyval = check_scheme_arg (parser, (yylsp[0]), n, yyvsp[-2], yyvsp[-3]);
	}
#line 5632 "./out/parser.cc"
    break;

  case 304:
#line 2391 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5641 "./out/parser.cc"
    break;

  case 305:
#line 2396 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5650 "./out/parser.cc"
    break;

  case 306:
#line 2401 "parser.yy"
        {
		if (scm_is_true (scm_call_1 (yyvsp[-1], yyvsp[0])))
			yyval = scm_cons (yyvsp[0], yyvsp[-2]);
		else
			yyval = check_scheme_arg (parser, (yylsp[0]),
					       make_music_from_simple
					       (parser, (yylsp[0]), yyvsp[0]),
					       yyvsp[-2], yyvsp[-1]);
	}
#line 5664 "./out/parser.cc"
    break;

  case 307:
#line 2411 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5673 "./out/parser.cc"
    break;

  case 308:
#line 2416 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5682 "./out/parser.cc"
    break;

  case 309:
#line 2421 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]),
				       yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5691 "./out/parser.cc"
    break;

  case 310:
#line 2426 "parser.yy"
        {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-2], yyvsp[-1]);
	}
#line 5699 "./out/parser.cc"
    break;

  case 311:
#line 2433 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5721 "./out/parser.cc"
    break;

  case 312:
#line 2451 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], PITCH_IDENTIFIER, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5736 "./out/parser.cc"
    break;

  case 313:
#line 2462 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true
		    (scm_call_1
		     (yyvsp[-2], make_music_from_simple
		      (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], TONICNAME_PITCH, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5751 "./out/parser.cc"
    break;

  case 314:
#line 2473 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_string_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5773 "./out/parser.cc"
    break;

  case 315:
#line 2491 "parser.yy"
        {
		yyval = yyvsp[-1];
		SCM res = try_word_variants (yyvsp[-2], yyvsp[0]);
		if (!SCM_UNBNDP (res))
			if (scm_is_pair (res))
				MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, res);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, res);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5795 "./out/parser.cc"
    break;

  case 316:
#line 2509 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], LYRIC_ELEMENT, yyvsp[0]);
		else
			// This is going to flag a syntax error, we
			// know the predicate to be false.
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]);
	}
#line 5813 "./out/parser.cc"
    break;

  case 317:
#line 2523 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			// May be 3 \cm or similar
			MYREPARSE ((yylsp[0]), yyvsp[-2], REAL, yyvsp[0]);
		else if (scm_is_true (scm_call_1 (yyvsp[-2], scm_list_1 (yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], SYMBOL_LIST, scm_list_1 (yyvsp[0]));
		else {
			SCM d = make_duration (yyvsp[0]);
			if (!SCM_UNBNDP (d)) {
				if (scm_is_true (scm_call_1 (yyvsp[-2], d)))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, d);
				else if (scm_is_true
					 (scm_call_1
					  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), d))))
					MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, d);
				else
					MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
			} else
				MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
		}
	}
#line 5840 "./out/parser.cc"
    break;

  case 318:
#line 2546 "parser.yy"
        {
		yyval = yyvsp[-1];
		if (scm_is_true (scm_call_1 (yyvsp[-2], yyvsp[0])))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_IDENTIFIER, yyvsp[0]);
		else if (scm_is_true
			 (scm_call_1
			  (yyvsp[-2], make_music_from_simple (parser, (yylsp[0]), yyvsp[0]))))
			MYREPARSE ((yylsp[0]), yyvsp[-2], DURATION_ARG, yyvsp[0]);
		else
			MYREPARSE ((yylsp[0]), yyvsp[-2], SCM_ARG, yyvsp[0]); // trigger error
	}
#line 5856 "./out/parser.cc"
    break;

  case 319:
#line 2558 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		if (scm_is_true (scm_call_1 (yyvsp[-3], n)))
			MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
		else {
			Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yylsp[0]));
			t->set_property ("digit", yyvsp[0]);
			SCM m = t->unprotect ();
			if (scm_is_true (scm_call_1 (yyvsp[-3], m)))
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, m);
			else
				MYREPARSE ((yylsp[0]), yyvsp[-3], SCM_ARG, yyvsp[0]);
		}
	}
#line 5876 "./out/parser.cc"
    break;

  case 320:
#line 2574 "parser.yy"
        {
		yyval = yyvsp[-2];
		SCM n = scm_difference (yyvsp[0], SCM_UNDEFINED);
		MYREPARSE ((yylsp[0]), yyvsp[-3], REAL, n);
	}
#line 5886 "./out/parser.cc"
    break;

  case 322:
#line 2584 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-3]), yyvsp[-1]);
	}
#line 5894 "./out/parser.cc"
    break;

  case 325:
#line 2593 "parser.yy"
        {
		yyval = scm_cons (loc_on_copy (parser, (yylsp[0]), yyvsp[-2]), yyvsp[0]);
	}
#line 5902 "./out/parser.cc"
    break;

  case 326:
#line 2599 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 5911 "./out/parser.cc"
    break;

  case 327:
#line 2607 "parser.yy"
             { yyval = SCM_EOL; }
#line 5917 "./out/parser.cc"
    break;

  case 328:
#line 2608 "parser.yy"
                            {
		yyval = yyvsp[0];
	}
#line 5925 "./out/parser.cc"
    break;

  case 329:
#line 2620 "parser.yy"
        {
		parser->lexer_->push_lyric_state ();
	}
#line 5933 "./out/parser.cc"
    break;

  case 330:
#line 2623 "parser.yy"
        {
		parser->lexer_->pop_state ();
		yyval = yyvsp[0];
	}
#line 5942 "./out/parser.cc"
    break;

  case 332:
#line 2631 "parser.yy"
                                              {
		if (scm_is_eq (yyvsp[-1], ly_symbol2scm ("chords")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyvsp[0]);
		}
		else
		{
		  yyval = yyvsp[0];
		}
		parser->lexer_->pop_state ();
	}
#line 5958 "./out/parser.cc"
    break;

  case 333:
#line 2642 "parser.yy"
                                                                                   {
		yyval = MAKE_SYNTAX (context_specification, (yyloc), yyvsp[-2], SCM_EOL, yyvsp[-1], SCM_BOOL_T, yyvsp[0]);
		if (scm_is_eq (yyvsp[-2], ly_symbol2scm ("ChordNames")))
		{
		  yyval = MAKE_SYNTAX (unrelativable_music, (yyloc), yyval);
		}
		parser->lexer_->pop_state ();
	}
#line 5971 "./out/parser.cc"
    break;

  case 334:
#line 2653 "parser.yy"
                 {
		parser->lexer_->push_note_state (Lily::pitchnames);

		yyval = ly_symbol2scm ("notes");
	}
#line 5981 "./out/parser.cc"
    break;

  case 335:
#line 2659 "parser.yy"
                {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("drums");
	}
#line 5991 "./out/parser.cc"
    break;

  case 336:
#line 2664 "parser.yy"
                     {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("figures");
	}
#line 6001 "./out/parser.cc"
    break;

  case 337:
#line 2669 "parser.yy"
                    {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("chords");

	}
#line 6013 "./out/parser.cc"
    break;

  case 338:
#line 2677 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("lyrics");
	}
#line 6021 "./out/parser.cc"
    break;

  case 339:
#line 2683 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::drum_pitch_names);

		yyval = ly_symbol2scm ("DrumStaff");
	}
#line 6031 "./out/parser.cc"
    break;

  case 340:
#line 2688 "parser.yy"
                  {
		parser->lexer_->push_figuredbass_state ();

		yyval = ly_symbol2scm ("FiguredBass");
	}
#line 6041 "./out/parser.cc"
    break;

  case 341:
#line 2693 "parser.yy"
                 {
		parser->lexer_->chordmodifier_tab_ =
			alist_to_hashq (Lily::chordmodifiers);
		parser->lexer_->push_chord_state (Lily::pitchnames);
		yyval = ly_symbol2scm ("ChordNames");
	}
#line 6052 "./out/parser.cc"
    break;

  case 342:
#line 2700 "parser.yy"
                { parser->lexer_->push_lyric_state ();
		yyval = ly_symbol2scm ("Lyrics");
	}
#line 6060 "./out/parser.cc"
    break;

  case 343:
#line 2706 "parser.yy"
                                         {
		yyval = MAKE_SYNTAX (context_change, (yyloc), yyvsp[-2], yyvsp[0]);
	}
#line 6068 "./out/parser.cc"
    break;

  case 344:
#line 2713 "parser.yy"
                         {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 6076 "./out/parser.cc"
    break;

  case 345:
#line 2719 "parser.yy"
                          {
		yyval = scm_list_3 (ly_symbol2scm ("assign"), yyvsp[-2], yyvsp[0]);
	}
#line 6084 "./out/parser.cc"
    break;

  case 346:
#line 2722 "parser.yy"
                       {
		yyval = scm_list_2 (ly_symbol2scm ("unset"), yyvsp[0]);
	}
#line 6092 "./out/parser.cc"
    break;

  case 347:
#line 2725 "parser.yy"
                                         {
		if (scm_ilength (yyvsp[-2]) < 2) {
			parser->parser_error ((yylsp[-2]), _("bad grob property path"));
			yyval = SCM_UNDEFINED;
		} else {
			yyval = scm_cons (ly_symbol2scm ("push"),
				       scm_cons2 (scm_car (yyvsp[-2]),
						  yyvsp[0],
						  scm_cdr (yyvsp[-2])));
		}
	}
#line 6108 "./out/parser.cc"
    break;

  case 348:
#line 2736 "parser.yy"
                            {
		yyval = scm_cons (ly_symbol2scm ("pop"), yyvsp[0]);
	}
#line 6116 "./out/parser.cc"
    break;

  case 349:
#line 2766 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 6124 "./out/parser.cc"
    break;

  case 350:
#line 2773 "parser.yy"
        {
		if (scm_is_null (yyvsp[0])
		    || scm_is_null (scm_cdr (yyvsp[0])))
			MYBACKUP (SCM_ARG, yyvsp[0], (yylsp[0]));
		else
			MYBACKUP (SYMBOL_LIST, scm_reverse_x (yyvsp[0], SCM_EOL), (yylsp[0]));
	}
#line 6136 "./out/parser.cc"
    break;

  case 352:
#line 2786 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6144 "./out/parser.cc"
    break;

  case 353:
#line 2790 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-2]));
	}
#line 6152 "./out/parser.cc"
    break;

  case 354:
#line 2794 "parser.yy"
        {
		yyval = scm_append_x (scm_list_2 (yyvsp[0], yyvsp[-1]));
	}
#line 6160 "./out/parser.cc"
    break;

  case 355:
#line 2800 "parser.yy"
                 { yyval = ly_symbol2scm ("consists"); }
#line 6166 "./out/parser.cc"
    break;

  case 356:
#line 2801 "parser.yy"
                 { yyval = ly_symbol2scm ("remove"); }
#line 6172 "./out/parser.cc"
    break;

  case 357:
#line 2803 "parser.yy"
                  { yyval = ly_symbol2scm ("accepts"); }
#line 6178 "./out/parser.cc"
    break;

  case 358:
#line 2804 "parser.yy"
                       { yyval = ly_symbol2scm ("default-child"); }
#line 6184 "./out/parser.cc"
    break;

  case 359:
#line 2805 "parser.yy"
                 { yyval = ly_symbol2scm ("denies"); }
#line 6190 "./out/parser.cc"
    break;

  case 360:
#line 2807 "parser.yy"
                { yyval = ly_symbol2scm ("alias"); }
#line 6196 "./out/parser.cc"
    break;

  case 361:
#line 2808 "parser.yy"
               { yyval = ly_symbol2scm ("translator-type"); }
#line 6202 "./out/parser.cc"
    break;

  case 362:
#line 2809 "parser.yy"
                      { yyval = ly_symbol2scm ("description"); }
#line 6208 "./out/parser.cc"
    break;

  case 363:
#line 2810 "parser.yy"
               { yyval = ly_symbol2scm ("context-name"); }
#line 6214 "./out/parser.cc"
    break;

  case 364:
#line 2814 "parser.yy"
                           { yyval = yyvsp[0]; }
#line 6220 "./out/parser.cc"
    break;

  case 365:
#line 2815 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6228 "./out/parser.cc"
    break;

  case 366:
#line 2818 "parser.yy"
                                 {
		yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
	}
#line 6236 "./out/parser.cc"
    break;

  case 367:
#line 2822 "parser.yy"
        {
		if (!scm_is_string (yyvsp[0])
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("consists"))
		    && !scm_is_eq (yyvsp[-1], ly_symbol2scm ("remove")))
		{
			yyval = SCM_EOL;
			parser->parser_error ((yylsp[-1]), _ ("only \\consists and \\remove take non-string argument."));
		}
		else
		{
			yyval = scm_list_2 (yyvsp[-1], yyvsp[0]);
		}
	}
#line 6254 "./out/parser.cc"
    break;

  case 368:
#line 2840 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_pair (l)
		    && to_boolean
		    (scm_object_property (scm_car (l),
					  ly_symbol2scm ("is-grob?"))))
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		if (scm_is_null (l) || scm_is_null (scm_cdr (l))) {
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6272 "./out/parser.cc"
    break;

  case 369:
#line 2858 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[0]) && scm_is_null (scm_cddr (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _ ("bad grob property path"));
			yyval = SCM_UNDEFINED;
		}
	}
#line 6284 "./out/parser.cc"
    break;

  case 370:
#line 2866 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-1])) {
			yyval = scm_append_x (scm_list_2 (yyvsp[-1], yyvsp[0]));
			if (scm_is_null (scm_cddr (yyval))) {
				parser->parser_error ((yyloc), _ ("bad grob property path"));
				yyval = SCM_UNDEFINED;
			}
		}

	}
#line 6299 "./out/parser.cc"
    break;

  case 371:
#line 2881 "parser.yy"
        {
		SCM l = scm_reverse_x (yyvsp[0], SCM_EOL);
		switch (scm_ilength (l)) {
		case 1:
			l = scm_cons (ly_symbol2scm ("Bottom"), l);
		case 2:
			break;
		default:
			parser->parser_error ((yylsp[0]), _ ("bad context property path"));
			l = SCM_UNDEFINED;
		}
		yyval = l;
	}
#line 6317 "./out/parser.cc"
    break;

  case 372:
#line 2913 "parser.yy"
        {
		yyvsp[0] = scm_reverse_x (yyvsp[0], SCM_EOL);
		if (scm_is_null (yyvsp[0])
		    || to_boolean
		    (scm_object_property (scm_car (yyvsp[0]),
					  ly_symbol2scm ("is-grob?")))) {
			yyval = ly_symbol2scm ("Bottom");
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER, yyvsp[0]);
		} else {
			yyval = scm_car (yyvsp[0]);
			parser->lexer_->push_extra_token ((yylsp[0]), SCM_IDENTIFIER,
							  scm_cdr (yyvsp[0]));
		}
	}
#line 6336 "./out/parser.cc"
    break;

  case 373:
#line 2930 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_override, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cdr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6350 "./out/parser.cc"
    break;

  case 374:
#line 2939 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (property_revert, (yyloc), yyvsp[-1], yyvsp[0]);
	}
#line 6358 "./out/parser.cc"
    break;

  case 375:
#line 2942 "parser.yy"
                                           {
		if (SCM_UNBNDP (yyvsp[-2]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_set, (yyloc),
					  scm_car (yyvsp[-2]),
					  scm_cadr (yyvsp[-2]),
					  yyvsp[0]);
	}
#line 6372 "./out/parser.cc"
    break;

  case 376:
#line 2951 "parser.yy"
                                  {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = MAKE_SYNTAX (void_music, (yyloc));
		else
			yyval = MAKE_SYNTAX (property_unset, (yyloc),
					  scm_car (yyvsp[0]),
					  scm_cadr (yyvsp[0]));
	}
#line 6385 "./out/parser.cc"
    break;

  case 383:
#line 2972 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("markup expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6398 "./out/parser.cc"
    break;

  case 386:
#line 2985 "parser.yy"
        {
		if (scm_is_string (yyvsp[0])) {
			yyval = yyvsp[0];
		} else {
			parser->parser_error ((yylsp[0]), (_ ("simple string expected")));
			yyval = scm_string (SCM_EOL);
		}
	}
#line 6411 "./out/parser.cc"
    break;

  case 387:
#line 2996 "parser.yy"
               {
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6419 "./out/parser.cc"
    break;

  case 388:
#line 3000 "parser.yy"
        {
		if (!is_regular_identifier (yyvsp[0], false))
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
		yyval = scm_string_to_symbol (yyvsp[0]);
	}
#line 6429 "./out/parser.cc"
    break;

  case 389:
#line 3006 "parser.yy"
        {
		// This is a bit of overkill but makes the same
		// routine responsible for all symbol interpretations.
		yyval = try_string_variants (Guile_user::symbol_p, yyvsp[0]);
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[0]), (_ ("symbol expected")));
			// Generate a unique symbol in case it is used
			// for an assignment or similar
			yyval = scm_make_symbol (ly_string2scm ("undefined"));
		}
	}
#line 6446 "./out/parser.cc"
    break;

  case 394:
#line 3033 "parser.yy"
        {
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 6454 "./out/parser.cc"
    break;

  case 396:
#line 3038 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6462 "./out/parser.cc"
    break;

  case 397:
#line 3042 "parser.yy"
        {
		yyval = scm_reverse_x (yyvsp[-2], yyvsp[0]);
	}
#line 6470 "./out/parser.cc"
    break;

  case 398:
#line 3048 "parser.yy"
                                   {
		// Let the rhythmic music iterator sort this mess out.
		if (scm_is_pair (yyvsp[0])) {
			unsmob<Music> (yyval)->set_property ("articulations",
							 scm_reverse_x (yyvsp[0], SCM_EOL));
		}
	}
#line 6482 "./out/parser.cc"
    break;

  case 399:
#line 3055 "parser.yy"
                                                                  {
		yyval = MAKE_SYNTAX (repetition_chord, (yyloc),
				  yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6491 "./out/parser.cc"
    break;

  case 400:
#line 3059 "parser.yy"
                                                                    {
		yyval = MAKE_SYNTAX (multi_measure_rest, (yyloc), yyvsp[-1],
				  scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 6500 "./out/parser.cc"
    break;

  case 403:
#line 3070 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[-2]);
		SCM dur = unsmob<Duration> (yyvsp[-1])->smobbed_copy ();
		SCM es = m->get_property ("elements");
		SCM postevs = scm_reverse_x (yyvsp[0], SCM_EOL);

		for (SCM s = es; scm_is_pair (s); s = scm_cdr (s))
		  unsmob<Music> (scm_car (s))->set_property ("duration", dur);
		es = ly_append2 (es, postevs);

		m->set_property ("elements", es);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = m->self_scm ();
	}
#line 6519 "./out/parser.cc"
    break;

  case 404:
#line 3088 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc),
				  reverse_music_list (parser, (yyloc),
						      yyvsp[-1], false, false));
	}
#line 6529 "./out/parser.cc"
    break;

  case 405:
#line 3094 "parser.yy"
        {
		yyval = MAKE_SYNTAX (event_chord, (yyloc), scm_reverse_x (yyvsp[-1], SCM_EOL));
	}
#line 6537 "./out/parser.cc"
    break;

  case 406:
#line 3100 "parser.yy"
                                { yyval = SCM_EOL; }
#line 6543 "./out/parser.cc"
    break;

  case 407:
#line 3101 "parser.yy"
                                                 {
		if (unsmob<Music> (yyvsp[0]))
			yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 6552 "./out/parser.cc"
    break;

  case 408:
#line 3109 "parser.yy"
        {
		bool q = to_boolean (yyvsp[-2]);
		bool ex = to_boolean (yyvsp[-3]);
		SCM check = yyvsp[-1];
		SCM post = yyvsp[0];

		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("pitch", yyvsp[-4]);
		if (q)
			n->set_property ("cautionary", SCM_BOOL_T);
                if (ex || q)
			n->set_property ("force-accidental", SCM_BOOL_T);

		if (scm_is_pair (post)) {
			SCM arts = scm_reverse_x (post, SCM_EOL);
			n->set_property ("articulations", arts);
		}
		if (scm_is_number (check))
		{
			int q = scm_to_int (check);
			n->set_property ("absolute-octave", scm_from_int (q-1));
		}

		yyval = n->unprotect ();
	}
#line 6582 "./out/parser.cc"
    break;

  case 409:
#line 3134 "parser.yy"
                                           {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("drum-type", yyvsp[-1]);

		if (scm_is_pair (yyvsp[0])) {
			SCM arts = scm_reverse_x (yyvsp[0], SCM_EOL);
			n->set_property ("articulations", arts);
		}
		yyval = n->unprotect ();
	}
#line 6597 "./out/parser.cc"
    break;

  case 410:
#line 3145 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);

		if (m && !m->is_mus_type ("post-event")) {
			while (m && m->is_mus_type ("music-wrapper-music")) {
				yyval = m->get_property ("element");
				m = unsmob<Music> (yyval);
			}

			if (!(m && m->is_mus_type ("rhythmic-event"))) {
				parser->parser_error ((yyloc), _ ("not a rhythmic event"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6617 "./out/parser.cc"
    break;

  case 415:
#line 3170 "parser.yy"
                                        {
		yyval = MAKE_SYNTAX (music_function, (yyloc),
				  yyvsp[-1], yyvsp[0]);
	}
#line 6626 "./out/parser.cc"
    break;

  case 416:
#line 3177 "parser.yy"
                    {
		yyval = SCM_EOL;
	}
#line 6634 "./out/parser.cc"
    break;

  case 417:
#line 3180 "parser.yy"
                                 {
		yyval = yyvsp[-1];
		if (Music *m = unsmob<Music> (yyvsp[0]))
		{
			if (m->is_mus_type ("post-event-wrapper"))
			{
				for (SCM p = m->get_property ("elements");
				     scm_is_pair (p);
				     p = scm_cdr (p))
				{
					yyval = scm_cons (scm_car (p), yyval);
				}
			} else {
				m->set_spot (parser->lexer_->override_input ((yylsp[0])));
				yyval = scm_cons (yyvsp[0], yyval);
			}
		}
	}
#line 6657 "./out/parser.cc"
    break;

  case 418:
#line 3201 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 6665 "./out/parser.cc"
    break;

  case 419:
#line 3204 "parser.yy"
                                         {
		Music *m = unsmob<Music> (yyvsp[0]);
		if (!m->is_mus_type ("post-event")) {
			parser->parser_error ((yylsp[0]), _ ("post-event expected"));
			yyval = SCM_UNSPECIFIED;
		} else {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
				m->set_property ("direction", yyvsp[-1]);
			yyval = yyvsp[0];
		}
	}
#line 6682 "./out/parser.cc"
    break;

  case 420:
#line 3216 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("HyphenEvent", (yyloc))->unprotect ();
	}
#line 6692 "./out/parser.cc"
    break;

  case 421:
#line 3221 "parser.yy"
                   {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("have to be in Lyric mode for lyrics"));
		yyval = MY_MAKE_MUSIC ("ExtenderEvent", (yyloc))->unprotect ();
	}
#line 6702 "./out/parser.cc"
    break;

  case 422:
#line 3226 "parser.yy"
                                          {
		if (Music *m = unsmob<Music> (yyvsp[0])) {
			m->set_spot (parser->lexer_->override_input ((yyloc)));
			if (!SCM_UNBNDP (yyvsp[-1]))
			{
				m->set_property ("direction", yyvsp[-1]);
			}
		}
		yyval = yyvsp[0];
	}
#line 6717 "./out/parser.cc"
    break;

  case 423:
#line 3236 "parser.yy"
                                          {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		if (!SCM_UNBNDP (yyvsp[-1]))
			m->set_property ("direction", yyvsp[-1]);
		yyval = yyvsp[0];
	}
#line 6729 "./out/parser.cc"
    break;

  case 424:
#line 3244 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (UP));
		yyval = yyvsp[0];
	}
#line 6740 "./out/parser.cc"
    break;

  case 425:
#line 3251 "parser.yy"
        {
		Music *m = unsmob<Music> (yyvsp[0]);
		m->set_spot (parser->lexer_->override_input ((yyloc)));
		m->set_property ("direction", scm_from_int (DOWN));
		yyval = yyvsp[0];
	}
#line 6751 "./out/parser.cc"
    break;

  case 427:
#line 3261 "parser.yy"
                        {
		unsmob<Music> (yyvsp[0])->set_spot (parser->lexer_->override_input ((yyloc)));
		yyval = yyvsp[0];
	}
#line 6760 "./out/parser.cc"
    break;

  case 428:
#line 3268 "parser.yy"
                   {
		Music *s = MY_MAKE_MUSIC ("StringNumberEvent", (yyloc));
		s->set_property ("string-number", yyvsp[0]);
		yyval = s->unprotect ();
	}
#line 6770 "./out/parser.cc"
    break;

  case 430:
#line 3277 "parser.yy"
                                {
		yyval = yyvsp[0];
	}
#line 6778 "./out/parser.cc"
    break;

  case 431:
#line 3280 "parser.yy"
                        {
               Music *a = MY_MAKE_MUSIC ("TremoloEvent", (yyloc));
               a->set_property ("tremolo-type", yyvsp[0]);
               yyval = a->unprotect ();
        }
#line 6788 "./out/parser.cc"
    break;

  case 433:
#line 3289 "parser.yy"
                     {
		yyval = yyvsp[0];
	}
#line 6796 "./out/parser.cc"
    break;

  case 434:
#line 3292 "parser.yy"
                              {
		SCM s = parser->lexer_->lookup_identifier ("dash" + ly_scm2string (yyvsp[0]));
		if (scm_is_string (s)) {
			Music *a = MY_MAKE_MUSIC ("ArticulationEvent", (yyloc));
			a->set_property ("articulation-type", s);
			yyval = a->unprotect ();
		} else {
			Music *original = unsmob<Music> (s);
			if (original && original->is_mus_type ("post-event")) {
				Music *a = original->clone ();
				// origin will be set by post_event_nofinger
				yyval = a->unprotect ();
			} else {
				parser->parser_error ((yylsp[0]), _ ("expecting string or post-event as script definition"));
				yyval = SCM_UNSPECIFIED;
			}
		}
	}
#line 6819 "./out/parser.cc"
    break;

  case 435:
#line 3313 "parser.yy"
             { yyval = SCM_EOL; }
#line 6825 "./out/parser.cc"
    break;

  case 436:
#line 3314 "parser.yy"
                     { yyval = yyvsp[0]; }
#line 6831 "./out/parser.cc"
    break;

  case 437:
#line 3319 "parser.yy"
        {
                yyval = SCM_INUM0;
        }
#line 6839 "./out/parser.cc"
    break;

  case 440:
#line 3327 "parser.yy"
             {
		yyval = scm_from_int (1);
	}
#line 6847 "./out/parser.cc"
    break;

  case 441:
#line 3330 "parser.yy"
                          {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 6855 "./out/parser.cc"
    break;

  case 442:
#line 3336 "parser.yy"
            {
		yyval = scm_from_int (-1);
	}
#line 6863 "./out/parser.cc"
    break;

  case 443:
#line 3339 "parser.yy"
                         {
		yyval = scm_oneminus (yyvsp[-1]);
	}
#line 6871 "./out/parser.cc"
    break;

  case 444:
#line 3345 "parser.yy"
                              {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6884 "./out/parser.cc"
    break;

  case 445:
#line 3360 "parser.yy"
                               {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6897 "./out/parser.cc"
    break;

  case 447:
#line 3372 "parser.yy"
                                  {
                if (!scm_is_eq (SCM_INUM0, yyvsp[0]))
                {
                        Pitch p = *unsmob<Pitch> (yyvsp[-1]);
                        p = p.transposed (Pitch (scm_to_int (yyvsp[0]), 0));
                        yyval = p.smobbed_copy ();
                }
	}
#line 6910 "./out/parser.cc"
    break;

  case 450:
#line 3388 "parser.yy"
                    {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 6920 "./out/parser.cc"
    break;

  case 451:
#line 3393 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 6931 "./out/parser.cc"
    break;

  case 452:
#line 3399 "parser.yy"
                 {
		// Flag a warning? could be unintentional
		Music *t = MY_MAKE_MUSIC ("TextScriptEvent", (yyloc));
		t->set_property ("text",
			make_simple_markup (yyvsp[0]));
		yyval = t->unprotect ();
	}
#line 6943 "./out/parser.cc"
    break;

  case 453:
#line 3407 "parser.yy"
        {
		// Could be using this for every gen_text_def but for speed
		yyval = MAKE_SYNTAX (create_script, (yylsp[0]), yyvsp[0]);
	}
#line 6952 "./out/parser.cc"
    break;

  case 454:
#line 3414 "parser.yy"
                 {
		Music *t = MY_MAKE_MUSIC ("FingeringEvent", (yyloc));
		t->set_property ("digit", yyvsp[0]);
		yyval = t->unprotect ();
	}
#line 6962 "./out/parser.cc"
    break;

  case 455:
#line 3422 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Hat");
	}
#line 6970 "./out/parser.cc"
    break;

  case 456:
#line 3425 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Plus");
	}
#line 6978 "./out/parser.cc"
    break;

  case 457:
#line 3428 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dash");
	}
#line 6986 "./out/parser.cc"
    break;

  case 458:
#line 3431 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Bang");
	}
#line 6994 "./out/parser.cc"
    break;

  case 459:
#line 3434 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Larger");
	}
#line 7002 "./out/parser.cc"
    break;

  case 460:
#line 3437 "parser.yy"
                        {
		yyval = scm_from_ascii_string ("Dot");
	}
#line 7010 "./out/parser.cc"
    break;

  case 461:
#line 3440 "parser.yy"
              {
		yyval = scm_from_ascii_string ("Underscore");
	}
#line 7018 "./out/parser.cc"
    break;

  case 462:
#line 3446 "parser.yy"
                { yyval = scm_from_int (DOWN); }
#line 7024 "./out/parser.cc"
    break;

  case 463:
#line 3447 "parser.yy"
                { yyval = scm_from_int (UP); }
#line 7030 "./out/parser.cc"
    break;

  case 464:
#line 3448 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7036 "./out/parser.cc"
    break;

  case 465:
#line 3452 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7044 "./out/parser.cc"
    break;

  case 466:
#line 3455 "parser.yy"
                                {
		yyval = yyvsp[0];
		parser->default_duration_ = *unsmob<Duration> (yyval);
	}
#line 7053 "./out/parser.cc"
    break;

  case 467:
#line 3464 "parser.yy"
        {
		if (SCM_UNBNDP (yyval))
			yyval = parser->default_duration_.smobbed_copy ();
	}
#line 7062 "./out/parser.cc"
    break;

  case 468:
#line 3471 "parser.yy"
                                {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
		if (SCM_UNBNDP (yyval))
		{
			parser->parser_error ((yylsp[-1]), _ ("not a duration"));
			yyval = Duration ().smobbed_copy ();
		}
	}
#line 7075 "./out/parser.cc"
    break;

  case 469:
#line 3479 "parser.yy"
                                        {
		yyval = make_duration (yyvsp[-1], scm_to_int (yyvsp[0]));
	}
#line 7083 "./out/parser.cc"
    break;

  case 470:
#line 3485 "parser.yy"
                                   {
		yyval = make_duration (yyvsp[-1], 0, yyvsp[0]);
	}
#line 7091 "./out/parser.cc"
    break;

  case 471:
#line 3491 "parser.yy"
                        {
		yyval = SCM_INUM0;
	}
#line 7099 "./out/parser.cc"
    break;

  case 472:
#line 3494 "parser.yy"
                   {
		yyval = scm_oneplus (yyvsp[-1]);
	}
#line 7107 "./out/parser.cc"
    break;

  case 473:
#line 3501 "parser.yy"
        {
		yyval = SCM_UNDEFINED;
	}
#line 7115 "./out/parser.cc"
    break;

  case 474:
#line 3505 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], yyvsp[0]);
		else
			yyval = yyvsp[0];
	}
#line 7126 "./out/parser.cc"
    break;

  case 475:
#line 3512 "parser.yy"
        {
		if (!SCM_UNBNDP (yyvsp[-2]))
			yyval = scm_product (yyvsp[-2], scm_divide (scm_car (yyvsp[0]),
							  scm_cdr (yyvsp[0])));
		else
			yyval = scm_divide (scm_car (yyvsp[0]), scm_cdr (yyvsp[0]));
	}
#line 7138 "./out/parser.cc"
    break;

  case 476:
#line 3522 "parser.yy"
                {
		yyval = scm_from_int (parser->default_tremolo_type_);
	}
#line 7146 "./out/parser.cc"
    break;

  case 477:
#line 3525 "parser.yy"
                       {
		if (SCM_UNBNDP (make_duration (yyvsp[0]))) {
			parser->parser_error ((yylsp[0]), _ ("not a duration"));
			yyval = scm_from_int (parser->default_tremolo_type_);
		} else {
			yyval = yyvsp[0];
			parser->default_tremolo_type_ = scm_to_int (yyvsp[0]);
		}
	}
#line 7160 "./out/parser.cc"
    break;

  case 482:
#line 3542 "parser.yy"
        {
		// as an integer, it needs to be non-negative, and otherwise
		// it needs to be suitable as a markup.
		if (scm_is_integer (yyvsp[0])
		    ? scm_is_true (scm_negative_p (yyvsp[0]))
		    : !Text_interface::is_markup (yyvsp[0]))
		{
			parser->parser_error ((yylsp[0]), _ ("bass number expected"));
			yyval = SCM_INUM0;
		}
	}
#line 7176 "./out/parser.cc"
    break;

  case 483:
#line 3556 "parser.yy"
                { yyval = ly_rational2scm (FLAT_ALTERATION); }
#line 7182 "./out/parser.cc"
    break;

  case 484:
#line 3557 "parser.yy"
                { yyval = ly_rational2scm (SHARP_ALTERATION); }
#line 7188 "./out/parser.cc"
    break;

  case 485:
#line 3558 "parser.yy"
                { yyval = scm_from_int (0); }
#line 7194 "./out/parser.cc"
    break;

  case 486:
#line 3562 "parser.yy"
                     {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->unprotect ();
	}
#line 7203 "./out/parser.cc"
    break;

  case 487:
#line 3566 "parser.yy"
                       {
		Music *bfr = MY_MAKE_MUSIC ("BassFigureEvent", (yyloc));
		yyval = bfr->self_scm ();

		if (scm_is_number (yyvsp[0]))
			bfr->set_property ("figure", yyvsp[0]);
		else if (Text_interface::is_markup (yyvsp[0]))
			bfr->set_property ("text", yyvsp[0]);

		bfr->unprotect ();
	}
#line 7219 "./out/parser.cc"
    break;

  case 488:
#line 3577 "parser.yy"
                          {
		yyval = yyvsp[-1];
		unsmob<Music> (yyvsp[-1])->set_property ("bracket-stop", SCM_BOOL_T);
	}
#line 7228 "./out/parser.cc"
    break;

  case 489:
#line 3581 "parser.yy"
                                              {
		Music *m = unsmob<Music> (yyvsp[-1]);
		if (scm_to_double (yyvsp[0])) {
			SCM salter = m->get_property ("alteration");
			SCM alter = scm_is_number (salter) ? salter : scm_from_int (0);
			m->set_property ("alteration",
					 scm_sum (alter, yyvsp[0]));
		} else {
			m->set_property ("alteration", scm_from_int (0));
		}
	}
#line 7244 "./out/parser.cc"
    break;

  case 490:
#line 3592 "parser.yy"
                                                 {
		Music *m = unsmob<Music> (yyvsp[-1]);
		m->set_property (yyvsp[0], SCM_BOOL_T);
	}
#line 7253 "./out/parser.cc"
    break;

  case 491:
#line 3600 "parser.yy"
                        {
		yyval = ly_symbol2scm ("augmented");
	}
#line 7261 "./out/parser.cc"
    break;

  case 492:
#line 3603 "parser.yy"
                        {
		yyval = ly_symbol2scm ("no-continuation");
	}
#line 7269 "./out/parser.cc"
    break;

  case 493:
#line 3606 "parser.yy"
                        {
		yyval = ly_symbol2scm ("diminished");
	}
#line 7277 "./out/parser.cc"
    break;

  case 494:
#line 3609 "parser.yy"
                      {
		yyval = ly_symbol2scm ("augmented-slash");
	}
#line 7285 "./out/parser.cc"
    break;

  case 495:
#line 3615 "parser.yy"
                    {
		yyval = yyvsp[0];
	}
#line 7293 "./out/parser.cc"
    break;

  case 496:
#line 3618 "parser.yy"
                          {
		yyval = yyvsp[0];
		unsmob<Music> (yyval)->set_property ("bracket-start", SCM_BOOL_T);
	}
#line 7302 "./out/parser.cc"
    break;

  case 497:
#line 3625 "parser.yy"
                        {
		yyval = SCM_EOL;
	}
#line 7310 "./out/parser.cc"
    break;

  case 498:
#line 3628 "parser.yy"
                                     {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7318 "./out/parser.cc"
    break;

  case 499:
#line 3634 "parser.yy"
               { yyval = SCM_BOOL_F; }
#line 7324 "./out/parser.cc"
    break;

  case 500:
#line 3635 "parser.yy"
               { yyval = SCM_BOOL_T; }
#line 7330 "./out/parser.cc"
    break;

  case 501:
#line 3639 "parser.yy"
                                                                                                    {
		if (!parser->lexer_->is_note_state ())
			parser->parser_error ((yylsp[-6]), _ ("have to be in Note mode for notes"));
		if (!SCM_UNBNDP (yyvsp[-5])
                    || !SCM_UNBNDP (yyvsp[-4])
                    || scm_is_number (yyvsp[-3])
                    || !SCM_UNBNDP (yyvsp[-2])
                    || scm_is_true (yyvsp[-1])
		    || scm_is_pair (yyvsp[0]))
		{
			Music *n = 0;
			if (scm_is_true (yyvsp[-1]))
				n = MY_MAKE_MUSIC ("RestEvent", (yyloc));
			else
				n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));

			n->set_property ("pitch", yyvsp[-6]);
			if (SCM_UNBNDP (yyvsp[-2]))
				n->set_property ("duration",
						 parser->default_duration_.smobbed_copy ());
			else
				n->set_property ("duration", yyvsp[-2]);

			if (scm_is_number (yyvsp[-3]))
			{
				int q = scm_to_int (yyvsp[-3]);
				n->set_property ("absolute-octave", scm_from_int (q-1));
			}

			if (to_boolean (yyvsp[-4]))
				n->set_property ("cautionary", SCM_BOOL_T);
			if (to_boolean (yyvsp[-5]) || to_boolean (yyvsp[-4]))
				n->set_property ("force-accidental", SCM_BOOL_T);
			if (scm_is_pair (yyvsp[0]))
				n->set_property ("articulations",
						 scm_reverse_x (yyvsp[0], SCM_EOL));
			yyval = n->unprotect ();
		}
	}
#line 7374 "./out/parser.cc"
    break;

  case 502:
#line 3678 "parser.yy"
                                {
		if (!parser->lexer_->is_chord_state ())
                        parser->parser_error ((yylsp[-1]), _ ("have to be in Chord mode for chords"));
		if (scm_is_pair (yyvsp[0])) {
			if (unsmob<Pitch> (yyvsp[-1]))
				yyvsp[-1] = make_chord_elements ((yylsp[-1]),
							  yyvsp[-1],
							  parser->default_duration_.smobbed_copy (),
							  SCM_EOL);

			SCM elts = ly_append2 (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));

			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), elts);
		} else if (!unsmob<Pitch> (yyvsp[-1]))
			yyval = MAKE_SYNTAX (event_chord, (yylsp[-1]), yyvsp[-1]);
		// A mere pitch drops through.
	}
#line 7396 "./out/parser.cc"
    break;

  case 503:
#line 3698 "parser.yy"
                                              {
		Music *n = MY_MAKE_MUSIC ("NoteEvent", (yyloc));
		n->set_property ("duration", yyvsp[0]);
		n->set_property ("drum-type", yyvsp[-1]);

		yyval = n->unprotect ();
	}
#line 7408 "./out/parser.cc"
    break;

  case 504:
#line 3705 "parser.yy"
                                                        {
		Music *ev = 0;
 		if (ly_scm2string (yyvsp[-1]) == "s") {
			/* Space */
			ev = MY_MAKE_MUSIC ("SkipEvent", (yyloc));
		  }
		else {
			ev = MY_MAKE_MUSIC ("RestEvent", (yyloc));

		    }
		ev->set_property ("duration", yyvsp[0]);
 		yyval = ev->unprotect ();
	}
#line 7426 "./out/parser.cc"
    break;

  case 505:
#line 3721 "parser.yy"
                    {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("markup outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7436 "./out/parser.cc"
    break;

  case 506:
#line 3726 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _f ("not a note name: %s", ly_scm2string (yyvsp[0])));
		yyval = yyvsp[0];
	}
#line 7446 "./out/parser.cc"
    break;

  case 507:
#line 3731 "parser.yy"
                 {
		if (!parser->lexer_->is_lyric_state ())
			parser->parser_error ((yylsp[0]), _ ("string outside of text script or \\lyricmode"));
		yyval = yyvsp[0];
	}
#line 7456 "./out/parser.cc"
    break;

  case 509:
#line 3740 "parser.yy"
                                                             {
		yyval = MAKE_SYNTAX (lyric_event, (yyloc), yyvsp[-2], yyvsp[-1]);
		if (scm_is_pair (yyvsp[0]))
			unsmob<Music> (yyval)->set_property
				("articulations", scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 7467 "./out/parser.cc"
    break;

  case 510:
#line 3750 "parser.yy"
                                                    {
		if (SCM_UNBNDP (yyvsp[0]))
			yyval = yyvsp[-1];
		else
			yyval = make_chord_elements ((yyloc), yyvsp[-1], yyvsp[0], SCM_EOL);
	}
#line 7478 "./out/parser.cc"
    break;

  case 511:
#line 3756 "parser.yy"
                                                                                   {
		SCM its = scm_reverse_x (yyvsp[0], SCM_EOL);
		yyval = make_chord_elements ((yyloc), yyvsp[-3], yyvsp[-2], scm_cons (yyvsp[-1], its));
	}
#line 7487 "./out/parser.cc"
    break;

  case 512:
#line 3763 "parser.yy"
             {
		yyval = SCM_EOL;
	}
#line 7495 "./out/parser.cc"
    break;

  case 513:
#line 3766 "parser.yy"
                                 {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7503 "./out/parser.cc"
    break;

  case 514:
#line 3772 "parser.yy"
                    {
		yyval = ly_symbol2scm ("chord-colon");
	}
#line 7511 "./out/parser.cc"
    break;

  case 515:
#line 3775 "parser.yy"
                      {
		yyval = ly_symbol2scm ("chord-caret");
	}
#line 7519 "./out/parser.cc"
    break;

  case 516:
#line 3778 "parser.yy"
                                        {
 		yyval = scm_list_2 (ly_symbol2scm ("chord-slash"), yyvsp[0]);
	}
#line 7527 "./out/parser.cc"
    break;

  case 517:
#line 3781 "parser.yy"
                                       {
		yyval = scm_list_2 (ly_symbol2scm ("chord-bass"), yyvsp[0]);
	}
#line 7535 "./out/parser.cc"
    break;

  case 518:
#line 3787 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7543 "./out/parser.cc"
    break;

  case 519:
#line 3790 "parser.yy"
                       {
		yyval = scm_reverse_x (yyvsp[0], SCM_EOL);
	}
#line 7551 "./out/parser.cc"
    break;

  case 520:
#line 3793 "parser.yy"
                          {
		yyval = yyvsp[0];
	}
#line 7559 "./out/parser.cc"
    break;

  case 521:
#line 3799 "parser.yy"
                    { yyval = scm_cons (yyvsp[0], SCM_EOL); }
#line 7565 "./out/parser.cc"
    break;

  case 522:
#line 3800 "parser.yy"
                                       {
		yyval = scm_cons (yyvsp[0], yyval);
	}
#line 7573 "./out/parser.cc"
    break;

  case 523:
#line 3806 "parser.yy"
                 {
		yyval = make_chord_step (yyvsp[0], 0);
        }
#line 7581 "./out/parser.cc"
    break;

  case 524:
#line 3809 "parser.yy"
                       {
		yyval = make_chord_step (yyvsp[-1], SHARP_ALTERATION);
	}
#line 7589 "./out/parser.cc"
    break;

  case 525:
#line 3812 "parser.yy"
                               {
		yyval = make_chord_step (yyvsp[-1], FLAT_ALTERATION);
	}
#line 7597 "./out/parser.cc"
    break;

  case 526:
#line 3818 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 7605 "./out/parser.cc"
    break;

  case 527:
#line 3821 "parser.yy"
                                              {
		yyval = scm_cons (yyvsp[-2], yyvsp[0]);
	}
#line 7613 "./out/parser.cc"
    break;

  case 528:
#line 3833 "parser.yy"
                                          {
		yyval = scm_sum (yyvsp[-2], yyvsp[0]);
	}
#line 7621 "./out/parser.cc"
    break;

  case 529:
#line 3836 "parser.yy"
                                            {
		yyval = scm_difference (yyvsp[-2], yyvsp[0]);
	}
#line 7629 "./out/parser.cc"
    break;

  case 531:
#line 3843 "parser.yy"
                      {
		yyval = yyvsp[0];
	}
#line 7637 "./out/parser.cc"
    break;

  case 532:
#line 3846 "parser.yy"
                                          {
		yyval = scm_product (yyvsp[-2], yyvsp[0]);
	}
#line 7645 "./out/parser.cc"
    break;

  case 533:
#line 3849 "parser.yy"
                                          {
		yyval = scm_divide (yyvsp[-2], yyvsp[0]);
	}
#line 7653 "./out/parser.cc"
    break;

  case 534:
#line 3855 "parser.yy"
                           { /* %prec UNARY_MINUS */
		yyval = scm_difference (yyvsp[0], SCM_UNDEFINED);
	}
#line 7661 "./out/parser.cc"
    break;

  case 538:
#line 3865 "parser.yy"
        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7669 "./out/parser.cc"
    break;

  case 541:
#line 3873 "parser.yy"
                                        {
		yyval = scm_product (yyvsp[-1], yyvsp[0]);
	}
#line 7677 "./out/parser.cc"
    break;

  case 543:
#line 3881 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7690 "./out/parser.cc"
    break;

  case 544:
#line 3890 "parser.yy"
        {
		if (!scm_is_integer (yyvsp[0])
		    || scm_is_true (scm_negative_p (yyvsp[0])))
		{
			parser->parser_error ((yylsp[0]), _("not an unsigned integer"));
			yyval = SCM_INUM0;
		}
	}
#line 7703 "./out/parser.cc"
    break;

  case 545:
#line 3901 "parser.yy"
                { yyval = SCM_UNDEFINED; }
#line 7709 "./out/parser.cc"
    break;

  case 546:
#line 3903 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7720 "./out/parser.cc"
    break;

  case 547:
#line 3918 "parser.yy"
        { yyval = SCM_UNDEFINED; }
#line 7726 "./out/parser.cc"
    break;

  case 548:
#line 3920 "parser.yy"
        {
                if (SCM_UNBNDP (yyvsp[-1]))
                        yyval = SCM_BOOL_T;
                else
                        yyval = scm_not (yyvsp[-1]);
        }
#line 7737 "./out/parser.cc"
    break;

  case 549:
#line 3930 "parser.yy"
                { parser->lexer_->push_markup_state (); }
#line 7743 "./out/parser.cc"
    break;

  case 550:
#line 3931 "parser.yy"
                    {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7752 "./out/parser.cc"
    break;

  case 551:
#line 3939 "parser.yy"
        {
		parser->lexer_->push_markup_state ();
	}
#line 7760 "./out/parser.cc"
    break;

  case 552:
#line 3955 "parser.yy"
        {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7769 "./out/parser.cc"
    break;

  case 553:
#line 3963 "parser.yy"
                               {
		yyval = yyvsp[0];
		parser->lexer_->pop_state ();
	}
#line 7778 "./out/parser.cc"
    break;

  case 554:
#line 3968 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 7786 "./out/parser.cc"
    break;

  case 555:
#line 3975 "parser.yy"
        {
		yyval = MAKE_SYNTAX (partial_markup, (yylsp[-1]), yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 7795 "./out/parser.cc"
    break;

  case 556:
#line 3982 "parser.yy"
                    {
		yyval = scm_list_2 (Lily::line_markup,  yyvsp[0]);
	}
#line 7803 "./out/parser.cc"
    break;

  case 557:
#line 3986 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 7812 "./out/parser.cc"
    break;

  case 558:
#line 3990 "parser.yy"
                               {
		yyval = yyvsp[0];
	}
#line 7820 "./out/parser.cc"
    break;

  case 559:
#line 3997 "parser.yy"
        {
		if (Text_interface::is_markup (yyvsp[0]))
			MYBACKUP (MARKUP_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else if (Text_interface::is_markup_list (yyvsp[0]))
			MYBACKUP (MARKUPLIST_IDENTIFIER, yyvsp[0], (yylsp[0]));
		else {
			parser->parser_error ((yylsp[0]), _ ("not a markup"));
			MYBACKUP (MARKUP_IDENTIFIER, scm_string (SCM_EOL), (yylsp[0]));
		}
	}
#line 7835 "./out/parser.cc"
    break;

  case 561:
#line 4011 "parser.yy"
                             {
		yyval = yyvsp[0];
	}
#line 7843 "./out/parser.cc"
    break;

  case 563:
#line 4018 "parser.yy"
                           {
		yyval = yyvsp[0];
	}
#line 7851 "./out/parser.cc"
    break;

  case 564:
#line 4021 "parser.yy"
                              {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 7859 "./out/parser.cc"
    break;

  case 565:
#line 4025 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 7867 "./out/parser.cc"
    break;

  case 566:
#line 4028 "parser.yy"
                     {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 7875 "./out/parser.cc"
    break;

  case 567:
#line 4030 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_1 (scm_list_2 (Lily::score_lines_markup_list, yyvsp[-1]));
		parser->lexer_->pop_state ();
	}
#line 7891 "./out/parser.cc"
    break;

  case 568:
#line 4044 "parser.yy"
                                                  {
		yyval = MAKE_SYNTAX (composed_markup_list,
				  (yylsp[0]), yyvsp[-1], yyvsp[0]);
	}
#line 7900 "./out/parser.cc"
    break;

  case 569:
#line 4051 "parser.yy"
                                        {
		yyval = scm_reverse_x (yyvsp[-1], SCM_EOL);
	}
#line 7908 "./out/parser.cc"
    break;

  case 570:
#line 4057 "parser.yy"
                        {  yyval = SCM_EOL; }
#line 7914 "./out/parser.cc"
    break;

  case 571:
#line 4058 "parser.yy"
                                         {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7922 "./out/parser.cc"
    break;

  case 572:
#line 4061 "parser.yy"
                                              {
		yyval = scm_reverse_x (yyvsp[0], yyvsp[-1]);
	}
#line 7930 "./out/parser.cc"
    break;

  case 573:
#line 4067 "parser.yy"
                                                           {
	  yyval = scm_cons (yyvsp[-1], scm_reverse_x(yyvsp[0], SCM_EOL));
	}
#line 7938 "./out/parser.cc"
    break;

  case 574:
#line 4073 "parser.yy"
                                                                     {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7946 "./out/parser.cc"
    break;

  case 575:
#line 4076 "parser.yy"
                                                                {
	  yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 7954 "./out/parser.cc"
    break;

  case 576:
#line 4079 "parser.yy"
                                                          {
		yyval = check_scheme_arg (parser, (yylsp[0]), yyvsp[0], yyvsp[-1], yyvsp[-2]);
	}
#line 7962 "./out/parser.cc"
    break;

  case 577:
#line 4082 "parser.yy"
                              {
	  yyval = SCM_EOL;
	}
#line 7970 "./out/parser.cc"
    break;

  case 578:
#line 4088 "parser.yy"
                                       { yyval = yyvsp[0]; }
#line 7976 "./out/parser.cc"
    break;

  case 579:
#line 4089 "parser.yy"
                                                             {
	  yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 7984 "./out/parser.cc"
    break;

  case 580:
#line 4096 "parser.yy"
        {
		yyval = scm_list_1 (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)));
	}
#line 7992 "./out/parser.cc"
    break;

  case 581:
#line 4100 "parser.yy"
        {
		yyval = scm_cons (scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL)),
			       yyvsp[-2]);
	}
#line 8001 "./out/parser.cc"
    break;

  case 582:
#line 4108 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8009 "./out/parser.cc"
    break;

  case 583:
#line 4112 "parser.yy"
        {
		yyval= yyvsp[0];
	}
#line 8017 "./out/parser.cc"
    break;

  case 584:
#line 4116 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8025 "./out/parser.cc"
    break;

  case 585:
#line 4120 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8033 "./out/parser.cc"
    break;

  case 586:
#line 4126 "parser.yy"
                                                                    {
	  yyval = scm_cons (yyvsp[-2], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8041 "./out/parser.cc"
    break;

  case 587:
#line 4132 "parser.yy"
                                {
		yyval = scm_list_1 (yyvsp[0]);
	}
#line 8049 "./out/parser.cc"
    break;

  case 588:
#line 4135 "parser.yy"
                                                {
		yyval = scm_cons (yyvsp[0], yyvsp[-1]);
	}
#line 8057 "./out/parser.cc"
    break;

  case 591:
#line 4147 "parser.yy"
        {
		yyval = make_simple_markup (yyvsp[0]);
	}
#line 8065 "./out/parser.cc"
    break;

  case 593:
#line 4154 "parser.yy"
              {
		parser->lexer_->push_note_state (Lily::pitchnames);
	}
#line 8073 "./out/parser.cc"
    break;

  case 594:
#line 4156 "parser.yy"
                             {
		Score *sc = unsmob<Score> (yyvsp[-1]);
		sc->origin ()->set_spot ((yyloc));
		if (sc->defs_.empty ()) {
			Output_def *od = get_layout (parser);
			sc->add_output_def (od);
			od->unprotect ();
		}
		yyval = scm_list_2 (Lily::score_markup, yyvsp[-1]);
		parser->lexer_->pop_state ();
	}
#line 8089 "./out/parser.cc"
    break;

  case 595:
#line 4167 "parser.yy"
                                                         {
		yyval = scm_cons (yyvsp[-1], scm_reverse_x (yyvsp[0], SCM_EOL));
	}
#line 8097 "./out/parser.cc"
    break;

  case 596:
#line 4171 "parser.yy"
        {
		yyval = yyvsp[0];
	}
#line 8105 "./out/parser.cc"
    break;

  case 597:
#line 4178 "parser.yy"
        {
		yyval = scm_car (MAKE_SYNTAX (composed_markup_list,
					   (yylsp[0]), yyvsp[-1], scm_list_1 (yyvsp[0])));
	}
#line 8114 "./out/parser.cc"
    break;

  case 598:
#line 4182 "parser.yy"
                        {
		yyval = yyvsp[0];
	}
#line 8122 "./out/parser.cc"
    break;


#line 8126 "./out/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (&yylloc, parser, retval, YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *, YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (&yylloc, parser, retval, yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }

  yyerror_range[1] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, &yylloc, parser, retval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;

      yyerror_range[1] = *yylsp;
      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  yyerror_range[2] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, yyerror_range, 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;


#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (&yylloc, parser, retval, YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif


/*-----------------------------------------------------.
| yyreturn -- parsing is finished, return the result.  |
`-----------------------------------------------------*/
yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, &yylloc, parser, retval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp, yylsp, parser, retval);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 4187 "parser.yy"


void
Lily_parser::set_yydebug (bool x)
{
	yydebug = x;
}

SCM
Lily_parser::do_yyparse ()
{
	return scm_c_with_fluid (Lily::f_parser,
				 self_scm (),
				 do_yyparse_trampoline,
				 static_cast <void *>(this));
}

SCM
Lily_parser::do_yyparse_trampoline (void *parser)
{
	SCM retval = SCM_UNDEFINED;
	yyparse (static_cast <Lily_parser *>(parser), &retval);
	return retval;
}



/*

It is a little strange to have this function in this file, but
otherwise, we have to import music classes into the lexer.

*/
int
Lily_lexer::try_special_identifiers (SCM *destination, SCM sid)
{
	if (unsmob<Book> (sid)) {
		Book *book =  unsmob<Book> (sid)->clone ();
		*destination = book->self_scm ();
		book->unprotect ();

		return BOOK_IDENTIFIER;
	} else if (scm_is_number (sid)) {
		*destination = sid;
		return NUMBER_IDENTIFIER;
	} else if (unsmob<Context_def> (sid))
	{
		*destination = unsmob<Context_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
        } else if (unsmob<Context_mod> (sid)) {
                *destination = unsmob<Context_mod> (sid)->smobbed_copy ();
                return SCM_IDENTIFIER;
	} else if (Music *mus = unsmob<Music> (sid)) {
		mus = mus->clone ();
		*destination = mus->self_scm ();
		bool is_event = mus->is_mus_type ("post-event");
		mus->unprotect ();
		return is_event ? EVENT_IDENTIFIER : MUSIC_IDENTIFIER;
	} else if (unsmob<Pitch> (sid)) {
		*destination = unsmob<Pitch> (sid)->smobbed_copy ();
		return PITCH_IDENTIFIER;
	} else if (unsmob<Duration> (sid)) {
		*destination = unsmob<Duration> (sid)->smobbed_copy ();
		return DURATION_IDENTIFIER;
	} else if (unsmob<Output_def> (sid)) {
		*destination = unsmob<Output_def> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (unsmob<Score> (sid)) {
		*destination = unsmob<Score> (sid)->clone ()->unprotect ();
		return SCM_IDENTIFIER;
	} else if (scm_is_pair (sid)
		   && scm_is_pair (scm_car (sid))
		   && scm_is_true (Lily::key_p (scm_caar (sid)))) {
		*destination = sid;
		return LOOKUP_IDENTIFIER;
	}
	return -1;
}

SCM
get_next_unique_context_id ()
{
	return scm_from_ascii_string ("$uniqueContextId");
}


SCM
get_next_unique_lyrics_context_id ()
{
	static int new_context_count;
	char s[128];
	snprintf (s, sizeof (s)-1, "uniqueContext%d", new_context_count++);
	return scm_from_ascii_string (s);
}

// check_scheme_arg checks one argument with a given predicate for use
// in an argument list and throws a syntax error if it is unusable.
// The argument is prepended to the argument list in any case.  After
// throwing a syntax error, the argument list is terminated with #f as
// its last cdr in order to mark it as uncallable while not losing
// track of its total length.
//
// There are a few special considerations: if optional argument disp
// is given (otherwise it defaults to SCM_UNDEFINED), it will be used
// instead of arg in a prospective error message.  This is useful if
// arg is not the actual argument but rather a transformation of it.
//
// If arg itself is SCM_UNDEFINED, the predicate is considered false
// and an error message using disp is produced unconditionally.

SCM check_scheme_arg (Lily_parser *parser, Input loc,
		      SCM arg, SCM args, SCM pred, SCM disp)
{
	if (SCM_UNBNDP (arg))
		args = scm_cons (disp, args);
	else {
		args = scm_cons (arg, args);
		if (scm_is_true (scm_call_1 (pred, arg)))
			return args;
	}
	scm_set_cdr_x (scm_last_pair (args), SCM_EOL);
	MAKE_SYNTAX (argument_error, loc, scm_length (args), pred,
		     SCM_UNBNDP (disp) ? arg : disp);
	scm_set_cdr_x (scm_last_pair (args), SCM_BOOL_F);
	return args;
}

SCM loc_on_copy (Lily_parser *parser, Input loc, SCM arg)
{
	if (Music *m = unsmob<Music> (arg))
	{
		m = m->clone ();
		m->set_spot (parser->lexer_->override_input (loc));
		return m->unprotect ();
	}
	if (Book *b = unsmob<Book> (arg))
	{
		b = b->clone ();
		b->origin ()->set_spot (parser->lexer_->override_input (loc));
		return b->unprotect ();
	}
	if (Context_def *cd = unsmob<Context_def> (arg))
	{
		cd = cd->clone ();
		cd->origin ()->set_spot (parser->lexer_->override_input (loc));
		return cd->unprotect ();
	}
	if (Output_def *od = unsmob<Output_def> (arg))
	{
		od = od->clone ();
		od->input_origin_ = parser->lexer_->override_input (loc);
		return od->unprotect ();
	}
	if (Score *s = unsmob<Score> (arg))
	{
		s = s->clone ();
		s->origin ()->set_spot (parser->lexer_->override_input (loc));
		return s->unprotect ();
	}
	if (Context_mod *cm = unsmob<Context_mod> (arg))
	{
		return cm->smobbed_copy ();
	}
	return arg;
}

SCM
make_reverse_key_list (SCM keys)
{
	if (scm_is_true (Lily::key_p (keys)))
		return scm_list_1 (keys);
	if (scm_is_string (keys))
		return scm_list_1 (scm_string_to_symbol (keys));
	if (!ly_is_list (keys))
		return SCM_UNDEFINED;
	SCM res = SCM_EOL;
	for (; scm_is_pair (keys); keys = scm_cdr (keys))
	{
		SCM elt = scm_car (keys);
		if (scm_is_true (Lily::key_p (elt)))
			res = scm_cons (elt, res);
		else if (scm_is_string (elt))
			res = scm_cons (scm_string_to_symbol (elt), res);
		else return SCM_UNDEFINED;
	}
	return res;
}

SCM
try_string_variants (SCM pred, SCM str)
{
	// a matching predicate is always ok
	if (scm_is_true (scm_call_1 (pred, str)))
		return str;
	// a key may be interpreted as a list of keys if it helps
	if (scm_is_true (Lily::key_p (str))) {
		str = scm_list_1 (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
		return SCM_UNDEFINED;
	}

	if (!scm_is_string (str))
		return SCM_UNDEFINED;

	// Let's attempt the symbol list interpretation first.

	str = scm_string_to_symbol (str);

	SCM lst = scm_list_1 (str);

	if (scm_is_true (scm_call_1 (pred, lst)))
		return lst;

	// Try the single symbol interpretation

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	return SCM_UNDEFINED;
}

SCM
try_word_variants (SCM pred, SCM str)
{
	// str is always a string when we come here

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If this cannot be a string representation of a symbol list,
	// we are through.

	if (!is_regular_identifier (str, true))
		return SCM_UNDEFINED;

	str = scm_string_split (str, SCM_MAKE_CHAR ('.'));
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_split (scm_car (p),
						    SCM_MAKE_CHAR (',')));
	str = scm_append_x (str);
	for (SCM p = str; scm_is_pair (p); p = scm_cdr (p))
		scm_set_car_x (p, scm_string_to_symbol (scm_car (p)));

	// Let's attempt the symbol list interpretation first.

	if (scm_is_true (scm_call_1 (pred, str)))
		return str;

	// If there is just one symbol in the list, we might interpret
	// it as a single symbol

	if (scm_is_null (scm_cdr (str)))
	{
		str = scm_car (str);
		if (scm_is_true (scm_call_1 (pred, str)))
			return str;
	}

	return SCM_UNDEFINED;
}

bool
is_regular_identifier (SCM id, bool multiple)
{
  if (!scm_is_string (id))
	  return false;

  string str = ly_scm2string (id);

  bool middle = false;

  for (string::iterator it=str.begin(); it != str.end (); it++)
  {
	  int c = *it & 0xff;
	  if ((c >= 'a' && c <= 'z')
	      || (c >= 'A' && c <= 'Z')
	      || c > 0x7f)
		  middle = true;
	  else if (middle && (c == '-' || c == '_' || (multiple &&
						       (c == '.' || c == ','))))
		  middle = false;
	  else
		  return false;
  }
  return middle;
}

SCM
make_music_from_simple (Lily_parser *parser, Input loc, SCM simple)
{
	if (unsmob<Music> (simple))
		return simple;

	if (scm_is_symbol (simple))
	{
		SCM out = SCM_UNDEFINED;
		switch (parser->lexer_->scan_word (out, simple))
		{
		case DRUM_PITCH:
		{
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("drum-type", out);
			return n->unprotect ();
		}
		case NOTENAME_PITCH:
		case TONICNAME_PITCH:
			// Take the parsed pitch
			simple = out;
			break;
		// Don't scan CHORD_MODIFIER etc.
		}
	}

	if (parser->lexer_->is_note_state ()) {
		if (unsmob<Pitch> (simple)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", parser->default_duration_.smobbed_copy ());
			n->set_property ("pitch", simple);
			return n->unprotect ();
		}
		SCM d = simple;
		if (scm_is_integer (simple))
			d = make_duration (simple);
		if (unsmob<Duration> (d)) {
			Music *n = MY_MAKE_MUSIC ("NoteEvent", loc);
			n->set_property ("duration", d);
			return n->unprotect ();
		}
		return simple;
	} else if (parser->lexer_->is_lyric_state ()) {
		if (Text_interface::is_markup (simple))
			return MAKE_SYNTAX (lyric_event, loc, simple,
					    parser->default_duration_.smobbed_copy ());
	} else if (parser->lexer_->is_chord_state ()) {
		if (unsmob<Pitch> (simple))
			return MAKE_SYNTAX
				(event_chord,
				 loc,
				 make_chord_elements (loc, simple,
						      parser->default_duration_.smobbed_copy (),
						      SCM_EOL));
	}
	return simple;
}

Music *
make_music_with_input (SCM name, Input where)
{
       Music *m = make_music_by_name (name);
       m->set_spot (where);
       return m;
}

SCM
make_simple_markup (SCM a)
{
	return a;
}

SCM
make_duration (SCM d, int dots, SCM factor)
{
	Duration k;

	if (Duration *dur = unsmob<Duration> (d)) {
		if (!dots && SCM_UNBNDP (factor))
			return d;
		k = *dur;
		if (dots)
			k = Duration (k.duration_log (), k.dot_count () + dots)
				.compressed (k.factor ());
	} else {
		int t = scm_to_int (d);
		if (t > 0 && (t & (t-1)) == 0)
			k = Duration (intlog2 (t), dots);
		else
			return SCM_UNDEFINED;
	}

	if (!SCM_UNBNDP (factor))
		k = k.compressed (ly_scm2rational (factor));

	return k.smobbed_copy ();
}

SCM
make_chord_step (SCM step_scm, Rational alter)
{
	Pitch m (0, scm_to_int (step_scm) - 1, alter);

	// Notename/octave are normalized
	if (m.get_notename () == 6)
		m = m.transposed (Pitch (0, 0, FLAT_ALTERATION));

	return m.smobbed_copy ();
}


SCM
make_chord_elements (Input loc, SCM pitch, SCM dur, SCM modification_list)
{
	SCM res = Lily::construct_chord_elements (pitch, dur, modification_list);
	for (SCM s = res; scm_is_pair (s); s = scm_cdr (s))
	{
		unsmob<Music> (scm_car (s))->set_spot (loc);
	}
	return res;
}

// Return true if there are post events unaccounted for
bool
add_post_events (Music *m, SCM events)
{
	if (!scm_is_pair (events))
		return false;	// successfully added -- nothing

	while (m) {
		if (m->is_mus_type ("rhythmic-event")) {
			m->set_property
				("articulations",
				 scm_append_x (scm_list_2
					       (m->get_property ("articulations"),
						events)));
			return false;
		}
		if (m->is_mus_type ("event-chord")) {
			m->set_property
				("elements",
				 scm_append_x (scm_list_2
					       (m->get_property ("elements"),
						events)));
			return false;
		}
		if (m->is_mus_type ("sequential-music")) {
			SCM lp = scm_last_pair (m->get_property ("elements"));
			if (scm_is_pair (lp)) {
				m = unsmob<Music> (scm_car (lp));
				continue;
			}
			return true;
		}
		if (m->is_mus_type ("music-wrapper-music")
		    || m->is_mus_type ("time-scaled-music")) {
			m = unsmob<Music> (m->get_property ("element"));
			continue;
		}
		break;
	}
	return true;
}

// Returns either a list or a post-event
//
// If PRESERVE is true, unattachable post-events are not thrown away
// but rather added attached to empty chords.  If COMPRESS is true, a
// sequence consisting only of post-events may be returned as a single
// post-event.
SCM reverse_music_list (Lily_parser *parser, Input loc, SCM lst, bool preserve, bool compress)
{
	SCM res = SCM_EOL;	// Resulting reversed list
	SCM bad = SCM_EOL;	// Bad post events
	SCM post = SCM_EOL;	// current unattached events
	for (; scm_is_pair (lst); lst = scm_cdr (lst)) {
		SCM elt = scm_car (lst);
		Music *m = unsmob<Music> (elt);
		assert (m);
		if (m->is_mus_type ("post-event")) {
			post = scm_cons (elt, post);
			continue;
		}
		if (add_post_events (m, post)) {
			bad = scm_cons (scm_car (post), bad);
			if (preserve) {
				Music *p = unsmob<Music> (scm_car (post));
				res = scm_cons (MAKE_SYNTAX (event_chord,
							     *p->origin (),
							     post),
						res);
			}
		}
		post = SCM_EOL;
		res = scm_cons (elt, res);
	}
	if (scm_is_pair (post)) {
		if (scm_is_null (res) && compress) { // pure postevent list
			if (scm_is_null (scm_cdr (post)))
				return scm_car (post);
			Music *m = MY_MAKE_MUSIC ("PostEvents", loc);
			m->set_property ("elements", post);
			return m->unprotect ();
		}
		bad = ly_append2 (post, bad);
		if (preserve) {
			Music *p = unsmob<Music> (scm_car (post));
			res = scm_cons (MAKE_SYNTAX (event_chord,
						     *p->origin (),
						     post),
					res);
		}
	}
	for (; scm_is_pair (bad); bad = scm_cdr (bad))
	{
		Music *what = unsmob<Music> (scm_car (bad));
		if (preserve)
			what->origin ()->warning (_f ("Unattached %s",
						      what->name ()));
		else
			what->origin ()->warning (_f ("Dropping unattachable %s",
						      what->name ()));
	}
	return res;
}


int
yylex (YYSTYPE *s, YYLTYPE *loc, Lily_parser *parser)
{
	Lily_lexer *lex = parser->lexer_;

	lex->lexval_ = s;
	lex->lexloc_ = loc;
	int tok = lex->pop_extra_token ();
	if (tok >= 0)
		return tok;
	lex->prepare_for_next_token ();
	return lex->yylex ();
}
